<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	// Loading libraries
	LoadLib (
		'categories',
		'users',
		'format.lib.php',
		'blog'
	);

	// Setting URL Prototype and extracting variables to current scheme
	Extract (
		URLGetArgs('null/null/action=alpha?page=page&id=int')
	);

	switch ($action) {
		case 'edit':
			if ($id) {

				// creating a new block
				$tpl = new ContentBlock();

				$tpl->insert('BLOCK_CONTENT', 'blog/admin.edit.tpl');

				// main query
				$q = $db->query("
					SELECT
						id, author_id, category_id, icon, title, content, footer, date_created,
						status, allow_comments
					FROM ".db_table("blog")." WHERE id = '{$id}'
				");

				if ($db->numRows($q)) {

					// fetching and sanitising data
					$row = $db->fetchRow($q);

					saneHTML($row, "content");
					format::htmlFilter($row["content"], $row["author_id"]);

					$tpl->setArray($row);

					$actions = new tplButtonBox();
						$actions->add(mklink("index.php/module=admin/base=blog", _l("L_BLOG_ENTRIES"), "blog.png"));
						$actions->add(mklink("index.php/module=admin/base=blog/action=create", _l("L_COMPOSE"), "new.png"));
						$actions->add(mklink("modules/blog/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}&return=".urlencode("index.php/module=admin/base=blog")."", _l("L_DELETE"), "delete.png", true));
					$actions = $actions->make();

					$tpl->setArray (
						Array (
							"BLOCK_TITLE"			=> _l("L_BLOG"),
							"BLOCK_ICON"			=> mkIcon("blog.png", 16),
							"ACTION"				=> "edit",
							"ACTIONS"				=> $actions
						)
					);

					$mcBuff = $tpl->make();
				}
			}
		break;
		case "create":

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "blog/admin.create.tpl");

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=blog", _l("L_BLOG_ENTRIES"), "blog.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_BLOG"),
					"BLOCK_ICON"		=> mkIcon("blog.png", 16),
					"ICON"				=> "blog.png",
					"STATUS"			=> 1,
					"CATEGORY_ID"		=> conf::getkey("blog", "last_selected_category", 0, "i"),
					"ACTION"			=> "create",
					"ALLOW_COMMENTS"	=> 1,
					"TITLE"				=> "",
					"CONTENT"			=> "",
					"FOOTER"			=> "",
					"ID"				=> 0,
					"RETURN"			=> "index.php/module=admin/base=blog",
					"TAGS"				=> "",
					"ACTIONS"			=> $actions
				)
			);

			$mcBuff = $tpl->make();
		break;
		default:

			// creating a content block
			$tpl = new ContentBlock();

			// inserting templates in that content block
			$tpl->insert("BLOCK_CONTENT", "blog/admin.default.tpl");

			// creating a pager
			$pager = $db->pager (
				"SELECT id FROM ".db_table("blog")."
				WHERE ".db_languagelock()."",
				"index.php/module=admin/admin=blog?page=%p", $page,
				conf::getkey("blog", "items_per_admin_page")
			);

			// querying items for specified $page
			$q = $db->query ("
				SELECT
				id, author_id, category_id, icon, title, content, date_created, status
				FROM ".db_table("blog")."
				WHERE ".db_languagelock()."
				ORDER BY status ASC, date_created DESC {$pager['sql']}
			", __FILE__, __LINE__);


			while ($row = $db->fetchRow($q)) {

				// sanitizing all variables but 'content', it should be
				// cleaned using another function
				saneHTML ($row, 'content');

				$row["title"] = $row['status'] ? $row['title'] : $row['title'].' ('._L('L_DRAFT').')';

				$row["ACTIONS"] = new tplButtonBox();
				$row["ACTIONS"]->add (
					mkLink("index.php/module=admin/base=blog/action=edit?id={$row['id']}", _L('L_EDIT'), "edit.png"),
					mkLink("modules/blog/main.act.php?action=delete&id={$row['id']}&auth="._L('C_AUTH_STR'), _l("L_DELETE"), "delete.png", true)
				);

				if (!$row["status"])
					$row["ACTIONS"]->add(mkLink("modules/blog/main.act.php?action=publish&id={$row['id']}&auth="._L("C_AUTH_STR"), _L("L_PUBLISH")));

				$row["ACTIONS"] = $row["ACTIONS"]->make();

				$tpl->setArray ($row, "ENTRY");

				// saving 'entry' sub-block
				$tpl->saveBlock("ENTRY");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=blog/action=create", _l("L_COMPOSE"), "new.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_BLOG"),
					"BLOCK_ICON"		=> mkIcon("blog.png", 16),
					"ACTIONS"			=> $actions,
					"PAGER"				=> $pager["html"]
				)
			);

			// main block compilation
			$mcBuff = $tpl->make();
		break;
	}
?>