<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title>Archive</title>
			<description>Displays blog entries for the last year, viewed by month.</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
	</blockscript>
	<%%>
	*/

	LoadLib('categories');

	// events counter
	$events = Array();

	// SQL category lock
	$categorylock = categories::db_categorylock("category_id");

	// querying blog entries for the last year
	$q = $GLOBALS["db"]->query("SELECT id, title, date_created
	FROM ".db_table("blog")."
	WHERE ".db_languagelock()." AND {$categorylock}
	AND status = '1' AND date_created >= '".(date("Y")-1)."-".date("m")."-".date("d")." 00:00:00'
	ORDER BY date_created DESC",
	__FILE__, __LINE__, true);

	while ($row = $GLOBALS["db"]->fetchRow($q)) {
		saneHTML($row);
		preg_match("/(\d*-\d*).*/", $row["date_created"], $month);
		$month = $month[1];
		
		// adding event to $month index
		$events[$month] = isset($events[$month]) ? $events[$month]+1 : 1;
	}

	$last_year = false;
	foreach ($events as $month => $counter) {
		list($year, $month) = explode("-", $month);
		// checking for year change
		if ($last_year != $year) {
			$return .= "<b>$year</b><hr />\n";
			$last_year = $year;
		}
		// adding link that will show blog entries for this month
		$return .= "<a href=\"".urlEvalPrototype("index.php/module=blog?date=$year-$month")."\">".ucwords(strftime("%B, %Y [ <i>$counter</i> ]", mktime(0,0,0,$month,1,$year)))."</a><br />\n";
	}
?>