<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title>Latests posts</title>
			<description>Shows a list of the most recent blog entries.</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
		<variable name="limit">3</variable>
		<variable name="catid">0</variable>
	</blockscript>
	<%%>
	*/

	LoadLib (
		"categories", "format.lib.php"
	);

	$categorylock = categories::db_categorylock("category_id", null, $catid);

	// querying for the latests entries
	$q = $GLOBALS["db"]->query("SELECT
	id, author_id, category_id, icon, title, content, date_created
	FROM ".db_table("blog")."
	WHERE ".db_languagelock()." AND status = '1' AND {$categorylock}
	ORDER BY date_created DESC LIMIT {$limit}",
	__FILE__, __LINE__, true);

	$return = Array();
	while ($row = $GLOBALS["db"]->fetchRow($q)) {
		// mkintro will strip all html from post's content
		saneHTML($row, "content");
		// adding link
		$return[] = "<h4><a href=\"".urlEvalPrototype("index.php/module=blog/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}")."\" title=\"".dateFormat($row["date_created"])."\">".mkIcon($row["icon"] ? $row["icon"] : "blog.png")." {$row["title"]}</a></h4>".mkIntro($row["content"], 120)."<br /><div class=\"small\" style=\"text-align:right\"><b>"._l("L_POSTED_BY").":</b> ".cacheFunc('users::mkUserLink', $row["author_id"])."</div>\n";
	}
	//
	$return = implode("<hr />\n", $return);

?>