<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	// loading main configuration
	require_once "../../conf.php";

	// loading some other libraries & api
	LoadLib (
		"format.lib.php",
		"blog",
		"categories"
	);

	// authentication script
	require_once "../../lib/auth.inc.php";

	// importing some general variables that could be used in most procedures
	varImport ("action", "id", "return");

	// unprivileged user tasks
	switch ($action) {
		default:
			//foo();
		break;
	}

	// module administrator tasks
	if (is_admin()) {
		switch ($action) {
			case "delete":
				execWithEach($id, "Blog::deleteItem");

				slog("blog: deleted item(s) ".(is_array($id) ? implode(",", $id) : $id), "actions", 1);
			break;
			case "publish":
				Blog::setItemStatus($id, 1);

				slog("blog: published entry (id='$id')", "actions", 2);
			break;
			case "create":

				// all those variables below are supposed to be sent over a form.
				// after importing them, those variables becomes globals.
				varImport (
					"icon", "status", "category_id", "title", "content", "footer",
					"allow_comments", "tags"
				);

				// variables below are required not to be null before continue.
				varRequire (
					"category_id", "title", "content"
				);

				// checking access (for avoiding flood)
				$AccessTable->load_rule (
					$AccessTable->set_generic_rule("blog", "post"), "E_ANTI_FLOOD"
				);

				// html generated by the rtbEditor is not standard and needs to be
				// fixed before inserint this post into the database
				editorApplyFixes($content);

				// getting an id for this new entry
				$entry_id = $db->findFreeId("blog");

				categories::tagUpdate("downloads", $entry_id, $tags, array($content, $title));

				// inserting the new entry into the database
				$db->query ("
				INSERT INTO ".db_table("blog")."
					(
						id,
						author_id,
						category_id,
						icon,
						title,
						content,
						footer,
						date_created,
						status,
						allow_comments
					)
						VALUES
					(
						'{$entry_id}',
						'{$USER["id"]}',
						'{$category_id}',
						'{$icon}',
						'{$title}',
						'{$content}',
						'{$footer}',
						NOW(),
						'{$status}',
						'{$allow_comments}'
					)
				", __FILE__, __LINE__);

				$return = urlEvalPrototype("index.php/module=admin/base=blog", true, false);

				conf::setkey("blog", "last_selected_category", $category_id, "i");

				slog("blog: created new entry with title '$title'", "actions", 1);
			break;
			case "edit":

				// all those variables below are supposed to be sent over a form.
				// after importing them, those variables becomes globals.
				varImport (
					"icon", "status", "category_id", "title", "content", "footer", "tags",
					"allow_comments"
				);

				// variables below are required to continue.
				varRequire (
					"id", "category_id", "title", "content"
				);

				// is this entry already posted?
				$ptime = false;
				$db->query("SELECT status FROM ".db_table("blog")." WHERE id = '{$id}'");
				$row = $db->fetchRow();
				if (!$row["status"])
					$ptime = true;

				// html generated by the rtbEditor is not standard and needs to be
				// fixed before inserint this post into the database.
				editorApplyFixes($content);

				categories::tagUpdate("blog", $id, $tags, array($content, $title));

				$db->query("
					UPDATE ".db_table("blog")." SET
						category_id 	= '{$category_id}',
						icon 			= '{$icon}',
						title 			= '{$title}',
						content 		= '{$content}',
						footer 			= '{$footer}',
						status 			= '{$status}',
						".($ptime ? "date_created = CURRENT_TIMESTAMP(),": "")."
						allow_comments	= '{$allow_comments}'
					WHERE id = '{$id}'
				", __FILE__, __LINE__);

				$return = urlEvalPrototype("index.php/module=admin/base=blog", true, false);

				slog("blog: updated entry (id='$id')", "actions", 1);
			break;
		}
	}

	redirect($return);

	db_exit();
?>