<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	loadLib ("categories");

	Class Blog {

		function proccessSearch($query_id, $limit = -1) {
			$db =& $GLOBALS["db"];

			$data = array();

			for ($i = 0; ($limit < 0 || $i < $limit) && $row = $db->fetchRow($query_id); $i++) {
				$row["title"] = mklink("index.php/module=blog/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}", $row["title"]);
				$row["description"] = $row["content"];

				if (gauth("blog")) {
					$row["actions"] = new tplButtonBox();
						$row["actions"]->add(mklink("index.php/module=admin/base=blog/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
						$row["actions"]->add(mklink("modules/blog/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$row["actions"] = $row["actions"]->make();
				}
				$data[] = $row;
			}

			return $data;
		}

		function createItemLink($id, $only_url = false, $custom_url = null) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT icon, title FROM ".db_table("blog")." WHERE id='{$id}'",
			__FILE__, __LINE__, true);

			if ($db->numRows($q)) {
				$row = $db->fetchRow($q);
				if ($only_url) {
					return urlEvalPrototype("index.php/module=blog/action=view/title=".urlTitleEncode($row["title"])."?id=$id");
				} else {
					return mkicon($row["icon"], 16)." ".mklink($custom_url ? $custom_url :"index.php/module=blog/action=view/title=".urlTitleEncode($row["title"])."?id=$id", $row["title"]);
				}
			}
			return false;
		}
		function countRead($id) {
			$db =& $GLOBALS["db"];

			$db->query("UPDATE ".db_table("blog")."
				SET page_reads = page_reads + 1 WHERE id='{$id}'",
			__FILE__, __LINE__, true);
		}
		function getPossibleStatus() {
			return Array(_l("L_DRAFT"), _l("L_PUBLISHED"));
		}
		/**
		* createPermalink(result)
		* @returns: permalink for the given post
		*/
		function createPermalink(&$row, $usetitle = false) {
			return mklink("index.php/module=blog/action=permalink?path={$row["id"]}.".date2time($row["date_created"]), $usetitle ? $row["title"] :_l("L_PERMALINK"));
		}

		/**
		* deleteItem(item id);
		* @returns: boolean
		*
		*/
		// deletes a blog entry and all associated content with it
		function deleteItem($id) {

			// loading 'comments' api
			LoadLib("comments");

			// deleting comments
			Comments::deleteItems("blog", $id);

			slog("blog: deleted post '$id'", "actions", 1);

			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("blog")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* setItemStatus(item id, boolean);
		* @returns: boolean
		*
		*/
		// sets item status
		function setItemStatus($id, $status) {
			return $GLOBALS["db"]->query ("UPDATE ".db_table("blog")." SET status = '{$status}' WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* Comments::allowComment(item id);
		* @returns: boolean
		*
		*/
		// checks if this entry could accept comments on it
		function allowComment($thread) {
			$db =& $GLOBALS["db"];

			// this is a very simple check
			$q = $db->query("SELECT id FROM ".db_table("blog")."
			WHERE id = '{$thread}' AND allow_comments = '1' AND status = '1'",
			__FILE__, __LINE__, true);
			return $db->numRows($q) ? true : false;
		}
	}
?>