<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	// module's specification an installation instructions
	Class gekkoModule_Blog {
		function create_menu() {
			// returning 'false' means you want gekko to create a default menu entry
			return false;
		}
		function configure() {
			// default values for configuration keys (use ::getKey instead of setKey,
			// because getKey could create the key _only_ if it doesn't exists) and
			// setKey will _overwrite_ it.
			conf::getKey("blog", "items_per_page",			12,		"i");
			conf::getKey("blog", "items_per_admin_page",	25,		"i");
			conf::getKey("blog", "allow_user_comments",		1, 		"b");
			conf::getkey("blog", "tags_automark",			1,		"b");
		}
		function install() {

			// creating tables for this module
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("blog")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				category_id SMALLINT (5) UNSIGNED NOT NULL,
				icon VARCHAR (64) NOT NULL default 'blog.png',
				title VARCHAR (128) NOT NULL default '',
				content TEXT,
				footer VARCHAR (255) NOT NULL default '',
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP(19),
				status ENUM('0','1') NOT NULL default '1',
				page_reads MEDIUMINT (8) UNSIGNED NOT NULL default 0,
				allow_comments ENUM('0','1') NOT NULL default '1',
				language_id VARCHAR (2) NOT NULL default ''
			)", __FILE__, __LINE__, true);

			// registering module (this is not done automatically)
			gekkoModule::register($GLOBALS["cgdb"]["blog"], "blog", "*", $GLOBALS["cgdb"]["blog"]);
		}
		function uninstall() {
			// dropping tables (additional job is made automatically)
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("blog"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			$db =& $GLOBALS["db"];
			// applying patches according to new module's version
			if (Packages::checkVersion("0.5.8", $provided_v) < 0) {
				// fixes bugs when using MySQL5
				$db->query("ALTER TABLE ".db_table("blog")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1',
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
			if (Packages::checkVersion("0.5.9", $provided_v) <= 0) {
				$db->query ("ALTER TABLE ".db_table("blog")."
				CHANGE COLUMN icon icon VARCHAR (64) NOT NULL default 'blog.png',
				CHANGE COLUMN userid userid MEDIUMINT (8) UNSIGNED NOT NULL,
				ADD COLUMN pagereads MEDIUMINT (8) UNSIGNED NOT NULL default 0 AFTER status",
				__FILE__, __LINE__);
			}
			if (Packages::checkVersion("0.6.4", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("blog")."
					CHANGE COLUMN userid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
					CHANGE COLUMN category category_id SMALLINT (5) UNSIGNED NOT NULL,
					CHANGE COLUMN allowcomments allow_comments ENUM('0','1') NOT NULL default '1',
					CHANGE COLUMN pagereads page_reads MEDIUMINT (8) UNSIGNED NOT NULL default 0,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER footer,
					ADD COLUMN date_modified DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER date_created,
					ADD COLUMN language_id VARCHAR (2) NOT NULL default '' AFTER allow_comments
				",__FILE__, __LINE__, true);

				$db->query("UPDATE ".db_table("blog")." SET date_created = FROM_UNIXTIME(creationtime)", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("blog")."
					DROP COLUMN creationtime
				", __FILE__, __LINE__, true);
			}
			if (packages::checkversion("0.6.5", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("blog")."
					CHANGE COLUMN date_modified date_modified TIMESTAMP(19)
				");
			}
		}
		function ext_uninstall($module) {
			// if this module depends on other and it is uninstalled...
		}
	}
?>