<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib("groups", "categories");

	Extract (
		URLGetArgs("null/null/action=alpha?id=int&return=string")
	);

	switch ($action) {
		case "edit":

			if ($id) {

				$tpl = new ContentBlock();

				$tpl->insert("BLOCK_CONTENT", "categories/admin.edit.tpl");

				$actions = new tplButtonBox();
					$actions->add(mklink("index.php/module=admin/base=categories", _l("L_LIST"), "categories.png"));
					$actions->add(mklink("index.php/module=admin/base=categories/action=create", _l("L_CREATE"), "new.png"));
				$actions = $actions->make();

				$q = $db->query("
					SELECT
						id, icon, title, description, status, auth_access
					FROM ".db_table("category")." WHERE id = '{$id}'
				");

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);
					saneHTML($row);

					$row["TAGS"] = implode(", ", categories::categoryGetTags($row["id"], false));

					$tpl->setArray($row);

					$tpl->setArray(
						Array (
							"BLOCK_TITLE"		=> _l("L_CATEGORIES"),
							"BLOCK_SUBTITLE"	=> _l("L_EDIT"),
							"BLOCK_ICON"		=> mkIcon("categories.png"),
							"ICONCHOOSER"		=> mkIconChooser(48, $row["icon"]),
							"ARR_STATUS"		=> serialize(array(_l("L_DISABLED"), _l("L_ENABLED"))),
							"ACTION"			=> "edit",
							"ACTIONS"			=> $actions,
							"RETURN"			=> "index.php/module=admin/base=categories"
						)
					);
					$tpl->setArray($row);

					$mcBuff = $tpl->make();
				}

			}

		break;
		case "create":

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "categories/admin.create.tpl");

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=categories", _l("L_LIST"), "categories.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE" 		=> _l("L_CATEGORIES"),
					"BLOCK_ICON"		=> mkIcon("categories.png", 16),
					"ICONCHOOSER"		=> mkIconChooser(48, "categories.png"),
					"ARR_STATUS"		=> serialize(array(_l("L_DISABLED"), _l("L_ENABLED"))),
					"STATUS"			=> 1,
					"ACTION"			=> "create",
					"TITLE"				=> "",
					"DESCRIPTION"		=> "",
					"AUTH_ACCESS"		=> "*",
					"TAGS"				=> "",
					"ACTIONS"			=> $actions,
					"RETURN"			=> $return ? $return : "index.php/module=admin/base=categories"
				)
			);

			$mcBuff = $tpl->make();
		break;
		default:

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "categories/admin.default.tpl");

			$q = $db->query ("
				SELECT
					id, icon, title, description, status, auth_access, date_created, date_modified
				FROM ".db_table("category")."
				ORDER BY title ASC
			", __FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {
				saneHTML($row);

				if (!$row["status"])
					$row["title"] .= " ("._l("L_DISABLED").")";

				$row["TAGS"] = implode(", ", categories::categoryGetTags($row["id"], true));

				$tpl->setArray($row, "CATEGORY");

				$row["ACTIONS"] = new tplButtonBox();
					$row["ACTIONS"]->add (
						mkLink("index.php/module=admin/base=categories/action=edit?id={$row['id']}", _l("L_EDIT"), "edit.png"),
						mkLink("modules/categories/main.act.php?action=delete&id={$row['id']}&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), "delete.png", true)
					);
					if (!$row["status"])
						$row["ACTIONS"]->add(
							mkLink("modules/categories/main.act.php?action=enable&id={$row['id']}&auth={C_AUTH_STR}", _l("L_ENABLE"), "unlock.png")
						);
				$row["ACTIONS"] = $row["ACTIONS"]->make();

				$row["icon"] = mkicon($row["icon"], 48);
				$row["auth_access"] = groups::humanReadableGroups($row["auth_access"]);

				$tpl->setArray($row, "CATEGORY");

				$tpl->saveBlock("CATEGORY");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=categories/action=create", _l("L_CREATE"), "new.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE" 		=> _l("L_CATEGORIES"),
					"BLOCK_ICON"		=> mkIcon("categories.png", 16),
					"ACTIONS"			=> $actions
				)
			);

			$mcBuff = $tpl->make();
		break;
	}
?>