<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib("categories");

	Extract (
		URLGetArgs ("null/action=alpha/category=string/module=alpha/item=int?id=int&tag=string&page=int")
	);

	switch ($action) {
		case "tag":

			if (!$tag)
				$tag = $category;

			if ($page < 0)
				$page = 0;

			if ($tag) {

				$tag_id = categories::tagGetID($tag);

				if ($tag_id) {

					if ($module && $item) {
						// redirecting to module's element

						// updating rank
						$q = $db->query("UPDATE ".db_table("category_tag_relation")."
							SET module_item_rank = module_item_rank + 1 WHERE
							tag_id = '{$tag_id}' AND module_name = '{$module}' AND module_item_id = '{$item}'",
							__FILE__, __LINE__);

						if ($db->affectedRows($q)) {

							// re-balancing rank (lowest element must always be 0)
							$q = $db->query("SELECT module_item_rank
								FROM ".db_table("category_tag_relation")."
								ORDER BY module_item_rank ASC LIMIT 1",
								__FILE__, __LINE__);

							if ($db->numRows($q)) {
								$row = $db->fetchRow($q);
								$db->query("UPDATE ".db_table("category_tag_relation")."
								SET module_item_rank = module_item_rank - {$row["module_item_rank"]}",
								__FILE__, __LINE__);
							}

							// getting item's url, then redirecting user's browser
							loadLib ($module);

							$url = call_user_func(array($module, "createItemLink"), $item, true);

							header("Location: $url");

							exit();

						} else {
							redirect("index.php/module=categories");
						}

					} else {

						// increasing tag_rank
						$db->query("UPDATE ".db_table("category_tag")."
							SET tag_rank = tag_rank + 1
							WHERE id='{$tag_id}'", __FILE__, __LINE__);

						// rebalancing tag_rank
						$q = $db->query("SELECT tag_rank FROM ".db_table("category_tag")."
							ORDER BY tag_rank ASC LIMIT 1", __FILE__, __LINE__);

						$row = $db->fetchRow($q);

						if ($row["tag_rank"] > 0) {
							// lowest tag_rank must always be 0
							$db->query("UPDATE ".db_table("category_tag")." SET tag_rank = tag_rank - {$row["tag_rank"]}",
							__FILE__, __LINE__);
						}

						// getting associated items
						$q = $db->query("SELECT module_name, module_item_id FROM ".db_table("category_tag_relation")."
							WHERE tag_id = '{$tag_id}'
							ORDER BY module_item_rank DESC", __FILE__, __LINE__);

						$tpl = new ContentBlock();
						$tpl->insert("BLOCK_CONTENT", "categories/main.tag.tpl");

						while ($row = $db->fetchRow($q)) {

							loadLib ($row["module_name"]);

							$tpl->setArray (
								array (
									"TITLE"	=> call_user_func (
										Array($row["module_name"], "createItemLink"),
										$row["module_item_id"],
										false,
										"index.php/module=categories/action=tag/tag=$tag/module={$row["module_name"]}/item={$row["module_item_id"]}"
										)
								), "ITEM"
							);

							$tpl->saveBlock("ITEM");
						}

						$tpl->setArray(
							Array (
								"BLOCK_TITLE"	=> htmlspecialchars(ucwords($tag)),
								"BLOCK_ICON"	=> mkicon("categories.png", 16)
							)
						);

						$mcBuff = $tpl->make();
					}
				}
			}
		break;
		case "view":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "categories/main.view.tpl");

			$q = $db->query("SELECT
			id, icon, title, description, auth_access
			FROM ".db_table("category")."
			WHERE status = '1' AND id='{$id}'",
			__FILE__, __LINE__);

			$row = $db->fetchRow($q);

			unset ($entries);

			if ($db->numRows($q) && gauth($row["auth_access"])) {

				$row["icon"] = mkIcon($row["icon"], 48);

				$modules = gekkoModule::getList();

				// including a little script from every module from where it can list
				// contents that are related to this category.
				foreach ($modules as $module) {

					// script is called mod_categories.inc.php
					$file = GEKKO_SOURCE_DIR."modules/{$module}/mod_categories.inc.php";

					// if file above exists, including it
					if (file_exists($file)) {

						$data = Array(
							'entries' 	=> Array(), // module contents that are related to this category
							'module' 	=> '' // module info
						);

						include ($file);

						if (($entries = count($data["entries"])) > 0) {
							$tpl->reset("MODULE.ENTRY");
							foreach ($data["entries"] as $entry) {
								$tpl->setArray($entry, "MODULE.ENTRY");
								$tpl->saveBlock("MODULE.ENTRY");
							}
							$tpl->setArray($data["module"], "MODULE");
							$tpl->saveBlock("MODULE");
						}

					}

				}

				$tpl->setArray($row);
				$tpl->setArray(
					Array (
						"BLOCK_TITLE"	=> _l("L_CATEGORY"),
						"BLOCK_ICON"	=> mkIcon("categories.png"),
						"ENTRIES"		=> isset($entries) ? $entries : 0
					)
				);

				$mcBuff = $tpl->make();
			}
		break;
		default:

			if ($id) {
				header("HTTP/1.1 301 Moved Permanently");
				redirect("index.php/module=categories/action=view/category=$action?id=$id");
			}

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "categories/main.default.tpl");

			$q = $db->query ("
			SELECT
				id, icon, title, description, auth_access
			FROM ".db_table("category")." WHERE status = '1'
			ORDER BY title ASC
			", __FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {
				if (gauth($row["auth_access"])) {
					$row["icon"] = mkIcon($row["icon"], 48);
					$row["CATEGORY_LINK"] = urlevalprototype("index.php/module=categories/action=view/category=".urlTitleEncode($row["title"])."?id={$row['id']}");
					$tpl->setArray ($row, "CATEGORY");
					$tpl->saveBlock("CATEGORY");
				}
			}

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_CATEGORIES"),
					"BLOCK_ICON"		=> mkIcon("categories.png")
				)
			);

			$mcBuff = $tpl->make();
		break;
	}
?>