<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	if (defined("IN-TEMPLATE"))
		jscriptLoad("modules/categories/main.js");

	Class Categories {
		function tagChooser($module, $item_id, $name = "tags") {
			return "<textarea cols=\"40\" rows=\"3\" readonly=\"readonly\" onclick=\"tagChooser(this)\" name=\"$name\" />".implode(", ", categories::tagRetrieve($module, $item_id))."</textarea>";
		}
		function displayTags($module, $item_id) {
			$tags = implode(", ", cacheFunc("categories::tagRetrieve", $module, $item_id, true));
			if ($tags)
				return "<div><b>"._l("L_TAGS")."</b>: {$tags}</div>";
			return null;
		}
		function tagUpdate($module, $item_id, $tags, $automark = false) {
			if ($automark && conf::getkey($module, "tags_automark")) {
				foreach ($automark as $buff)
					categories::tagAutoMark($tags, $buff);
			}
			categories::tagMark($tags, $module, $item_id);
		}
		function proccessSearch($query_id, $limit = -1) {
			$db =& $GLOBALS["db"];

			$data = array();

			for ($i = 0; ($limit < 0 || $i < $limit) && $row = $db->fetchRow($query_id); $i++) {
				$row["icon"] = "categories.png";
				$row["title"] = mklink("index.php/module=categories/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}", $row["title"]);

				if (gauth("categories")) {
					$row["actions"] = new tplButtonBox();
						$row["actions"]->add(mklink("index.php/module=admin/base=categories/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
						$row["actions"]->add(mklink("modules/categories/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$row["actions"] = $row["actions"]->make();
				}

				$data[] = $row;
			}

			return $data;
		}
		function tagClear($module_name, $item_id) {
			$db =& $GLOBALS["db"];

			$db->query("DELETE FROM ".db_table("category_tag_relation")."
			WHERE module_name = '{$module_name}' AND module_item_id = '{$item_id}'",
			__FILE__, __LINE__, true);

		}
		function tagGetId($tag_name) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT id FROM ".db_table("category_tag")."
			WHERE tag_name = '{$tag_name}'",
			__FILE__, __LINE__, true);

			if ($db->numRows($q)) {
				$row = $db->fetchRow($q);
				return $row["id"];
			}
			return 0;
		}
		function tagAutoMark(&$tag_list, $text) {
			$db =& $GLOBALS["db"];

			$tag_list = explode(",", $tag_list);

			$q = $db->query("SELECT tag_name FROM ".db_table("category_tag"),
			__FILE__, __LINE__, true);

			$text = strtolower(" $text ");
			while ($row = $db->fetchRow($q)) {
				if (strpos($text, " ".strtolower($row["tag_name"])." ") !== false)
					$tag_list[] = $row["tag_name"];
			}

			$tag_list = implode(", ", $tag_list);
		}
		function tagRetrieve($module_name, $item_id, $linkmode = false) {
			$db =& $GLOBALS["db"];
			$tags = Array();

			if ($item_id) {
				$q = $db->query("SELECT t.tag_name FROM ".db_table("category_tag")." t,
				".db_table("category_tag_relation")." r WHERE r.module_name = '{$module_name}'
				AND r.module_item_id = '{$item_id}' AND  r.tag_id = t.id", __FILE__, __LINE__, true);

				while ($row = $db->fetchRow($q)) {
					if ($linkmode)
						$tags[] = mklink("index.php/module=categories/action=tag/title=".urlTitleEncode($row["tag_name"]), $row["tag_name"]);
					else
						$tags[] = $row["tag_name"];
				}
			}

			return $tags;
		}
		function tagMark($tag_name, $module_name, $item_id) {
			$db =& $GLOBALS["db"];
			$tags = explode(",", $tag_name);
			$done = Array();

			categories::tagClear($module_name, $item_id);

			foreach ($tags as $tag) {
				$tag = trim($tag);
				if (!isset($done[$tag])) {

					$tag_id = cacheFunc("categories::tagGetId", $tag);

					$db->query("INSERT INTO ".db_table("category_tag_relation")." (tag_id, module_name, module_item_id)
					VALUES ('$tag_id', '$module_name', '$item_id')", __FILE__, __LINE__, true);

					$done[$tag] = true;

				}
			}
		}
		function tagDelete($tag_name) {

			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT id FROM ".db_table("category_tag")."
			WHERE tag_name='{$tag_name}'", __FILE__, __LINE__);

			if ($db->numRows($q)) {
				$row = $db->fetchRow($q);

				$db->query("DELETE FROM ".db_table("category_tag")."
				WHERE id = '{$row["id"]}'", __FILE__, __LINE__);

				$db->query("DELETE FROM ".db_table("category_tag_relation")."
				WHERE tag_id = '{$row["id"]}'", __FILE__, __LINE__);
			}
		}
		function tagInsert($tag_name, $category_id) {
			$tag_name = trim($tag_name);

			if ($tag_name) {
				$db =& $GLOBALS["db"];

				$q = $db->query("SELECT id FROM ".db_table("category_tag")."
				WHERE tag_name='{$tag_name}'", __FILE__, __LINE__);

				if ($db->numRows($q)) {
					$row = $db->fetchRow($q);

					$db->query("UPDATE ".db_table("category_tag")."
					SET category_id = '{$category_id}' WHERE id = '{$row["id"]}'",
					__FILE__, __LINE__);

				} else {
					$db->query("INSERT INTO ".db_table("category_tag")."
						(category_id, tag_name) VALUES ('{$category_id}', '{$tag_name}')
					", __FILE__, __LINE__);
				}
			}

		}
		function categoryGetTags($id, $linkmode = false) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT tag_name FROM ".db_table("category_tag")."
			WHERE category_id='{$id}'", __FILE__, __LINE__, true);

			$tags = array();
			while ($row = $db->fetchRow($q)) {
				if (!trim($row["tag_name"]))
					continue;
				if ($linkmode)
					$tags[] = mklink("index.php/module=categories/action=tag/title=".urlTitleEncode($row["tag_name"])."", $row["tag_name"]);
				else
					$tags[] = $row["tag_name"];
			}
			return $tags;
		}

		/**
		* deleteItem(category id)
		* @return: true / false
		*/
		function deleteItem($id) {
			slog("categories: deleted '$id'", "actions", 1);
			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("category")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* setItemStatus(category id, [boolean] status)
		* @return: true / false
		*/
		function setItemStatus($id, $status) {
			return $GLOBALS["db"]->query ("UPDATE ".db_table("category")." SET status = '{$status}' WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* fetchList(at least one);
		* @return: array id->categories
		* When $one_at_least is set to 'true' and if no category was found
		* then redirects browser to category administration section.
		*
		*/
		function fetchList($one_at_least = false) {
			$return = array();
			$q = $GLOBALS["db"]->query("SELECT id, title FROM ".db_table("category")." ORDER BY title ASC", __FILE__, __LINE__, true);
			while ($row = $GLOBALS["db"]->fetchRow($q)) {
				saneHTML($row);
				$return[$row["id"]] = $row["title"];
			}
			if ($one_at_least && !count($return)) {
				header("Location: "._l("C_SITE.URL").urlEvalPrototype("index.php/module=admin/base=categories?message=".urlencode(_l("E_CATEGORY_REQUIRED"))."&return=".urlencode($_SERVER["REQUEST_URI"])));
				abort();
			}
			return $return;
		}

		/**
		* mkIcon(category id);
		* @return: a html formatted category icon
		*
		*/
		function mkIcon($id) {
			$q = $GLOBALS["db"]->query("SELECT icon FROM ".db_table("category")."
			WHERE id='$id'", __FILE__, __LINE__, true);
			$row = $GLOBALS["db"]->fetchRow($q);
			return mkIcon($row["icon"], 48);
		}

		/**
		* getCategory(category id, [boolean] $only_name);
		* @return: a html formatted link or only category name
		*
		*/
		function getCategory($id, $only_name = false) {

			$q = $GLOBALS["db"]->query("SELECT title
			FROM ".db_table("category")." WHERE id = '$id'", __FILE__, __LINE__, true);
			$row = $GLOBALS["db"]->fetchRow($q);

			saneHTML($row);

			if ($only_name)
				return $row["title"];

			return $GLOBALS["db"]->numRows($q) ? mkLink("index.php/module=categories/category=".urlTitleEncode($row["title"])."?id=$id", $row["title"]) : false;
		}

		/**
		* getID(category_name);
		* @returns: category ID
		*
		*/
		function getID($title) {

			$db =& $GLOBALS["db"];
			$ids = Array();

			$titles = explode(",", $title);
			foreach ($titles as $title) {
				$q = $db->query("SELECT id
				FROM ".db_table("category")." WHERE title = '{$title}'", __FILE__, __LINE__, true);

				if ($db->numRows($q)) {
					$row = $db->fetchRow($q);
					$ids[] = $row["id"];
				}
			}

			if ($ids)
				return implode(",", $ids);
			else
				return false;
		}

		function match($ids, $field = "category") {
			return categories::db_match($ids, $field);
		}
		/**
		* db_match();
		* @return: sql
		*/
		function db_match($ids, $field = "category") {
			if ($ids) {

				$ids = explode(",", $ids);

				foreach ($ids as $id)
					$sql[] = "$field='$id'";

				$sql = implode(" OR ", $sql);

				return "($sql)";
			}
			return 1;
		}

		/**
		* auth();
		* @return: true if the current user has enough privileges to access items listed in this category
		*
		*/
		function auth($id) {

			$q = $GLOBALS["db"]->query("SELECT auth_access
			FROM ".db_table("category")." WHERE id = '{$id}'",
			__FILE__, __LINE__, true);
			$row = $GLOBALS["db"]->fetchRow($q);

			return gauth($row["auth_access"]);
		}

		function createLock($field_name = "category", $auth = null) {
			return cacheFunc("categories::fetchAllowed", true, $field_name, $auth);
		}

		function db_categorylock($field = "category", $category = null, $auth = null) {
			$lock = cacheFunc("categories::fetchAllowed", true, $field, $auth);

			if ($category) {
				return "(({$lock}) AND ($field = '".cacheFunc("categories::getID", $category)."'))";
			}
			return "($lock)";
		}

		/**
		* fetchAllowed([boolean] create sql lock, sql lock field, auth string)
		* @return: array id->id
		* Lists allowed categories by id (if isset(...)) or returns a SQL formatted condition
		* for to use in a query.
		*
		*/
		function fetchAllowed($sql_lock = false, $sql_lock_field = "category", $auth = "*") {

			$return = Array();

			$q = $GLOBALS["db"]->query("SELECT id, auth_access
			FROM ".db_table("category")."
			WHERE status = '1'", __FILE__, __LINE__, true);

			while ($row = $GLOBALS["db"]->fetchRow($q)) {
				if (gauth($row["auth_access"], $auth))
					$return[$row["id"]] = $row["id"];
			}

			if ($sql_lock)
				$return = "$sql_lock_field = '".implode($return, "' OR $sql_lock_field = '")."'";

			return $return;
		}
	}
?>