<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class gekkoModule_Categories {
		function create_menu() {
			return true;
		}
		function configure() {

		}
		function install() {
			$db =& $GLOBALS["db"];

			$db->query("
			CREATE TABLE ".db_table("category")." (
				id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (id),
				icon VARCHAR (64) NOT NULL default 'categories.png',
				title VARCHAR (64) NOT NULL default '',
				description VARCHAR (255),
				status ENUM('0','1') NOT NULL default '1',
				language_id VARCHAR (2) NOT NULL default '',
				author_id MEDIUMINT (8) UNSIGNED NOT NULL default 1,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP,
				auth_access VARCHAR (255) NOT NULL default '*'
			)
			", __FILE__, __LINE__, true);

			$db->query("
			CREATE TABLE ".db_table("category_tag")." (
				id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY(id),
				category_id SMALLINT(5) UNSIGNED NOT NULL default '0',
				tag_name VARCHAR (255),
				tag_rank MEDIUMINT (8) UNSIGNED NOT NULL default '0'
			)", __FILE__, __LINE__);

			$db->query("
			CREATE TABLE ".db_table("category_tag_relation")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY(id),
				tag_id SMALLINT (5) UNSIGNED NOT NULL,
				module_name VARCHAR (255) NOT NULL,
				module_item_id INT (11) UNSIGNED NOT NULL default '0',
				module_item_rank SMALLINT (5) UNSIGNED NOT NULL default '0'
			)", __FILE__, __LINE__);

			// default category
			$db->query("
				INSERT INTO ".db_table("category")." (
					id,
					title,
					description
				) VALUES (
					'1',
					'General',
					'General Category'
				)
			", __FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["categories"], "categories", "*", $GLOBALS["cgdb"]["categories"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("category"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {

			$db =& $GLOBALS["db"];

			if (Packages::checkVersion("0.5.8", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("category")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}

			if (Packages::checkVersion("0.5.20", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("category")."
				CHANGE COLUMN icon icon VARCHAR (64) NOT NULL default 'categories.png'
				", __FILE__, __LINE__);
			}

			if (Packages::checkVersion("0.6.4", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("category")."
				CHANGE COLUMN category title VARCHAR (64) NOT NULL default '',
				ADD language_id VARCHAR (2) NOT NULL default '' AFTER status
				", __FILE__, __LINE__, true);

				$db->query("
				CREATE TABLE ".db_table("category_tag")." (
					id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY(id),
					category_id SMALLINT(5) UNSIGNED NOT NULL default '0',
					tag_name VARCHAR (255),
					tag_rank MEDIUMINT (8) UNSIGNED NOT NULL default '0'
				)", __FILE__, __LINE__, true);

				$db->query("
				CREATE TABLE ".db_table("category_tag_relation")." (
					id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY(id),
					tag_id SMALLINT (5) UNSIGNED NOT NULL,
					module_name VARCHAR (255) NOT NULL,
					module_item_id INT (11) UNSIGNED NOT NULL default '0',
					module_item_rank SMALLINT (5) UNSIGNED NOT NULL default '0'
				)", __FILE__, __LINE__, true);
			}
			// last release
			if (packages::checkVersion("0.6.5", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("category")."
					ADD COLUMN author_id MEDIUMINT (8) UNSIGNED NOT NULL default 1 AFTER language_id,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER author_id,
					ADD COLUMN date_modified TIMESTAMP AFTER date_created
				",
				__FILE__, __LINE__, true);
			}
		}
		function ext_uninstall($module) {

		}
	}

?>