<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"core.lib.php", "format.lib.php", "comments"
	);

	require_once GEKKO_SOURCE_DIR."lib/auth.inc.php";

	varImport("action", "id", "return");

	$auth_edit = false;

	// is this user authorized to edit messages?
	if (!is_admin() && !is_array($id)) {
		$db->query("SELECT id, date_created, author_id FROM ".db_table("comment")." WHERE id = '{$id}'");
		$row = $db->fetchRow();
		$auth_edit = Comments::authEdit($row);
	}

	switch ($action) {
		case "delete":
			if (is_admin() || $auth_edit)
				execWithEach($id, "comments::deleteItem");
			else
				abort(accessDenied());
		break;
		case "post":

			// antiflood
			$AccessTable->load_rule (
				$AccessTable->set_generic_rule("comments", "post"),
				"E_ANTI_FLOOD"
			);

			varImport("thread", "parent", "module", "nickname", "email", "title", "icon", "content", "url");

			varRequire("thread", "module", "title", "content");

			if (Comments::allowComment($module, $thread)) {

				editorApplyFixes($content);

				$db->query ("
				INSERT INTO ".db_table("comment")."
					(
						id,
						module,
						thread,
						parent,
						author_id,
						nickname,
						url,
						email,
						icon,
						title,
						content,
						date_created,
						ipaddr
					)
						VALUES
					(
						'".$db->findFreeId("comment")."',
						'{$module}',
						'{$thread}',
						'{$parent}',
						'{$USER["id"]}',
						'{$nickname}',
						'{$url}',
						'{$email}',
						'{$icon}',
						'{$title}',
						'{$content}',
						'".time2date()."',
						'".IP_ADDR."'
					)
				", __FILE__, __LINE__);

				set_userconf("nickname", $nickname);
				set_userconf("email", $email);
				set_userconf("url", $url);
			}

			cacheCleanPages($module);

			slog("comments: posted from ".getIP().", thread: $module.$thread.$parent", "actions", 3);
		break;
		case "edit":
			if (is_admin() || $auth_edit) {

				varImport("id", "thread", "module", "nickname", "email", "title", "icon", "content");

				varRequire("id", "thread", "module", "title", "content");

				editorApplyFixes($content);

				$db->query("
					UPDATE ".db_table("comment")." SET
						".(is_admin() ? "nickname = '{$nickname}'," : "")."
						".(is_admin() ? "email = '{$email}'," : "")."
						icon = '{$icon}',
						title = '{$title}',
						content = '{$content}'
					WHERE id = '{$id}' ".(is_admin() ? "" : " AND author_id = '{$USER["id"]}'")."
				", __FILE__, __LINE__);

				cacheCleanPages($module);

				slog("comment: modified comment '$id'", "actions", 2);
			} else {
				abort(accessDenied());
			}
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return);

	db_exit();
?>