<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"users", "comments", "format.lib.php"
	);

	Extract (
		UrlGetArgs("null/action=alpha?id=int&page=page")
	);

	switch ($action) {
		case "permalink":
			if ($id) {

				$q = $db->query("SELECT module, thread, date_created FROM ".db_table("comment")."
				WHERE id='{$id}'", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					$maxitems = conf::getKey("comments", "items_per_page");

					$q = $db->query("SELECT id FROM ".db_table("comment")."
					WHERE module='{$row["module"]}' AND thread='{$row["thread"]}'
					AND parent = '0' AND date_created < '{$row["date_created"]}'",
					__FILE__, __LINE__);

					$page = ($db->numRows($q)+1)/$maxitems;

					if ($page > intval($page))
						$page = intval(++$page);

					redirect("index.php/module={$row["module"]}/action=view?id={$row["thread"]}&page=$page#comment_$id");

				} else {
					redirect("index.php/module=comments?message=".urlencode(_l("L_UNKNOWN_PERMALINK"))."&type=error");
				}
				shutdown();
			}
		break;
		case "edit":
			if ($id) {

				$q = $db->query ("
				SELECT
					id, module, thread, icon, title, url, content, nickname, email, author_id, date_created
				FROM ".db_table("comment")." WHERE id = '{$id}'
				", __FILE__, __LINE__);

				$tpl = new ContentBlock();

				$tpl->insert("BLOCK_CONTENT", "comments/main.edit.tpl");

				if (($db->numRows($q) && $row = $db->fetchRow($q))  && Comments::authEdit($row)) {

					saneHTML($row, "content");

					format::htmlFilter($row["content"], $row["author_id"]);

					$tpl->setArray($row);

					$tpl->setArray (
						Array (
							"BLOCK_ICON"			=> mkIcon("comments.png"),
							"BLOCK_TITLE"			=> _l("L_COMMENTS"),
							"COMMENT_FORM_TITLE"	=> _l("L_EDIT"),
							"ACTION"				=> "edit",
							"RETURN"				=> local_referer(),
							"EDIT_AUTHOR"			=> true
						)
					);

					$mcBuff = $tpl->make();
				} else {
					$mcBuff = accessDenied();
				}
			}

		break;
		case "view":
			if ($id) {

				$q = $db->query ("
				SELECT
					id, author_id, nickname, email, icon, url, title, content, date_created, ipaddr
				FROM ".db_table("comment")." WHERE id = '{$id}'
				", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					Comments::prepareRow($row);

					$row["buttons"] = Comments::mkbuttonbox($row["id"], Comments::authEdit($row), false);

					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "comments/main.view.tpl");

					// loading children
					$children = Comments::fetchChildren($row["id"]);

					foreach ($children as $child) {
						Comments::prepareRow($child);
						$child["buttons"] = Comments::mkbuttonbox($child["id"], Comments::authEdit($child), false);

						$tpl->setArray($child, "COMMENT.REPLY");
						$tpl->saveBlock("COMMENT.REPLY");
					}

					$tpl->setArray($row, "COMMENT");

					$tpl->setArray (
						Array (
							"BLOCK_TITLE"		=> _l("L_COMMENTS"),
							"BLOCK_ICON"		=> mkicon("comments.png"),
							"COMMENTS_TITLE"	=> _l("L_VIEW")
						)
					);

					$tpl->saveBlock("COMMENT");

					$mcBuff = $tpl->make();
				}
			}
		break;
		default: {
			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "comments/main.default.tpl");

			$pager = $db->pager(
				"SELECT id FROM ".db_table("comment")." WHERE parent='0'",
				"index.php/module=comments?id=%p", $page, conf::getkey("comments", "items_per_page")
			);

			$q = $db->query ("
				SELECT
					id, module, thread, author_id, nickname, email, url, icon, title, content, date_created, ipaddr
				FROM ".db_table("comment")." WHERE parent='0'
				ORDER BY date_created DESC ".$pager["sql"]."
			", __FILE__, __LINE__);

			if ($db->numRows($q)) {

				while ($row = $db->fetchRow($q)) {

					Comments::prepareRow($row);
					$row["buttons"] = Comments::mkbuttonbox($row["id"], Comments::authEdit($row), false);
					$row["title"]= mkLink("index.php/module={$row["module"]}/action=view?id={$row["thread"]}", $row["title"]);

					$tpl->setArray($row, "COMMENT");
					$tpl->saveBlock("COMMENT");
				}

				$tpl->setArray(
					Array (
						"BLOCK_TITLE"	=> _l("L_COMMENTS"),
						"BLOCK_ICON"	=> mkicon("comments.png", 16),
						"PAGER"			=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();

			}
		}
	}

?>