<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class Comments {

		function proccessSearch($query_id, $limit = -1) {
			$db =& $GLOBALS["db"];

			$data = Array();

			for ($i = 0; ($limit < 0 || $i < $limit) && $row = $db->fetchRow($query_id); $i++) {

				$row["title"] = mklink("index.php/module=comments/action=permalink?id={$row["id"]}", $row["title"]);
				$row["description"] = $row["content"];

				if (gauth("comments")) {
					$row["actions"] = new tplButtonBox();
						$row["actions"]->add(mklink("index.php/module=comments/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
						$row["actions"]->add(mklink("modules/comments/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$row["actions"] = $row["actions"]->make();
				}

				$data[] = $row;

			}
			return $data;
		}

		function LoadBlock($module, $thread, $url, $page = 1, $title = null) {

			$comm = "";
			$comm .= Comments::loadThread($module, $thread, $url, $page);
			$comm .= Comments::loadForm($module, $thread, $title);

			if ($comm) {
				$tpl = new blockWidget();
				$tpl->load("comments/_comment.module.tpl");
				$tpl->set("BLOCK_CONTENT", $comm);
				return $tpl->make();
			} else {
				// comments are disabled
				return "";
			}
		}

		function countItems($module, $thread, $only_parents = false) {
			$db =& $GLOBALS["db"];
			$q = $db->query("SELECT id FROM ".db_table("comment")."
			WHERE module = '{$module}' AND thread = '{$thread}'".($only_parents ? " AND parent='0'": "")."", __FILE__, __LINE__,true);
			return intval($db->numRows($q));
		}


		function deleteItems($module, $thread) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT id FROM ".db_table("comment")." WHERE module='{$module}' AND thread='{$thread}'",
			__FILE__, __LINE__, true);

			while ($row = $db->fetchRow($q))
				comments::deleteItem($row["id"]);

			cacheCleanPages($module);

			slog("comments: massive deletion (module=$module thread=$thread)", "actions", 2);
		}


		function mkLink($module, $thread, $url_prototype = null) {
			// are comments enabled?
			if (!conf::getKey($module, "allow_user_comments", 0, "b"))
				return _l("L_COMMENTS_DISABLED");
			$c = Comments::countItems($module, $thread);
			return mkLink(($url_prototype ? $url_prototype : "index.php/module=$module/action=view?id=$thread")."#comments", ($c ? _l("L_COMMENTS").": $c" : _l("L_POST_A_COMMENT")));
		}


		function deleteItem($id) {
			$db =& $GLOBALS["db"];
			slog("comments: comment '$id' was deleted", "actions", 1);
			Comments::deleteChildren($id);
			return $db->query ("DELETE FROM ".db_table("comment")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}
		function deleteChildren($id) {
			if ($id) {
				$db =& $GLOBALS["db"];
				$q = $db->query("SELECT id, module FROM ".db_table("comment")." WHERE parent='{$id}'", __FILE__, __LINE__, true);
				while ($row = $db->fetchRow($q)) {
					cacheCleanPages($row["module"]);
					comments::deleteItem($row["id"]);
				}
			}
		}
		function loadForm($module, $thread, $title = null, $data = null) {
			$buff = "";
			if (Comments::allowComment($module, $thread)) {
				$tpl = new blockWidget();
				$buff = $tpl->load("comments/_comment.form.tpl");
				if (!$data) {
					$tpl->setArray (
						Array (
							"THREAD"				=> "$thread",
							"MODULE"				=> "$module",
							"ACTION"				=> "post",
							"TITLE"					=> "Re: $title",
							"CONTENT"				=> "",
							"COMMENT_FORM_TITLE"	=> _l("L_POST_A_COMMENT"),
							"RETURN"				=> "",
							"NICKNAME"				=> htmlspecialchars(get_userconf("nickname")),
							"EMAIL"					=> htmlspecialchars(get_userconf("email")),
							"URL"					=> htmlspecialchars(get_userconf("url"))
						)
					);
				}
				$buff = $tpl->make();
			}
			return $buff;
		}

		function authEdit(&$row) {
			return (gauth("comment") || (is_user() && ($row["author_id"] == $GLOBALS["USER"]["id"]) && ($row["date_created"]+conf::getKey("comments", "edit_time")) >= time()));
		}

		function fetchChildren($parent, $level = 0) {
			$result = Array();
			$level++;

			$db =& $GLOBALS["db"];
			$q = $db->query("SELECT
				id, author_id, nickname, email, icon, title, content, date_created, ipaddr, url
				FROM ".db_table("comment")." WHERE parent='$parent'
			");

			while ($row = $db->fetchRow($q)) {
				$row["level"] = $level;
				$result[] = $row;

				// recursion
				if (($children = Comments::fetchChildren($row["id"], $level)))
					$result = array_merge($result, $children);
			}

			return $result;
		}

		function prepareRow(&$row) {

			saneHTML($row, "content");

			format::style($row["content"], $row["author_id"]);

			$row["author"] = Comments::mkuserlink($row);
			$row["buttons"] = Comments::mkbuttonbox($row["id"], Comments::authEdit($row["id"]));

		}

		function loadThread($module, $thread, $url_prototype, $page = 1) {

			if (Comments::allowComment($module, $thread)) {


				$db =& $GLOBALS["db"];

				$buff = new BlockWidget();
				$buff->load("comments/_comment.inc.tpl");

				// creating pager
				$pager = $db->pager (
					"SELECT id FROM ".db_table("comment")."
					WHERE module = '{$module}' AND thread = '{$thread}' AND parent = '0'",
					$url_prototype, $page,
					conf::getKey("comments", "items_per_page")
				);

				// querying for messages
				$q = $db->query("
					SELECT
						id, author_id, nickname, email, icon, title, content, url, date_created, ipaddr
					FROM ".db_table("comment")."
					WHERE module = '{$module}' AND thread = '{$thread}' AND parent = '0'
					ORDER BY date_created ASC ".$pager["sql"]."
				", __FILE__, __LINE__, true);

				if ($db->numRows($q)) {

					while ($row = $db->fetchRow($q)) {

						Comments::prepareRow($row);

						$buff->setArray($row, "COMMENT");

						// loading children
						$children = Comments::fetchChildren($row["id"]);
						$buff->reset("COMMENT.REPLY");

						foreach ($children as $child) {
							$buff->set("REPLIES", 1, "COMMENT");
							Comments::prepareRow($child);
							$buff->setArray($child, "COMMENT.REPLY");
							$buff->saveBlock("COMMENT.REPLY");
						}

						$buff->saveBlock("COMMENT");
					}

					$buff->set ("COMMENTS_TITLE", "");

					$buff = $buff->make();

					$buff .= $pager["html"];

					return $buff;
				}
			}
			return false;
		}


		function mkUserLink($row) {

			if ($row["author_id"]) {
				return cacheFunc("users::mkuserlink", $row["author_id"]);
			} else {

				if (!gauth("comments") && conf::getkey("comments", "hide_ip_and_email", 1, "b"))
					$row["email"] = $row["ipaddr"] = "";

				if (!$row["nickname"])
					$row["nickname"] = _l("L_ANONYMOUS");

				if ($row["url"] == "http://")
					$row["url"] = "";

				return "&lt;".safeLink($row["url"], $row["nickname"])."&gt; ".($row["email"] ? " ".safelink($row["email"]) : "").($row["ipaddr"] ? " (".$row["ipaddr"].")" : "");
			}
		}

		function mkButtonBox($id, $editable = false, $reply = true) {
			$buttonBox = new tplButtonBox();
			if ($editable) {
				$buttonBox->add(mkLink("index.php/module=comments/action=edit?id={$id}", _l("L_EDIT"), "edit.png"));
				$buttonBox->add(mkLink("modules/comments/main.act.php?action=delete&id={$id}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
			}
			if ($reply)
				$buttonBox->add(mkLink("javascript:commentReply({$id});", _l("L_REPLY"), "reply.png"));
			return $buttonBox->make();
		}
		function allowComment($module, $thread) {
			if (conf::getKey($module, "allow_user_comments", 0, "b")) {

				LoadLib ($module);

				return call_user_func(array($module, "allowComment"), $thread);
			}
			return false;
		}
	}
?>