<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class gekkoModule_Comments {
		function create_menu() {
			// don't need a menu entry
			return true;
		}
		function configure() {
			conf::getKey("comments", "edit_time", 300, "i");
			conf::getKey("comments", "items_per_page", 8, "i");
		}
		function install() {

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("comment")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				module VARCHAR (32),
				thread MEDIUMINT (8) UNSIGNED NOT NULL,
				parent SMALLINT (5) UNSIGNED NOT NULL,
				author_id MEDIUMINT(8) UNSIGNED NOT NULL,
				nickname VARCHAR (32),
				email VARCHAR (64),
				url VARCHAR (128),
				icon VARCHAR (64),
				title VARCHAR (128),
				content TEXT,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP,
				ipaddr VARCHAR (64)
			)
			",__FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["comments"], "comments", "*", $GLOBALS["cgdb"]["comments"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("comment"),__FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			$db =& $GLOBALS["db"];
			if (Packages::checkVersion("0.5.8", $provided_v) <= 0) {
				$db->query("ALTER TABLE ".db_table("comment")."
				ADD parent SMALLINT (5) UNSIGNED NOT NULL AFTER thread,
				ADD url VARCHAR (128) AFTER email",__FILE__, __LINE__);
			}
			// last revision
			if (packages::checkVersion("0.6.7", $provided_v) < 0) {

				$db->query("ALTER TABLE ".db_table("comment")."
					CHANGE userid author_id MEDIUMINT(8) UNSIGNED NOT NULL default 1,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER creationtime,
					ADD COLUMN date_modified TIMESTAMP AFTER date_created
				", __FILE__, __LINE__, true);

				$db->query("UPDATE ".db_table("comment")." SET
					date_created = FROM_UNIXTIME(creationtime)", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("comment")."
					DROP COLUMN creationtime
				", __FILE__, __LINE__, true);

			}
		}
		function ext_uninstall($module) {
			$GLOBALS["db"]->query("DELETE FROM ".db_table("comment")." WHERE Module = '{$module}'",__FILE__, __LINE__, true);
		}
	}
?>