<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"downloads"
	);

	Extract (
		URLGetArgs("null/nul/action=alpha?id=int&page=page&category=int")
	);

	switch ($action) {
		case "edit_item":
			if ($id) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "downloads/admin.$action.tpl");

				$q = $db->query("SELECT id, download_category_id, title, description,
				thumbnail_url, thumbnail_size, file_url, author_id,
				date_modified, date_created, allow_comments, file_size
				FROM ".db_table("download_item")." WHERE id = '{$id}'", __FILE__, __LINE__);

				$row = $db->fetchRow($q);

				$tpl->setArray($row);

				saneHTML($row, "description");

				$options = new tplButtonBox();
				$options->add(
					mklink("index.php/module=admin/base=downloads", _l("L_CATEGORIES"), "categories.png"),
					mklink("index.php/module=admin/base=downloads/action=view_items?category={$row["download_category_id"]}", _l("L_VIEW_ITEMS"), "downloads.png")
				);
				$options = $options->make();

				$q = $db->query("SELECT id, title
				FROM ".db_table("download_category")." WHERE id = '{$row["download_category_id"]}'", __FILE__, __LINE__);
				$row2 = $db->fetchRow($q);

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"		=> $row2["title"],
						"BLOCK_ICON"		=> mkIcon("download.png", 16),
						"ACTION"			=> $action,
						"OPTIONS"			=> $options,
						"RETURN"			=> "index.php/module=admin/base=downloads/action=view_items?category={$row["download_category_id"]}"
					)
				);

				$mcBuff = $tpl->make();
			}
		break;
		case "view_items":
			if ($category) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "downloads/admin.$action.tpl");

				$pager = $db->pager (
					"SELECT id FROM ".db_table("download_item")." WHERE download_category_id = '{$category}'",
					"index.php/module=admin/base=downloads/action=view_items?id={$category}&page=%p#items",
					$page, conf::getkey("downloads", "items_per_admin_page")
				);

				$q = $db->query("SELECT id, title, description, thumbnail_url, thumbnail_size,
				file_url, allow_comments, date_modified, author_id, file_size
				FROM ".db_table("download_item")."
				WHERE download_category_id = '{$category}'
				ORDER BY title ASC {$pager["sql"]}",
				__FILE__, __LINE__);

				while ($row = $db->fetchRow($q)) {

					saneHTML($row, "description");
					format::style($row["description"], $row["author_id"]);

					if ($row["thumbnail_size"])
						list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

					$row["ACTIONS"] = new tplButtonBox();
						$row["ACTIONS"]->add(mklink("index.php/module=admin/base=downloads/action=edit_item?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
						$row["ACTIONS"]->add(mklink("modules/downloads/main.act.php?action=delete_item&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$row["ACTIONS"] = $row["ACTIONS"]->make();

					$tpl->setArray($row, "ITEM");
					$tpl->saveBlock("ITEM");
				}

				$options = new tplButtonBox();
				$options->add(
					mklink("index.php/module=admin/base=downloads", _l("L_CATEGORIES"), "categories.png"),
					mklink("index.php/module=admin/base=downloads/action=create_item?category=$category", _l("L_CREATE_ITEM"), "downloads.png")
				);
				$options = $options->make();

				$q = $db->query("SELECT id, title FROM ".db_table("download_category")."
				WHERE id = '{$category}'", __FILE__, __LINE__);
				$row = $db->fetchRow($q);

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"		=> $row["title"],
						"BLOCK_SUBTITLE"	=> _l("L_ADD_ITEM"),
						"BLOCK_ICON"		=> mkIcon("download.png", 16),
						"DOWNLOAD_CATEGORY_ID"	=> $id,
						"TITLE"				=> "",
						"ACTION"			=> "add_item",
						"DESCRIPTION"		=> "",
						"FILE_SIZE"			=> 0,
						"PAGER"				=> $pager["html"],
						"ALLOW_COMMENTS"	=> 1,
						"OPTIONS"			=> $options,
						"RETURN"			=> ""
					)
				);

				$mcBuff = $tpl->make();
			}
		break;
		case "create_item":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/admin.$action.tpl");

			$options = new tplButtonBox();
			$options->add(
				mklink("index.php/module=admin/base=downloads", _l("L_CATEGORIES"), "categories.png"),
				mklink("index.php/module=admin/base=downloads/action=view_items?category=$category", _l("L_VIEW_ITEMS"), "downloads.png")
			);
			$options = $options->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_DOWNLOADS"),
					"BLOCK_ICON"		=> mkIcon("download.png", 16),
					"DOWNLOAD_CATEGORY_ID"	=> $category,
					"TITLE"				=> "",
					"ACTION"			=> $action,
					"DESCRIPTION"		=> "",
					"OPTIONS"			=> $options,
					"FILE_SIZE"			=> 0,
					"ALLOW_COMMENTS"		=> 1,
					"RETURN"			=> "index.php/module=admin/base=downloads/action=view_items?category=$category"
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "edit_category":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/admin.$action.tpl");

			$q = $db->query("SELECT
			id, category_id, title, description, status, thumbnail_url,
			thumbnail_size, author_id, date_modified, auth_access
			FROM ".db_table("download_category")." WHERE id = '{$id}'
			", __FILE__, __LINE__);

			$row = $db->fetchRow($q);

			if ($row["thumbnail_size"])
				list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

			$options = new tplButtonBox();
			$options->add(
				mklink("index.php/module=admin/base=downloads", _l("L_CATEGORIES"), "categories.png"),
				mklink("index.php/module=admin/base=downloads/action=view_items&category={$row["id"]}", _l("L_VIEW_ITEMS"), "items.png"),
				mklink("index.php/module=admin/base=downloads/action=create_item&category={$row["id"]}", _l("L_ADD_ITEM"), "downloads.png"),
				mklink("modules/downloads/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true)
			);
			$options = $options->make();

			$tpl->setArray($row);

			$tpl->setArray (
				Array (
					"BLOCK_ICON"		=> mkIcon("downloads.png", 16),
					"BLOCK_TITLE"		=> $row["title"],
					"BLOCK_SUBTITLE"	=> _l("L_EDIT"),
					"ARR_CATEGORIES"	=> serialize(categories::fetchList()),
					"ACTION"			=> $action,
					"GALLERIES"			=> 0,
					"OPTIONS"			=> $options,
					"RETURN"			=> "index.php/module=admin/base=downloads"
				)
			);

			$mcBuff = $tpl->make();

		break;
		case "create_category":

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "downloads/admin.$action.tpl");

			$options = new tplButtonBox();
			$options->add(
				mklink("index.php/module=admin/base=downloads", _l("L_CATEGORIES"), "categories.png")
			);
			$options = $options->make();

			$tpl->setArray (
				Array (
					"BLOCK_ICON"		=> mkIcon("downloads.png", 16),
					"BLOCK_TITLE"		=> _l("L_DOWNLOADS"),
					"ARR_CATEGORIES"	=> serialize(categories::fetchList(true)),
					"CATEGORY_ID"		=> 0,
					"ACTION"			=> $action,
					"TITLE"				=> "",
					"DESCRIPTION"		=> "",
					"STATUS"			=> 1,
					"OPTIONS"			=> $options,
					"THUMBNAIL"			=> "",
					"AUTH_ACCESS"		=> "*",
					"RETURN"			=> "index.php/module=admin/base=downloads"
				)
			);

			$mcBuff = $tpl->make();
		break;
		default:

			$categories = categories::fetchList(true);

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/admin.default.tpl");

			$q = $db->query("SELECT
				id, title, description, category_id, status, thumbnail_url, thumbnail_size,
				author_id, date_modified
				FROM ".db_table("download_category")."
				ORDER BY category_id ASC, title ASC",
				__FILE__, __LINE__);

			if ($db->numRows($q)) {

				$catnames = Array();

				while ($row = $db->fetchRow($q)) {

					if (!isset($catnames[$row["category_id"]])) {
						// this means it is the end of a category (or the beggining of the first)

						if (count($catnames)) {
							// saving buffer & reseting subcategory block
							$tpl->saveBlock("CATEGORY");
							$tpl->reset("CATEGORY.SUBCATEGORY");
						}

						// new category
						$catnames[$row["category_id"]] = true;

						$tpl->setArray (
							Array (
								"CATEGORY" => categories::getCategory($row["category_id"], true)
							), "CATEGORY"
						);

					}

					if ($row["thumbnail_size"])
						list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

					$buttons = new tplButtonBox();
						$buttons->add(
							mklink("index.php/module=admin/base=downloads/action=view_items?category={$row["id"]}", _l("L_VIEW_ITEMS"), "items.png"),
							mklink("index.php/module=admin/base=downloads/action=edit_category?id={$row["id"]}", _l("L_EDIT"), "edit.png"),
							mklink("modules/downloads/main.act.php?action=delete_category&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true)
						);
					if (!$row["status"])
						$buttons->add(mklink("modules/downloads/main.act.php?action=enable_category&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_ENABLE"), "unlock.png"));
					$row["BUTTONS"] = $buttons->make();

					$tpl->setArray($row, "CATEGORY.SUBCATEGORY");

					$tpl->saveBlock("CATEGORY.SUBCATEGORY");
				}
				$tpl->saveBlock("CATEGORY");
			}


			$options = new tplButtonBox();
			$options->add(
				mklink("index.php/module=admin/base=downloads/action=create_category", _l("L_CREATE_CATEGORY"), "categories.png")
			);
			$options = $options->make();

			$tpl->setArray (
				Array (
					"BLOCK_ICON"		=> mkIcon("downloads.png", 16),
					"BLOCK_TITLE"		=> _l("L_DOWNLOADS"),
					"OPTIONS"			=> $options
				)
			);
			$mcBuff = $tpl->make();
		break;
	}
?>