<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title>Random item</title>
			<description>Shows a random item from a random download category</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
		<variable name="items">3</variable>
	</blockscript>
	<%%>
	*/

	LoadLib (
		"downloads"
	);

	$db =& $GLOBALS["db"];

	$cat_lock = "(download_category_id = '".implode("' OR download_category_id ='", Downloads::allowedCategories())."')";

	$q = $db->query("SELECT id, title, description, thumbnail_url, thumbnail_size, author_id
	FROM ".db_table("download_item")."
	WHERE {$cat_lock}
	ORDER BY RAND() LIMIT $items", __FILE__, __LINE__, true);

	$return = Array();
	while ($row = $db->fetchRow($q)) {

		saneHTML($row, "description");
		format::style($row["description"], $row["author_id"]);

		if ($row["thumbnail_url"])
			list($width, $height) = explode("x", $row["thumbnail_size"]);


		$buff = mklink(
			"index.php/module=downloads/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}",
			($row["thumbnail_url"] ? "<img class=\"photo\" src=\""._l("C_SITE.REL_URL")."{$row["thumbnail_url"]}\" width=\"{$width}\" height=\"{$height}\" alt=\"{$row["title"]}\" title=\"{$row["title"]}\" /><br />": "")."<b>{$row["title"]}</b>");
		$buff .= "<br />{$row["description"]}";

		$return[] = $buff;
	}

	$return = "<div style=\"text-align: center\">\n".implode("<hr />", $return)."\n</div>\n";
?>