<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"file.lib.php", "image.lib.php", "downloads", "format.lib.php"
	);

	require_once GEKKO_SOURCE_DIR."lib/auth.inc.php";

	varImport("action", "id", "return");

	if (is_admin()) {

		switch ($action) {
			case "delete_item":
				execWithEach($id, "downloads::deleteItem");
			break;
			case "delete_category":
				execWithEach($id, "downloads::deleteCategory");
			break;
			case "enable_category":
				downloads::setItemStatus($id, "1");
			break;
			case "disable_category":
				downloads::setItemStatus($id, "0");
			break;
			case "edit_category":

				varImport("id", "status", "category_id", "title", "description",
				"auth_access", "file_size");

				varRequire("id", "title");

				// a thumbnail is required for a category to exists
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file", "temp");
					if ($thumb) {
						$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
						$icon = $thumb["url"];
					} else {
						abort("Couldn't upload thumbnail!");
					}
					// deleting old thumbnail
					$db->query("SELECT thumbnail_url FROM ".db_table("download_category")." WHERE id = '{$id}'", __FILE__, __LINE__);
					$row = $db->fetchRow();
					@unlink(GEKKO_USER_DIR.$row["thumbnail_url"]);
				} else {
					$thumb = false;
				}

				editorApplyFixes($description);

				$db->query("UPDATE ".db_table("download_category")." SET
					title = '{$title}',
					description = '{$description}',
					category_id = '{$category_id}',
					status = '{$status}',
					author_id = '{$USER["id"]}',
					".($thumb ? "thumbnail_url = '{$thumb["url"]}'," : "")."
					".($thumb ? "thumbnail_size = '{$thumb["width"]}x{$thumb["height"]}'," : "")."
					auth_access = '".groups::extractFromInput($auth_access)."'
				WHERE ID = '{$id}'
				", __FILE__, __LINE__);

				slog("downloads: category '$id' was updated", "actions", 1);
			break;
			case "create_category":

				varImport("status", "category_id", "title", "description", "auth_access");

				varRequire("title");

				// a thumbnail is required to create a category
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file", "temp");
					if ($thumb) {
						$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
					} else {
						abort("Couldn't upload thumbnail!");
					}
				}

				editorApplyFixes($description);

				$db->query ("
				INSERT INTO ".db_table("download_category")."
					(
      					id,
						category_id,
						title,
						description,
						status,
						thumbnail_url,
						thumbnail_size,
						author_id,
						date_created,
						auth_access
					)
						VALUES
					(
						'".$db->findFreeId("download_category")."',
						'{$category_id}',
						'{$title}',
						'{$description}',
						'{$status}',
						'".(isset($thumb["url"]) ? $thumb["url"] : "")."',
						'".(isset($thumb["url"]) ? $thumb["width"]."x".$thumb["height"] : "")."',
						'{$USER["id"]}',
						'".time2date()."',
						'".groups::extractFromInput($auth_access)."'
					)
				", __FILE__, __LINE__);

				slog("downloads: new sub category '$title' filed under category id = '$category_id'", "actions", 2);
			break;
			case "edit_item":

				varImport("id", "download_category_id", "title", "description", "link_only",
				"file_url", "thumbnail_url", "allow_comments", "tags");

				varRequire("id", "title", "download_category_id");

				// checking if the user wants to change this item's download
				$media = Array();
				if ((!$link_only) && ($_POST["remote_media"] || $_FILES["local_media"]["size"])) {
					// getting file by specified url or submission
					$media = file_get("local_media", "remote_media", "data/downloads");
					if (!file_exists($media["abs_loc"]))
						abort("Coudln't upload/download file.");
				} elseif ($link_only && $_POST["remote_media"]) {
					// only linking
					$media["rel_loc"] = $_POST["remote_media"];
				}

				if (!$title)
					$title = beauty_basename($media["rel_loc"]);

				// this user has specified a thumbnail, it means that he wants to
				// delete the older one
				$thumb = Array();
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file", "data/gallery");
					if ($thumb)
						$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
				}

				// a new download or thumbnail was specified, the user wants to remove
				// older files.
				if ($media || $thumb) {
					$db->query("SELECT thumbnail_url, file_url FROM ".db_table("download_item")."
					WHERE id = '{$id}'", __FILE__, __LINE__);
					$row = $db->fetchRow();
					if ($media)
						@unlink(GEKKO_USER_DIR.$row["file_url"]);
					if ($thumb)
						@unlink(GEKKO_USER_DIR.$row["thumbnail_url"]);
				}

				editorApplyFixes($description);

				categories::tagUpdate("downloads", $id, $tags, array($description, $title));

				$db->query("UPDATE ".db_table("download_item")." SET
					download_category_id = '{$download_category_id}',
					title = '{$title}',
					description = '{$description}',
					thumbnail_url = '".(isset($thumb["url"]) ? $thumb["url"] : $thumbnail_url)."',
					".($thumb ? "thumbnail_size = '{$thumb["width"]}x{$thumb["height"]}'," : "")."
					file_url = '".(isset($media["rel_loc"]) ? $media["rel_loc"] : $file_url)."',
					author_id = '{$USER["id"]}',
					allow_comments = '{$allow_comments}'
				WHERE ID = '{$id}'", __FILE__, __LINE__);

				slog("downloads: item id='$id' was updated", "actions", 1);
			break;
			case "create_item":

				unset($size);

				varImport("download_category_id", "title", "description", "link_only", "allow_comments", "file_size", "tags");

				varRequire("download_category_id");

				$media = Array();

				// media is required
				if ((!$link_only) && ($_POST["remote_media"] || $_FILES["local_media"]["size"])) {
					// saving media
					$media = file_get("local_media", "remote_media", "data/downloads");

					if (!file_exists($media["abs_loc"]))
						abort("Couldn't save file.");

				} elseif ($link_only && $_POST["remote_media"]) {
					// only linking
					$media["rel_loc"] = $_POST["remote_media"];
				} else {
					abort(_l("E_INSUFFICIENT_DATA"));
				}

				if (!$title)
					$title = beauty_basename($media["rel_loc"]);

				// when thumbnail is provided
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file", "data/gallery");
					if ($thumb) {
						if ($link_only) {
							// saving image size before resizing
							$media["size"] = imagesize($thumb["abs_loc"]);
						}
						$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
					}
				} else {
					$thumb = false;
				}

				// getting file_size
				if (!$file_size) {
					$file_size = r_filesize($media["rel_loc"]);
					if (!$file_size && isset($media["abs_loc"]))
						$file_size = r_filesize($media["abs_loc"]);
				}

				editorApplyFixes($description);

				$item_id = $db->findFreeId("download_item");

				categories::tagUpdate("downloads", $item_id, $tags, array($description, $title));

				$db->query ("
				INSERT INTO ".db_table("download_item")."
					(
						id,
						download_category_id,
						title,
						description,
						thumbnail_url,
						thumbnail_size,
						file_url,
						author_id,
						date_created,
						file_size,
						allow_comments
					)
						VALUES
					(
						'{$item_id}',
						'{$download_category_id}',
						'{$title}',
						'{$description}',
						'".($thumb ? $thumb["url"] : "")."',
						'".($thumb ? $thumb["width"]."x".$thumb["height"] : "")."',
						'{$media["rel_loc"]}',
						'{$USER["id"]}',
						'".time2date()."',
						'{$file_size}',
						'{$allow_comments}'
					)
				", __FILE__, __LINE__);

				slog("downloads: added item to downloads category '$title'", "actions", 2);
			break;
		}

	}

	redirect($return);

	db_exit();
?>