<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"comments", "downloads", "format.lib.php"
	);

	Extract (
		URLGetArgs("null/action=alpha?id=int&page=page")
	);

	switch ($action) {
		case "get":
			if ($id) {

				// is this user allowed to download from this item's parent category?
				$cat_lock = "(download_category_id = '".implode("' OR download_category_id ='", downloads::allowedCategories())."')";

				$q = $db->query("SELECT file_url, download_category_id
				FROM ".db_table("download_item")." WHERE id = '{$id}' AND $cat_lock",
				__FILE__, __LINE__);

				$row = $db->fetchRow($q);

				header("Location: ".relativeLink($row["file_url"]));

				abort();
			}
		break;
		case "view":
			if ($id) {

				$tpl = new contentBlock();
				$tpl->insert("BLOCK_CONTENT", "downloads/main.view.tpl");

				$db->query("SELECT id, title, description, file_url, thumbnail_url,
				thumbnail_size, author_id, date_modified, allow_comments, file_size
				FROM ".db_table("download_item")." WHERE id = '{$id}'",
				__FILE__, __LINE__);

				$row = $db->fetchRow();
				saneHTML($row, "description");
				format::style($row["description"], $row["author_id"]);

				if ($row["thumbnail_size"])
					list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

				$row["file_url"] = relativeLink($row["file_url"]);

				$row["DOWNLOAD_LINK"] = urlEvalPrototype("index.php/module=downloads/action=get/title=".urlencode($row["title"])."?id={$row["id"]}");
				$tpl->setArray($row);

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"	=> $row["title"],
						"BLOCK_ICON"	=> mkicon("downloads.png"),
						"PAGE"			=> $page
					)
				);

				$mcBuff = $tpl->make();

			}
		break;
		case "category":

			$tpl = new contentBlock();

			$tpl->insert("BLOCK_CONTENT", "downloads/main.category.tpl");

			$q = $db->query("SELECT
			id, title, description, thumbnail_url, thumbnail_size, auth_access
			FROM ".db_table("download_category")." WHERE id = '{$id}'",
			__FILE__, __LINE__);

			$row = $db->fetchRow($q);

			if ($db->numRows($q) && gauth($row["auth_access"])) {

				$pager = $db->pager (
					"SELECT id FROM ".db_table("download_item")."
					WHERE download_category_id = '{$row["id"]}'",
					"index.php/module=downloads/action=category/".urlTitleEncode($row["title"])."?id={$row["id"]}&page=%p",
					$page, conf::getkey("downloads", "items_per_page")
				);

				$q = $db->query("SELECT id, title, description, thumbnail_url, thumbnail_size,
				date_modified, author_id, allow_comments, file_url, file_size
				FROM ".db_table("download_item")."
				WHERE download_category_id = '{$row["id"]}' {$pager["sql"]}",
				__FILE__, __LINE__);

				while ($row2 = $db->fetchRow($q)) {
					saneHTML($row2, "description");
					format::style($row2["description"], $row2["author_id"]);

					if ($row2["thumbnail_size"])
						list($row2["THUMBNAIL.WIDTH"], $row2["THUMBNAIL.HEIGHT"]) = explode("x", $row2["thumbnail_size"]);

					$row2["ACTIONS"] = new tplButtonBox();
					$row2["ACTIONS"]->add(mklink("index.php/module=downloads/action=get/title=".urlTitleEncode($row2["title"])."?id={$row2["id"]}", _l("L_DOWNLOAD"), "downloads.png"));
					$row2["ACTIONS"] = $row2["ACTIONS"]->make();

					$row2["ITEM_LINK"] = urlEvalPrototype("index.php/module=downloads/action=get/title=".urlTitleEncode($row2["title"])."?id={$row2["id"]}");
					$tpl->setArray($row2, "ITEM");
					$tpl->saveBlock("ITEM");
				}

				$tpl->setArray ($row);

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"		=> _l("L_DOWNLOADS"),
						"BLOCK_ICON"		=> mkIcon("downloads.png", 16),
						"BLOCK_SUBTITLE"	=> $row["title"],
						"PAGER"				=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();
			} else {
				$mcBuff = accessDenied();
			}

		break;
		default: {

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/main.default.tpl");

			$allowed_categories = array();
			$tmp = Downloads::getCategories();
			while (list($i) = each($tmp))
				$allowed_categories[] = $i;
			$allowed_categories = "(id = '".implode("' OR id ='", $allowed_categories)."')";

			$pager = $db->pager (
				"SELECT id FROM ".db_table("download_category")."
				WHERE {$allowed_categories} ORDER BY title DESC",
				"index.php/module=downloads?page=%p", $page, conf::getKey("downloads", "items_per_page")
			);

			$q = $db->query("SELECT
			id, title, description, category_id, thumbnail_url, thumbnail_size, author_id, date_modified
			FROM ".db_table("download_category")." WHERE {$allowed_categories} ORDER BY
			category_id ASC, title ASC {$pager["sql"]}", __FILE__, __LINE__);

			if ($db->numRows($q)) {

				$catnames = Array();

				while ($row = $db->fetchRow($q)) {

					if (!isset($catnames[$row["category_id"]])) {

						if (count($catnames)) {
							$tpl->saveBlock("CATEGORY");
							$tpl->reset("CATEGORY.SUBCATEGORY");
						}

						$catnames[$row["category_id"]] = true;

						$tpl->setArray (
							Array (
								"ICON"		=> categories::mkIcon($row["category_id"]),
								"CATEGORY"	=> categories::getCategory($row["category_id"], true)
							),
						"CATEGORY");
					}

					if ($row["thumbnail_size"])
						list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

					$row["CATEGORY_LINK"] = urlEvalPrototype("index.php/module=downloads/action=category/title=".urlTitleEncode($row["title"])."?id={$row["id"]}");
					$tpl->setArray($row, "CATEGORY.SUBCATEGORY");
					$tpl->saveBlock("CATEGORY.SUBCATEGORY");
				}

				$tpl->saveBlock("CATEGORY");

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"	=> _l("L_DOWNLOADS"),
						"BLOCK_ICON"	=> mkIcon("downloads.png", 16),
						"PAGER"			=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();
			}
		}
	}
?>