<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	define ("GEKKO_DOWNLOADS_DIR", GEKKO_USER_DIR."data/downloads/");

	LoadLib (
		"remote.lib.php", "file.lib.php", "categories"
	);

	mkworkdir(GEKKO_DOWNLOADS_DIR);

	Class Downloads {
		function createItemLink($id, $only_url = false, $custom_url = null) {

			$cat_lock = "(download_category_id = '".implode("' OR download_category_id ='", downloads::allowedCategories())."')";

			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT title FROM ".db_table("download_item")."
			WHERE id='{$id}' AND {$cat_lock}",
			__FILE__, __LINE__, true);

			if ($db->numRows($q)) {
				$row = $db->fetchRow($q);
				$row["icon"] = "downloads.png";
				if ($only_url) {
					return urlEvalPrototype("index.php/module=downloads/action=view/title=".urlTitleEncode($row["title"])."?id=$id");
				} else {
					return mkicon($row["icon"], 16)." ".mklink($custom_url ? $custom_url :"index.php/module=downloads/action=view/title=".urlTitleEncode($row["title"])."?id=$id", $row["title"]);
				}
			}
			return false;
		}
		function db_categorylock($field = "id") {
			return "($field = '".implode("' OR $field ='", downloads::allowedCategories())."')";
		}
		function proccessSearch($query_id, $limit = -1) {
			$db =& $GLOBALS["db"];

			$data = Array();

			for ($i = 0; ($limit < 0 || $i < $limit) && $row = $db->fetchRow($query_id); $i++) {
				$row["icon"] = "downloads.png";
					$row["title"] = mklink("index.php/module=downloads/action=item/title=".urlTitleEncode($row["title"])."?id={$row["id"]}", $row["title"]);

					if (gauth("downloads")) {
						$row["actions"] = new tplButtonBox();
							$row["actions"]->add(mklink("index.php/module=admin/base=downloads/action=edit_item?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
							$row["actions"]->add(mklink("modules/downloads/main.act.php?action=delete_item&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
						$row["actions"] = $row["actions"]->make();
					}

					$data[] = $row;
			}
			return $data;
		}
		/**
		* getStatusList();
		* @returns: Human readable list of possible download items status
		*/
		function getStatusList() {
			$status = Array (
				_l("L_DISABLED"),
				_l("L_ENABLED")
			);
			return $status;
		}

		/**
		* countItems(category_id);
		* @returns: Items count for specified category
		*/
		function countItems($id = 0) {
			$q = $GLOBALS["db"]->query("SELECT id FROM ".db_table("download_item")."
			WHERE download_category_id = '{$id}'", __FILE__, __LINE__, true);
			return intval($GLOBALS["db"]->numRows($q));
		}

		/**
		* getCategories();
		* @returns: A list of categories of download items
		*/
		function getCategories() {
			$q = $GLOBALS["db"]->query("SELECT id, title FROM ".db_table("download_category")."
			ORDER BY title ASC", __FILE__, __LINE__, true);
			$buff = Array();
			while ($row = $GLOBALS["db"]->fetchRow($q)) {
				$buff[$row["id"]] = $row["title"];
			}
			return $buff;
		}

		/**
		* deleteCategory(category_id);
		*
		*/
		function deleteCategory($id) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT id FROM ".db_table("download_item")."
			WHERE download_category_id = '{$id}'", __FILE__, __LINE__, true);

			while ($row = $db->fetchRow($q)) {
				Downloads::deleteItem($row["id"]);
			}

			// deleting thumbnail_url
			$q = $db->query("SELECT
			thumbnail_url FROM ".db_table("download_category")."
			WHERE id = '{$id}'", __FILE__, __LINE__, true);
			$r = $db->fetchRow($q);

			@unlink(GEKKO_USER_DIR.$row["thumbnail_url"]);

			slog("downloads: deleted category '$id'", "actions", 1);

			return $db->query("DELETE FROM ".db_table("download_category")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}
		/**
		* deleteItem(item_id);
		*/
		function deleteItem($id) {
			$db =& $GLOBALS["db"];

			LoadLib ("comments");

			// deleting comments
			Comments::deleteItems("downloads", $id);

			$q = $db->query("SELECT thumbnail_url, file_url
			FROM ".db_table("download_item")." WHERE id = '{$id}'",
			__FILE__, __LINE__, true);
			$r = $db->fetchRow($q);

			// deleting media
			@unlink(GEKKO_USER_DIR.$r["thumbnail_url"]);
			@unlink(GEKKO_USER_DIR.$r["file_url"]);

			slog("downloads: deleted item '$id'", "actions", 1);

			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("download_item")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}
		/**
		* setCategoryStatus(category_id, status);
		*/
		function setCategoryStatus($id, $status) {
			slog("downloads: status of '$id' changed to '$status'", "actions", 2);
			return $GLOBALS["db"]->query ("UPDATE ".db_table("download_category")." SET Status = '{$status}' WHERE ID='{$id}'", __FILE__, __LINE__, true);
		}

		function allowedCategories() {
			$db =& $GLOBALS["db"];

			$global_categories = categories::fetchAllowed();

			$allowed = Array();
			$q = $db->query("SELECT id, auth_access, category_id
			FROM ".db_table("download_category")." WHERE status = '1'",
			__FILE__, __LINE__, true);
			while ($row = $db->fetchRow($q)) {
				if (gauth($row["auth_access"]) && (isset($global_categories[$row["category_id"]])))
					$allowed[$row["id"]] = $row["id"];
			}
			return $allowed;
		}
		/**
		* prepareRowForDisplay();
		* Does common processes for query rows
		*/
		function prepareRowForDisplay(&$row, $is_item = false) {
			$row["TITLE_ID"] = urlencode($row["title"]);

			if ($row["thumbnail_size"])
				list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

		}

		/**
		* allowComment(item_id);
		* @returns: does this item allow comments on it?
		*/
		function allowComment($thread) {
			$db =& $GLOBALS["db"];

			// checking item
			$q = $db->query("SELECT download_category_id
			FROM ".db_table("download_item")."
			WHERE id = '{$thread}' AND allow_comments = '1'", __FILE__, __LINE__, true);
			$row = $db->fetchRow($q);

			// checking access
			$q = $db->query("SELECT auth_access
			FROM ".db_table("download_category")."
			WHERE id = '{$row["download_category_id"]}' AND status = '1'");
			$row = $db->fetchRow($q);

			return $db->numRows($q) ? gauth($row["auth_access"]) : false;
		}
	}
?>