<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class gekkoModule_Downloads {
		function create_menu() {
			return false;
		}
		function configure() {
			conf::getKey("downloads", "items_per_page", 8, "i");
			conf::getKey("downloads", "allow_user_comments", 1, "b");
			conf::getKey("downloads", "items_per_admin_page", 24, "i");
			conf::getKey("downloads", "thumbnail.longest_side", 80, "i");
		}
		function install() {

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("download_category")." (
				id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY(ID),
				category_id SMALLINT (5) UNSIGNED NOT NULL default '1',
				title VARCHAR (255),
				description TEXT,
				status ENUM('0','1') NOT NULL default '1',
				thumbnail_url VARCHAR (255),
				thumbnail_size VARCHAR (32),
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP,
				auth_access VARCHAR (255)
			)
			", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("download_item")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				download_category_id SMALLINT (5) UNSIGNED NOT NULL,
				title VARCHAR (255),
				description TEXT,
				thumbnail_url VARCHAR (255),
				thumbnail_size VARCHAR (32),
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP,
				file_url VARCHAR (255),
				file_download_counter MEDIUMINT (8) UNSIGNED NOT NULL,
				file_size INT (11) UNSIGNED NOT NULL,
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				allow_comments ENUM('0','1') NOT NULL default '1'
			)
			", __FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["downloads"], "downloads", "*", $GLOBALS["cgdb"]["downloads"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("download"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("download_item"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {

			$db =& $GLOBALS["db"];

			if (Packages::checkVersion("0.3", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("download_item")."
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("download")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}

			// last revision
			if (packages::checkVersion("0.6.5", $provided_v) < 0) {

				$db->query("ALTER TABLE ".db_table("download")." RENAME TO ".db_table("download_category")."",
				__FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("download_category")."
					CHANGE COLUMN categorylink category_id SMALLINT (5) UNSIGNED NOT NULL default '1',
					CHANGE COLUMN thumbnail thumbnail_url VARCHAR (255),
					CHANGE COLUMN thumbnailsize thumbnail_size VARCHAR (32),
					CHANGE COLUMN authorid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER author_id,
					ADD COLUMN date_modified TIMESTAMP AFTER date_created
				", __FILE__, __LINE__, true);

				$db->query("UPDATE ".db_table("download_category")." SET
					date_created = FROM_UNIXTIME(creationtime),
					date_modified = FROM_UNIXTIME(lastupdated)
				", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("download_category")."
					DROP COLUMN creationtime,
					DROP COLUMN lastupdated",
				__FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("download_item")."
					CHANGE COLUMN downloadlink download_category_id SMALLINT (5) UNSIGNED NOT NULL,
					CHANGE COLUMN thumbnail thumbnail_url VARCHAR (255),
					CHANGE COLUMN thumbnailsize thumbnail_size VARCHAR (32),
					CHANGE COLUMN authorid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER author_id,
					ADD COLUMN date_modified TIMESTAMP AFTER date_created,
					CHANGE COLUMN downloadurl file_url VARCHAR (255),
					CHANGE COLUMN downloadscount file_download_counter MEDIUMINT (8) UNSIGNED NOT NULL,
					CHANGE COLUMN filesize file_size INT (11) UNSIGNED NOT NULL,
					CHANGE COLUMN allowcomments allow_comments ENUM('0','1') NOT NULL default '1'
				",
				__FILE__, __LINE__, true);

				$db->query("UPDATE ".db_table("download_item")." SET
					date_created = FROM_UNIXTIME(creationtime),
					date_modified = FROM_UNIXTIME(lastupdated)
				", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("download_item")."
					DROP COLUMN creationtime,
					DROP COLUMN lastupdated",
				__FILE__, __LINE__, true);
			}
		}
		function ext_uninstall($module) {

		}
	}

?>