<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-BLOCK")) die();

	LoadLib (
		"image.lib.php", "file.lib.php"
	);

	$cache_dir = "data/thumbs/cache/";
	// this directory must exists
	mkworkdir(GEKKO_USER_DIR.$cache_dir);

	$db =& $GLOBALS["db"];

	if (isset($id)) {

		$q = $db->query("SELECT title, image_url, link FROM ".db_table("extension_snapshot")."
		WHERE id='{$id}'", __FILE__, __LINE__, true);

		if ($db->numRows($q)) {

			$refresh_interval = conf::getkey("extensions", "snapshot.cache_life");
			$longest_side = conf::getkey("extensions", "snapshot.longest_side");

			$row = $db->fetchRow($q);

			extract($row);

			// be kind with the others' bandwidth
			if ($refresh_interval < 3600)
				$refresh_interval = 3600;

			// we are saving this image in a different location, the normal cache is
			// unaccesible from outside
			$cache_key = substr(md5("cache_$image_url$longest_side"), 0, 8).".".file_extension($image_url);

			// cleaning expired data (older than 24h)
			cacheClean($cache_dir, 3600*24);

			// assigning cache file
			$cache_file = "$cache_dir$cache_key";

			// inspecting cache life
			$life = 0;
			if (($mtime = @filemtime(GEKKO_USER_DIR.$cache_file)) !== false) {
				// cache life
				$life = (time()-$mtime);
			}

			if ($life == 0 || ($life > $refresh_interval)) {

				// cache files doesn't not exists or has expired
				$file = @saveFile($image_url, "temp/", $cache_key, true);

				if (file_exists($file["abs_loc"]) && @getimagesize($file["abs_loc"])) {
					// creating thumbail
					$thumb = mkthumbnail($file["abs_loc"], $longest_side, true, true, $cache_dir);
					$image_url = _l("C_SITE.REL_URL").$thumb["url"];
					$width = $thumb["width"];
					$height = $thumb["height"];
				}
			}

			// cache is valid or an error has ocurred
			if (!isset($thumb)) {
				if (file_exists(GEKKO_USER_DIR.$cache_file)) {
					// using cache... probably outdated, but it's better than nothing
					$image_url = _l("C_SITE.REL_URL").$cache_file;
					$size = getimagesize(GEKKO_USER_DIR.$cache_file);
					list($width, $height) = $size;
				} else {
					// no cache, no thumbnail... humm... linking directly :-\
					$width = $height = $longest_side;
				}
			}

			$title = htmlspecialchars($title);
			$link = htmlspecialchars($link);

			$tpl = new ContentBlock();
			$tpl->load(GEKKO_EXTENSIONS_DIR."snapshot/templates/display.tpl");
			$tpl->setArray(
				Array (
					"TITLE"			=> $title,
					"IMAGE_URL"		=> $image_url,
					"LINK"			=> $link,
					"WIDTH"			=> $width,
					"HEIGHT"		=> $height

				)
			);
			$return = $tpl->make();
		}
	}
?>