<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-BLOCK")) die();

	LoadLib (
		"network.lib.php", "file.lib.php"
	);

	if (!function_exists('fahrenheit2celcius')) {
		function fahrenheit2celcius($f) {
			return round((5/9)*($f-32));
		}
	}

	$db =& $GLOBALS["db"];

	$refresh_interval = 3600;

	if (isset($id)) {

		$q = $db->query("SELECT city, accid, temp_unit FROM ".db_table("extension_weather")."
		WHERE id='{$id}'", __FILE__, __LINE__, true);

		if ($db->numRows($q)) {

			$row = $db->fetchRow($q);

			extract($row);

			$cache_key = cacheAssignKey($accid, $temp_unit);

			if ($refresh_interval < 3600)
				$refresh_interval = 3600;

			// checking cache life
			if (($life = cacheCheckLifetime($cache_key)) !== false) {
				if ((time() - $life) < $refresh_interval) {
					cacheRead($cache_key, $buff);
				}
			}

			if (!isset($buff)) {
				// no valid cache was found

				$url = "http://msnbc.com/m/chnk/d/weather_d_src.asp?acid=$accid";
				//$icon_url = "http://image.weather.com/web/common/wxicons/31/";
				$icon_url = "http://st.msn.com/as/wea3/i/en-US/law/";

				// getting weather data
				$tmp = @saveFile($url, "temp/", "$accid.tmp");

				if (file_exists($tmp["abs_loc"])) {

					preg_match_all("/this\.([a-z]*)\s*=\s*\"(.*)\";/i", fileRead($tmp["abs_loc"]), $match);

					if ($match) {

						$buff = Array();

						// parsing data
						foreach ($match[1] as $key => $id) {
							$val = $match[2][$key];
							$buff[strtoupper(substr($id, 2))] = $val;
						}

						// fahrenheit to celcius conversion
						$buff["TEMP"] = ($temp_unit == 0) ? fahrenheit2celcius($buff["TEMP"])."&deg; C" : $buff["TEMP"]."&deg; F";

						preg_match("/(\d*)\/(\d*)\/(\d*)\s(\d*):(\d*):(\d*)/", $buff["LASTUP"], $match);

						if (isset($match[6])) {

							list($lastup, $m, $d, $y, $h, $i, $s) = $match;

							$buff["LASTUP"] = dateFormat(mktime($h, $i, $s, $m, $d, $y));

							$buff["ICON"] = $icon_url.$buff["CICON"].".gif";

							$fore = explode("|", $buff["FORE"]);
							for ($i = 1; $i <= 5; $i++) {
								$buff["FORECAST_{$i}_DATE"] = $fore[$i+4];
								$buff["FORECAST_{$i}_WEEKDAY"] = $fore[$i-1];
								$buff["FORECAST_{$i}_LOW_TEMP"] = ($temp_unit == 0) ? fahrenheit2celcius($fore[$i+9])."&deg; C" : $fore[$i+9]."&deg; F";
								$buff["FORECAST_{$i}_HI_TEMP"] = ($temp_unit == 0) ? fahrenheit2celcius($fore[$i+19])."&deg; C" : $fore[$i+19]."&deg; F";
								$buff["FORECAST_{$i}_ICON"] = $icon_url.$fore[$i+29].".gif";
							}

							// saving cache
							$buff = serialize($buff);
							cacheSave($cache_key, $buff);

						} else {
							$outdated = true;
						}

					} elseif ($life !== false || isset($outdated)) {
						// couldn't fetch fresh information, using outdated cache
						cacheRead($cache_key, $buff);
					}
					// deleting temp file
					@unlink($tmp["abs_loc"]);
				}
			}

			if (isset($buff) && (($buff = @unserialize($buff)) !== false)) {
				// html
				$tpl = new ContentBlock();
				$tpl->load(GEKKO_EXTENSIONS_DIR."weather/templates/display.tpl");
				$tpl->setArray($buff);
				$return = $tpl->make();
			}

		}
	}
?>