<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib ("extensions");

	Class gekkoModule_Extensions {

		var $extensions = Array();

		function gekkoModule_Extensions () {
			$extensions = listdir(GEKKO_EXTENSIONS_DIR);
			// including extension definition
			foreach ($extensions as $extension) {
				if (($include = Extensions::getComponent($extension, "main")) != false) {
					Extensions::LoadLanguage($extension);
					$this->extensions[] = $extension;
					include_once $include;
				}
			}
		}
		function create_menu() {
			// Extensions does not require a menu entry
			return false;
		}
		function extension_command($command) {
			foreach ($this->extensions as $extension) {
				// must be defined in extension definition
				if (function_exists("extension_{$extension}_{$command}"))
					call_user_func("extension_{$extension}_{$command}");
			}
		}
		function configure() {
			$this->extension_command("configure");
		}
		function install() {
			$db =& $GLOBALS["db"];

			// this module was derived from tagboard, so if tagboard module exists must be
			// patched to use this new system.

			$q = $db->query("SELECT id FROM ".db_table("module")."
			WHERE module='tagboard' OR module='friends' OR module='phrases'",
			__FILE__, __LINE__, true);

			if ($db->numRows($q)) {

				// tagboard exists, we need to patch the database

				// patching module table
				$db->query("UPDATE ".db_table("module")." SET module='extensions'
				WHERE module='tagboard' or module='phrases' OR module='friends'",
				__FILE__, __LINE__, true);

				// patching groups table
				$db->query("UPDATE ".db_table("group")."
					SET groupname='extensions', description='"._l("L_MODULE_EXTENSIONS")."'
					WHERE groupname='tagboard' OR groupname='phrases' OR groupname='friends'",
				__FILE__, __LINE__, true);

				// renaming tables
				$db->query("ALTER TABLE ".db_table("tagboard")." RENAME TO ".db_table("extension_tagboard")."",
				__FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("phrases")." RENAME TO ".db_table("extension_phrases")."",
				__FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("friends")." RENAME TO ".db_table("extension_friends")."",
				__FILE__, __LINE__, true);

				// configuration keys
				$keys = Array("tagboard", "phrases", "friends");
				foreach ($keys as $key) {
					$q = $db->query("SELECT id, keyname FROM ".db_table("conf")." WHERE module='$key'",
					__FILE__, __LINE__, true);
					while ($row = $db->fetchRow($q)) {
						$db->query("UPDATE ".db_table("conf")."
						SET keyname = '$key.{$row["keyname"]}', module='extensions'
						WHERE id='{$row["id"]}'", __FILE__, __LINE__, true);
					}
				}

				// updating blocks
				$q = $db->query("UPDATE ".db_table("block")."
					SET scriptpath = 'extensions/display.php', scriptvars = '".serialize(array("extension_name"=>"tagboard"))."'
					WHERE scriptpath = 'tagboard/tagboard.php'", __FILE__, __LINE__, true);

				$q = $db->query("UPDATE ".db_table("block")."
					SET scriptpath = 'extensions/display.php', scriptvars = '".serialize(array("extension_name"=>"phrases"))."'
					WHERE scriptpath = 'phrases/my_phrases.php'", __FILE__, __LINE__, true);

				$q = $db->query("UPDATE ".db_table("block")."
					SET scriptpath = 'extensions/display.php', scriptvars = '".serialize(array("extension_name"=>"friends"))."'
					WHERE scriptpath = 'friends/my_friends.php'", __FILE__, __LINE__, true);

				// importing weather blocks
				extension_weather_install();

				$q = $db->query("SELECT id, scriptvars FROM ".db_table("block")."
					WHERE scriptpath='blocks/weather.php'", __FILE__, __LINE__, true);

				$id = 1;
				while ($row = $db->fetchRow($q)) {
					$vars = @unserialize($row["scriptvars"]);

					if (isset($vars["accid"])) {

						$p = $db->query("INSERT INTO ".db_table("extension_weather")."
						(id, accid, temp_unit) VALUES ('$id', '{$vars["accid"]}', '".($vars["units"] == "F")."')",
						__FILE__, __LINE__, true);

						$p = $db->query("UPDATE ".db_table("block")."
						SET scriptpath = 'extensions/display.php',
						scriptvars='".serialize(array("extension_name" => "weather", "id" => $id))."'
						WHERE id = '{$row["id"]}'",
						__FILE__, __LINE__, true);

						$id++;

					}
				}

				// importing feed readers
				$q = $db->query("SELECT id, scriptvars FROM ".db_table("block")."
					WHERE scriptpath='blocks/news_reader.php'", __FILE__, __LINE__, true);

				$id = 1;
				while ($row = $db->fetchRow($q)) {
					$vars = @unserialize($row["scriptvars"]);

					if (isset($vars["url"])) {

						$p = $db->query("INSERT INTO ".db_table("extension_aggregator")."
						(id, url, type) VALUES ('$id', '{$vars["url"]}', '{$vars["type"]}')",
						__FILE__, __LINE__, true);

						$p = $db->query("UPDATE ".db_table("block")."
						SET scriptpath = 'extensions/display.php', scriptpath='".serialize(array("extension_name" => "aggregator", "id" => $id))."'
						WHERE id = '{$row["id"]}'",
						__FILE__, __LINE__, true);

						$id++;
					}
				}

				// importing thumbnails
				$q = $db->query("SELECT id, scriptvars FROM ".db_table("block")."
					WHERE scriptpath='blocks/thumb.php'", __FILE__, __LINE__, true);

				$id = 1;
				while ($row = $db->fetchRow($q)) {
					$vars = @unserialize($row["scriptvars"]);

					if (isset($vars["url"])) {

						$p = $db->query("INSERT INTO ".db_table("extension_snapshot")."
						(id, image_url, title, link) VALUES ('$id', '{$vars["url"]}', '{$vars["title"]}', '{$vars["link"]}')",
						__FILE__, __LINE__, true);

						$p = $db->query("UPDATE ".db_table("block")."
						SET scriptpath = 'extensions/display.php', scriptpath='".serialize(array("extension_name" => "snapshot", "id" => $id))."'
						WHERE id = '{$row["id"]}'",
						__FILE__, __LINE__, true);

						$id++;
					}
				}

				conf::setkey("extensions", "weather", 1, "b");
				conf::setkey("extensions", "friends", 1, "b");
				conf::setkey("extensions", "tagboard", 1, "b");
				conf::setkey("extensions", "phrases", 1, "b");

				$this->extension_command("configure");

				$q = $db->query("DELETE FROM ".db_table("module")."
				WHERE module='tagboard' OR module='friends' OR module='phrases'",
				__FILE__, __LINE__, true);

				$q = $db->query("DELETE FROM ".db_table("group")."
				WHERE groupname='tagboard' OR groupname='friends' OR groupname='phrases'",
				__FILE__, __LINE__, true);

				gekkoModule::install('extensions', "P");

			} else {

				// general command
				$this->extension_command("install");
				$this->extension_command("configure");

				foreach ($this->extensions as $extension)
					conf::setkey("extensions", $extension, 1, "b");

				// registering module
				gekkoModule::register($GLOBALS["cgdb"]["extensions"], "extensions", "*", $GLOBALS["cgdb"]["extensions"]);
			}
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("extensions"),__FILE__, __LINE__, true);

			$this->extension_command("uninstall");

			foreach ($this->extensions as $extension)
				conf::setkey("extensions", $extension, 0, "b");
		}
		function upgrade($provided_v) {
			foreach ($this->extensions as $extension) {
				if (function_exists("extension_{$extension}_upgrade")) {
					call_user_func("extension_{$extension}_upgrade", $provided_v);
				}
			}
		}
		function ext_uninstall($module) {

		}
	}
?>