<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Extract (
		URLGetArgs("null/null/action=alpha?id=int&category=int")
	);

	LoadLib ("forums");

	$vertical_position = Array(_l("L_BOTTOM"), _l("L_TOP"));

	if (!$category)
		$category = 1;

	switch ($action) {
		case "create_forum":

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "forums/admin.$action.tpl");

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin", _l("L_FORUMS"), "forums.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_FORUMS"),
					"BLOCK_ICON"		=> mkicon("categories.png", 16),
					"ICON"				=> "forum.png",
					"STATUS"			=> 1,
					"ARR_ORDER"			=> serialize($vertical_position),
					"ORDER_ID"			=> 1,
					"CATEGORY_ID"		=> $category,
					"NAME"				=> "",
					"DESCRIPTION"		=> "",
					"ACTION"			=> $action,
					"ACTIONS"			=> $actions,
					"RETURN"			=> "index.php/module=admin/base=forums"
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "edit_forum":

			$forum_order = Array();

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "forums/admin.$action.tpl");

			$q = $db->query("SELECT id, category_id, order_id, icon, name, description,
			status FROM ".db_table("forum_forum")." WHERE id = '{$id}'", __FILE__, __LINE__);

			if ($db->numRows($q)) {

				$row = $db->fetchRow($q);

				$q = $db->query("SELECT order_id FROM ".db_table("forum_forum")."
				where category_id = '{$row["category_id"]}'
				ORDER BY order_id ASC", __FILE__, __LINE__, true);

				while ($row2 = $db->fetchRow($q))
					$forum_order[$row2["order_id"]] = $row2["order_id"];

				saneHTML ($row, "description");

				$tpl->setArray ($row);

				$actions = new tplButtonBox();
					$actions->add(mklink("index.php/module=admin", _l("L_FORUMS"), "forums.png"));
				$actions = $actions->make();

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"		=> _l("L_FORUMS"),
						"BLOCK_SUBTITLE"	=> _l("L_EDIT_FORUM"),
						"BLOCK_ICON"		=> mkicon("categories.png", 16),
						"ARR_ORDER"			=> serialize($forum_order),
						"ACTION"			=> $action,
						"ACTIONS"			=> $actions,
						"RETURN"			=> "index.php/module=admin/base=forums"
					)
				);

				$mcBuff = $tpl->make();
			}
		break;
		case "edit_category":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "forums/admin.$action.tpl");

			$category_order = Array();

			$q = $db->query("SELECT order_id FROM ".db_table("forum_category")."
			ORDER BY order_id ASC", __FILE__, __LINE__);

			while ($row = $db->fetchRow($q))
				$category_order[$row["order_id"]] = $row["order_id"];

			$q = $db->query("SELECT id, icon, order_id, name, description, status,
			auth_access, auth_post
			FROM ".db_table("forum_category")." WHERE id = '{$id}'", __FILE__, __LINE__);

			$row = $db->fetchRow($q);
			saneHTML ($row, "description");

			$tpl->setArray ($row);

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin", _l("L_FORUMS"), "forums.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_FORUMS"),
					"BLOCK_ICON"		=> mkicon("categories.png", 16),
					"ARR_ORDER"			=> serialize($category_order),
					"ACTION"			=> $action,
					"ACTIONS"			=> $actions,
					"RETURN"			=> "index.php/module=admin/base=forums"
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "create_category":

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "forums/admin.$action.tpl");

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin", _l("L_FORUMS"), "forums.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_FORUMS"),
					"BLOCK_SUBTITLE"	=> _l("L_CREATE"),
					"BLOCK_ICON"		=> mkicon("categories.png", 16),
					"ARR_ORDER"			=> serialize($vertical_position),
					"ORDER_ID"			=> 1,
					"CATEGORY"			=> "",
					"ICON"				=> "category.png",
					"NAME"				=> "",
					"DESCRIPTION"		=> "",
					"STATUS"			=> 1,
					"AUTH_ACCESS"		=> conf::getKey("forums", "default_auth_access"),
					"AUTH_POST"			=> conf::getKey("forums", "default_auth_post"),
					"ACTION"			=> $action,
					"ACTIONS"			=> $actions,
					"RETURN"			=> "index.php/module=admin/base=forums"
				)
			);

			$mcBuff = $tpl->make();
		break;
		default:

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "forums/admin.default.tpl");

			$q = $db->query("SELECT id, icon, name, description, status, auth_access
			FROM ".db_table("forum_category")." ORDER BY order_id ASC",
			__FILE__, __LINE__);

			$catc = 0;
			$catt = $db->numRows($q);
			while ($row = $db->fetchRow($q)) {
				saneHTML($row, "description");

				// forums in this category
				$q2 = $db->query("SELECT id, icon, name, description, status,
				messages_count, topics_count
				FROM ".db_table("forum_forum")."
				WHERE category_id = '{$row["id"]}' ORDER BY order_id ASC",
				__FILE__, __LINE__, true);

				$tpl->reset("CATEGORY.FORUM");

				if (($frmt = $db->numRows($q2)) != 0) {
					$frmc = 0;
					while ($row2 = $db->fetchRow($q2)) {
						saneHTML($row2, "description");
						$row2["ACTIONS"] = new tplButtonBox();
							if ($frmc)
								$row2["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=move_forum&where=up&id={$row2["id"]}&auth={C_AUTH_STR}", _l("L_MOVE_UP"), "up.png", false, "icon"));
							if (++$frmc < $frmt)
								$row2["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=move_forum&where=down&id={$row2["id"]}&auth={C_AUTH_STR}", _l("L_MOVE_DOWN"), "down.png", false, "icon"));
							$row2["ACTIONS"]->add(mklink("index.php/module=admin/base=forums/action=edit_forum?id={$row2["id"]}", _l("L_EDIT"), "edit.png", false, "icon"));
							$row2["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=forum_delete&id={$row2["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true, "icon"));
							if (!$row2["status"])
								$row2["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=forum_enable&id={$row2["id"]}&auth={C_AUTH_STR}", _l("L_ENABLE"), "ok.png", false, "icon"));
						$row2["ACTIONS"] = $row2["ACTIONS"]->make();

						$tpl->setArray($row2, "CATEGORY.FORUM");

						$tpl->saveBlock("CATEGORY.FORUM");
					}
				}

				$row["ACTIONS"] = new tplButtonBox();
					if ($catc)
						$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=move_category&where=up&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_MOVE_UP"), "up.png"));
					if (++$catc < $catt)
						$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=move_category&where=down&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_MOVE_DOWN"), "down.png"));
					$row["ACTIONS"]->add(mklink("index.php/module=admin/base=forums/action=create_forum?category={$row["id"]}", _l("L_ADD_FORUM"), "forum.png"));
					$row["ACTIONS"]->add(mklink("index.php/module=admin/base=forums/action=edit_category?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
					$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=category_delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					if (!$row["status"]) {
						$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=category_enable&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_ENABLE"), "ok.png"));
					}
				$row["ACTIONS"] = $row["ACTIONS"]->make();

				$tpl->setArray($row, "CATEGORY");

				$tpl->saveBlock("CATEGORY");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=forums/action=create_category", _l("L_CREATE_CATEGORY"), "new.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_FORUMS"),
					"BLOCK_ICON"		=> mkicon("categories.png", 16),
					"ACTIONS"			=> $actions
				)
			);

			$mcBuff = $tpl->make();
		break;
	}

?>