<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"forums", "format.lib.php"
	);

	require_once GEKKO_SOURCE_DIR."lib/auth.inc.php";

	varImport("action", "id", "return");

	// privileges to edit messages
	$auth_edit = is_admin();

	if (!$auth_edit && $id) {
		$q = $db->query("SELECT id, date_created, author_id
		FROM ".db_table("forum_message")." WHERE id = '{$id}'");

		$row = $db->fetchRow($q);

		$auth_edit = forums::messageAuthEdit($id, $row["date_created"], $row["author_id"]);
	}

	// setting antiflood rule
	$forum_antiflood = $AccessTable->set_generic_rule("forum_id", "post");

	if (is_admin()) {
		switch ($action) {
			case "delete_category":
				varRequire("id");
				forums::deleteItem($id);
			break;
			case "enable_category":

				varRequire("id");
				$db->query("UPDATE ".db_table("forum_category")."
				SET status='1' WHERE id='{$id}'", __FILE__, __LINE__);

			break;
			case "enable_forum":

				varRequire("id");
				$db->query("UPDATE ".db_table("forum_forum")."
				SET status='1' WHERE id='{$id}'", __FILE__, __LINE__);

			break;
			case "move_category":

				varImport("where");

				varRequire("id", "where");

				// fetching immediatly lower or higher item
				$w = ($where == "up") ? "<" : ">";

				$db->query("SELECT order_id FROM ".db_table("forum_category")." WHERE id = '{$id}'");

				if ($db->numRows()) {

					$row = $db->fetchRow();

					$db->query("SELECT id, order_id FROM ".db_table("forum_category")."
					WHERE order_id $w '{$row["order_id"]}'
					ORDER BY order_id ".(($w == "<") ? "DESC": "ASC")." LIMIT 1"
					,__FILE__, __LINE__);

					if ($db->numRows()) {

						$row2 = $db->fetchRow();

						// swapping order
						$db->query("UPDATE ".db_table("forum_category")." SET
							order_id = '{$row2["order_id"]}'
						WHERE id = '{$id}'");

						$db->query("UPDATE ".db_table("forum_category")." SET
							order_id = '{$row["order_id"]}'
						WHERE id = '{$row2["id"]}'");

						slog("forums: category '$id' moved", "actions", 2);
					}

				}
			break;
			case "move_forum":

				varImport("id", "where");

				varRequire("id", "where");

				$w = ($where == "up") ? "<" : ">";

				$q = $db->query("SELECT category_id, order_id FROM ".db_table("forum_forum")." WHERE id = '$id'");

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					$db->query("SELECT id, order_id FROM ".db_table("forum_forum")."
					WHERE category_id = '{$row["category_id"]}' AND order_id $w '{$row["order_id"]}'
					ORDER BY order_id ".(($w == "<") ? "DESC": "ASC")." LIMIT 1"
					,__FILE__, __LINE__);

					if ($db->numRows($q)) {
						$row2 = $db->fetchRow($q);

						// swapping order_id
						$db->query("UPDATE ".db_table("forum_forum")." SET
							order_id = '{$row2["order_id"]}'
						WHERE id = '{$id}'");

						$db->query("UPDATE ".db_table("forum_forum")." SET
							order_id = '{$row["order_id"]}'
						WHERE id = '{$row2["id"]}'");

						slog("forums: forum '$id' moved", "actions", 2);
					}
				}

			break;
			case "delete_forum":
				varRequire("id");
				forums::deleteForum($id);
			break;
			case "delete_thread":

				$db->query("SELECT t.forum_id, f.category_id
				FROM ".db_table("forum_thread")." t, ".db_table("forum_forum")." f
				WHERE t.id = '{$id}' AND t.forum_id = f.id", __FILE__, __LINE__);

				$row = $db->fetchRow();

				if ($db->numRows()) {
					forums::deleteThread($id);
					$return = urlEvalPrototype("index.php/module=forums?path={$row["category_id"]}.{$row["forum_id"]}", true, false);
				}

				forums::updateForumStats($id);
			break;
			case "move_thread":

				varImport("to");

				varRequire("id", "to");

				$q = $db->query("SELECT f.id, f.category_id
				FROM ".db_table("forum_category")." c, ".db_table("forum_forum")." f, ".db_table("forum_thread")." t
				WHERE t.id = '{$id}' AND f.category_id = c.id AND t.forum_id = f.id",
				__FILE__, __LINE__);

				if ($db->numRows($q)) {
					$row = $db->fetchRow($q);

					$db->query("UPDATE ".db_table("forum_thread")." SET forum_id = '{$to}'
					WHERE id = '{$id}'", __FILE__, __LINE__);

					forums::updateForumStats($to);
					forums::updateForumStats($row["id"]);

					$return = "index.php/module=forums?path={$row["category_id"]}.$to";

					slog("forums: moved thread '$id' to forum '$to'");
				}
			break;
			case "mode_thread":

				varImport("mode");

				varRequire("id", "mode");

				unset ($mode_field, $mode_value);

				switch ($mode) {
					case "lock": case "unlock":
						$mode_field = "mode_locked";
						$mode_value = ($mode == "lock");
					break;
					case "stick": case "unstick":
						$mode_field = "mode_sticked";
						$mode_value = ($mode == "stick");
					break;
				}

				if (isset($mode_field)) {
					$db->query("UPDATE ".db_table("forum_thread")."
					SET $mode_field = '$mode_value' WHERE id = '$id'", __FILE__, __LINE__);

					$db->query("SELECT t.forum_id, f.category_id
					FROM ".db_table("forum_thread")." t, ".db_table("forum_forum")." f
					WHERE t.id = '{$id}' AND t.forum_id = f.id", __FILE__, __LINE__);
					$row = $db->fetchRow();

					$return = "index.php/forums?path={$row["category_id"]}.{$row["forum_id"]}";

					slog("forums: thread mode changed '$id'", "actions", 1);
				}

			break;
			case "edit_category":

				varImport("id", "icon", "status", "order_id",
				"name", "description", "auth_access", "auth_post");

				varRequire("id", "name");

				dbMacro::swapItemOrder("forum_category", $id, $order_id);

				editorApplyFixes($description);

				$db->query ("
				UPDATE ".db_table("forum_category")." SET
					icon = '{$icon}',
					name = '{$name}',
					description = '{$description}',
					status = '{$status}',
					auth_access = '".groups::extractFromInput($auth_access)."',
					auth_post = '".groups::extractFromInput($auth_post)."'
				WHERE id = '{$id}'
				", __FILE__, __LINE__);

				slog("forums: modified category id='$id'", "actions", 1);

			break;
			case "edit_forum":

				varImport("id", "icon", "status", "category_id", "order_id", "name", "description");

				varRequire("id", "category_id", "name");

				dbMacro::swapItemOrder("forum_forum", $id, $order_id);

				editorApplyFixes($description);

				// inserting into database
				$db->query ("
				UPDATE ".db_table("forum_forum")." SET
					category_id = '{$category_id}',
					icon = '{$icon}',
					name = '{$name}',
					description = '{$description}',
					status = '{$status}'
				WHERE id = '{$id}'
				", __FILE__, __LINE__);

				slog("forums: modified forum id='$id'", "actions", 1);
			break;
			case "create_category":

				varImport("icon", "status", "order_id", "name", "description", "auth_access", "auth_post");

				varRequire("name");

				// assigning order id
				$q = $db->query ("SELECT order_id FROM ".db_table("forum_category")."
				ORDER BY order_id ".(($order_id) ? "DESC" : "ASC")." LIMIT 1",
				__FILE__, __LINE__);

				if ($db->numRows($q)) {
					$row = $db->fetchRow($q);
					$order_id = $row["order_id"] + ($order_id ? 1 : -1);
				} else {
					$order_id = 1;
				}

				editorApplyFixes($description);

				$auth_access = groups::extractFromInput($auth_access);
				$auth_post = groups::extractFromInput($auth_post);

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("forum_category")."
					(
						id,
						order_id,
						icon,
						name,
						description,
						status,
						auth_access,
						auth_post
					)
						VALUES
					(
						'".$db->findFreeId("forum_category")."',
						'{$order_id}',
						'{$icon}',
						'{$name}',
						'{$description}',
						'{$status}',
						'{$auth_access}',
						'{$auth_post}'
					)
				", __FILE__, __LINE__);

				// saving preferences
				conf::setkey("forums", "default_auth_access", $auth_access, "s");
				conf::setkey("forums", "default_auth_post", $auth_post, "s");

				slog("forums: created category '$name'", "actions", 1);

			break;
			case "create_forum":
				varImport("icon", "status", "category_id", "order_id", "name", "description");

				varRequire("name", "category_id");

				$q = $db->query ("SELECT order_id FROM ".db_table("forum_forum")."
				ORDER BY order_id ".(($order_id) ? "DESC" : "ASC")." LIMIT 1",
				__FILE__, __LINE__);

				if ($db->numRows($q)) {
					$row = $db->fetchRow($q);
					$order_id = $row["order_id"] + ($order_id ? 1 : -1);
				} else {
					$order_id = 1;
				}

				editorApplyFixes($description);

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("forum_forum")."
					(
						id,
						category_id,
						order_id,
						icon,
						name,
						description,
						messages_count,
						topics_count,
						last_message_id,
						status
					)
						VALUES
					(
						'".$db->findFreeId("forum_forum")."',
						'{$category_id}',
						'{$order_id}',
						'{$icon}',
						'{$name}',
						'{$description}',
						'0',
						'0',
						'0',
						'{$status}'
					)
				", __FILE__, __LINE__);

				slog("forums: created forum '$name'", "actions", 1);
			break;
		}
	}

	switch ($action) {
		case "delete_message":
			if (is_admin() || $auth_edit) {

				varRequire("id");

				$q = $db->query("SELECT topic_id, is_topic
				FROM ".db_table("forum_message")."
				WHERE id = '{$id}'", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					if ($row["is_topic"]) {
						// this message is also a topic, so if we require to
						// delete this message, all messages linked to this
						// topic will be deleted too.

						$db->query("SELECT id FROM ".db_table("forum_message")."
						WHERE topic_id = '{$row["topic_id"]}'", __FILE__, __LINE__);

						if (!is_admin() && $db->numRows()) {

							// an ordinary user cannot delete topics
							abort(accessDenied());

						} elseif (is_admin()) {
							// admin can delete topics

							$db->query("DELETE FROM ".db_table("forum_message")."
							WHERE topic = '{$row["topic_id"]}' OR id = '{$id}'");

							$db->query("DELETE FROM ".db_table("forum_thread")."
							WHERE id = '{$id}'", __FILE__, __LINE__);

							$return = "index.php/module=forums";

							forums::updateThreadStats($row["topic_id"]);

						}
					} else {
						// deleting message
						$db->query("DELETE FROM ".db_table("forum_message")."
						WHERE id = '{$id}' ".(is_admin() ? "" : "AND author_id = '{$row["author_id"]}'")."",
						__FILE__, __LINE__);
					}

				}

				slog("forums: deleted message '$id'", "actions", 1);
			} else {
				abort(accessDenied());
			}
		break;
		case "edit_message":

			varImport("id", "category_id", "forum_id", "topic_id", "nickname", "email", "topic",
			"icon", "content");

			varRequire("id", "category_id", "forum_id", "topic_id", "topic", "content");

			$auth = forums::checkAuth($category_id, $forum_id, $topic_id);

			if ($auth_edit && $auth["post"]) {

				editorApplyFixes($content);

				$db->query("
				UPDATE ".db_table("forum_message")." SET
					".($nickname ? "nickname = '{$nickname}',": "")."
					".($email ? "contact_mail = '{$email}',": "")."
			    	icon = '{$icon}',
					title = '{$topic}',
					content = '{$content}'
				WHERE id = '{$id}' AND topic_id = '{$topic_id}' ".(is_admin() ? "" : " AND author_id = '{$USER["id"]}'")."
				", __FILE__, __LINE__);

				slog("forums: edited message '$id'", "actions", 1);
			} else {
				abort(accessDenied());
			}

		break;
		case "reply_topic":

			// preventing flood
			$AccessTable->load_rule($forum_antiflood, "E_ANTI_FLOOD");

			varImport("category_id", "forum_id", "topic_id", "nickname", "email", "topic", "icon", "content");

			varRequire("category_id", "forum_id", "topic_id", "topic", "content");

			$auth = forums::checkAuth($category_id, $forum_id, $topic_id);

			if ($auth["reply"]) {

				editorApplyFixes($content);

				$db->query("
				INSERT INTO ".db_table("forum_message")." (
					id,
					topic_id,
					icon,
					title,
					content,
					date_created,
					is_topic,
					nickname,
					contact_mail,
					author_id
				) VALUES (
					'".($msg = $db->findFreeId("forum_message"))."',
					'{$topic_id}',
					'{$icon}',
					'{$topic}',
					'{$content}',
					'".time2date()."',
					'0',
					'{$nickname}',
					'{$email}',
					'{$USER["id"]}'
				)",
				__FILE__, __LINE__);

				forums::updateThreadStats($topic_id);

				$return = urlEvalPrototype("index.php/module=forums?path={$category_id}.{$forum_id}.{$topic_id}&page=last#{$msg}", true, false);

				slog("forums: thread replied '$id'", "actions", 2);
			}
		break;
		case "create_topic":

			// antiflood
			$AccessTable->load_rule($forum_antiflood, _l("E_ANTI_FLOOD"));

			varImport("category_id", "forum_id", "nickname", "email", "topic", "icon", "content");

			varRequire("category_id", "forum_id", "topic", "content");

			$auth = forums::checkAuth($category_id, $forum_id);

			if ($auth["post"]) {

				$topic_id = $db->findFreeId("forum_thread");

				$db->query("INSERT INTO ".db_table("forum_thread")." (
						id,
						forum_id,
						stat_reads,
						stat_replies,
						mode_locked,
						mode_sticked
					) VALUES (
						'{$topic_id}',
						'{$forum_id}',
						'0',
						'0',
						'0',
						'0'
					)
				", __FILE__, __LINE__);

				editorApplyFixes($content);

				$db->query("INSERT INTO ".db_table("forum_message")." (
						id,
						topic_id,
						icon,
						title,
						content,
						date_created,
						is_topic,
						nickname,
						contact_mail,
						author_id
					) VALUES (
						'".$db->findFreeId("forum_message")."',
						'{$topic_id}',
						'{$icon}',
						'{$topic}',
						'{$content}',
						'".time2date()."',
						'1',
						'{$nickname}',
						'{$email}',
						'{$USER["id"]}'
					)", __FILE__, __LINE__);

					forums::updateThreadStats($id);

					$return = urlEvalPrototype("index.php/module=forums?path={$category_id}.{$forum_id}.{$topic_id}", true, false);

					slog("forums: new forum thread '$id'", "actions", 2);

			} else {
				abort(accessDenied());
			}

		break;
	}

	redirect($return);

	db_exit();
?>