<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"forums"
	);

	Extract (
		URLGetArgs ("null/action=alpha?path=string&page=page")
	);

	$catid = $frmid = $tpcid = $msgid = 0;

	if ($path) {
		$path = explode(".", preg_replace("/[^0-9\.]/", "", $path));
		if (isset($path[0])) $catid = $path[0];
		if (isset($path[1])) $frmid = $path[1];
		if (isset($path[2])) $tpcid = $path[2];
		if (isset($path[3])) $msgid = $path[3];
	}

	function array_key_prefix(&$arr, $prefix) {
		$buff = Array();
		foreach ($arr as $i => $t)
			$buff[$prefix.strtoupper($i)] = $t;
		$arr = $buff;
	}

	$allowed_categories = forums::getAllowedCategories();

	if ($catid && $frmid) {

		// FORUM VIEW
		forums::updateForumStats($frmid);

		$forum_auth = forums::checkAuth($catid, $frmid);

		// let's have a catid check before this
		if (in_array($catid, $allowed_categories) && $forum_auth["view"]) {

			// gathering generic information
			$q = $db->query("SELECT id, name, icon FROM ".db_table("forum_category")."
			WHERE id = '{$catid}'", __FILE__, __LINE__);

			if ($db->numRows($q)) {
				$category = $db->fetchRow($q);
				saneHTML($category);
				array_key_prefix($category, "CATEGORY_");
			} else {
				redirect("index.php/module=forums&message=".rawurlencode(_l("L_UNEXISTENT_CATEGORY"))."&type=error");
				shutdown();
			}

			$q = $db->query("SELECT id,name, icon FROM ".db_table("forum_forum")."
			WHERE id = '{$frmid}'", __FILE__, __LINE__);

			if ($db->numRows($q)) {
				$forum = $db->fetchRow($q);
				saneHTML($forum);
				array_key_prefix($forum, "FORUM_");
			} else {
				redirect("index.php/module=forums&path={$catid}&message=".rawurlencode(_l("L_UNEXISTENT_FORUM"))."&type=error");
				shutdown();
			}

			if ($tpcid) {
				// TOPIC

				$topic_auth = forums::checkAuth($catid, $frmid, $tpcid);

				$q = $db->query("SELECT t.id, m.title, m.icon
				FROM ".db_table("forum_message")." m, ".db_table("forum_thread")." t
				WHERE m.is_topic = '1' AND m.topic_id = '{$tpcid}' and t.id='$tpcid'",
				__FILE__, __LINE__);

				if ($db->numRows($q)) {
					$topic = $db->fetchRow($q);
					saneHTML($topic);
					array_key_prefix($topic, "TOPIC_");
				} else {
					redirect("index.php/module=forums&path={$catid}.{$frmid}&message=".rawurlencode(_L("L_UNEXISTENT_TOPIC"))."&type=error");
					shutdown();
				}

				switch ($action) {
					case "reply_topic":

						if ($topic_auth["reply"]) {

							$tpl = new ContentBlock();
							$tpl->insert("BLOCK_CONTENT", "forums/main.$action.tpl");

							$tpl->setArray ($category);
							$tpl->setArray ($forum);
							$tpl->setArray ($topic);

							$tpl->setArray (
								Array (
									"BLOCK_TITLE"	=> $topic["TOPIC_TITLE"],
									"BLOCK_ICON"	=> mkIcon("forums.png", 16),
									"NICKNAME"		=> "",
									"TITLE"			=> "Re: ".$topic["TOPIC_TITLE"],
									"ICON"			=> $topic["TOPIC_ICON"],
									"CONTACT_MAIL"	=> "",
									"CONTENT"		=> "",
									"RETURN"		=> "index.php/module=forums?path={$catid}.{$frmid}.{$tpcid}",
									"ACTION"		=> $action,
								)
							);

							// messages summary
							$q = $db->query("SELECT icon, title, content, date_created,
							author_id, nickname, contact_mail
							FROM ".db_table("forum_message")."
							WHERE topic_id = '{$tpcid}'
							ORDER BY date_created ASC", __FILE__, __LINE__);

							while ($row = $db->fetchRow($q)) {

								saneHTML($row, "content");

								format::style($row["content"], $row["author_id"]);

								$row["author"] = forums::mkuserlink($row);

								$tpl->setArray($row, "MESSAGE");
								$tpl->saveBlock("MESSAGE");
							}

							$mcBuff = $tpl->make();

						} else {
							$mcBuff = accessDenied();
						}
					break;
					default:
						if ($msgid) {
							switch ($action) {
								case "edit_message":

									$tpl = new ContentBlock();
									$tpl->insert("BLOCK_CONTENT", "forums/main.$action.tpl");

									// message
									$q = $db->query("SELECT id, title, icon, content, nickname, contact_mail,
									author_id
									FROM ".db_table("forum_message")."
									WHERE id = '{$msgid}' AND topic_id = '{$tpcid}'
									", __FILE__, __LINE__);

									$row = $db->fetchRow($q);
									saneHTML($row, "content");

									format::htmlFilter($row["content"], $row["author_id"]);

									$tpl->setArray ($category);
									$tpl->setArray ($forum);
									$tpl->setArray ($topic);

									$tpl->setArray($row);
									$tpl->setArray (
										Array (
											"BLOCK_TITLE"	=> $topic["TOPIC_TITLE"],
											"BLOCK_ICON"	=> mkIcon("forums.png", 16),
											"ACTION"		=> $action,
											"RETURN"		=> local_referer()."#{$msgid}"
										)
									);

									$mcBuff = $tpl->make();

								break;
								default:
									// PERMALINK

									$q = $db->query("SELECT date_created FROM ".db_table("forum_message")."
									WHERE id='{$msgid}'", __FILE__, __LINE__);

									if ($db->numRows($q)) {

										$row = $db->fetchRow($q);

										$db->query("SELECT id FROM ".db_table("forum_message")."
										WHERE topic_id = '{$tpcid}' AND date_created < '{$row["date_created"]}'",
										__FILE__, __LINE__);

										$page = ($db->numRows($q)+1)/conf::getKey("forums", "messages_per_page");

										if ($page > intval($page))
											$page = intval(++$page);

										redirect("index.php/module=forums?path={$catid}.{$frmid}.{$tpcid}&page=$page#$msgid");
										shutdown();
									} else {
										abort("Unknown permalink.");
									}

								break;
							}
						} else {
							// (no $msgid)

							// TOPIC VIEWING

							$tpl = new ContentBlock();
							$tpl->insert("BLOCK_CONTENT", "forums/main.thread.tpl");

							$pager = $db->pager(
								"SELECT id FROM ".db_table("forum_message")." WHERE
								topic_id = '{$tpcid}'",
								"index.php/module=forums?path={$catid}.{$frmid}.{$tpcid}&page=%p",
								$page, conf::getKey("forums", "messages_per_page")
							);

							// updating statistics
							$db->query("UPDATE ".db_table("forum_thread")." SET
							stat_reads = stat_reads + 1
							WHERE id = '{$tpcid}'", __FILE__, __LINE__);

							// listing messages
							$q = $db->query("SELECT
							id, icon, title, content, date_created, nickname, contact_mail, author_id
							FROM ".db_table("forum_message")."
							WHERE topic_id = '{$tpcid}'
							ORDER BY date_created ASC {$pager["sql"]}", __FILE__, __LINE__);

							while ($row = $db->fetchRow($q)) {

								saneHTML($row, "content");

								format::style($row["content"], $row["author_id"]);

								$row["author"] = forums::mkUserLink($row);

								$row["ACTIONS"] = new tplButtonBox();
								if (forums::messageAuthEdit($row["id"], $row["date_created"], $row["author_id"])) {
									$row["ACTIONS"]->add(mklink("index.php/module=forums/action=edit_message?path={$catid}.{$frmid}.{$tpcid}.{$row["id"]}", _l("L_EDIT"), "edit.png"));
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=delete_message&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
								}
								$row["ACTIONS"] = $row["ACTIONS"]->make();

								$tpl->setArray($row, "MESSAGE");
								$tpl->saveBlock("MESSAGE");
							}

							$q = $db->query("SELECT mode_locked, mode_sticked
								FROM ".db_table("forum_thread")."
								WHERE id = '{$tpcid}'", __FILE__ , __LINE__);
							$row = $db->fetchRow($q);

							saneHTML($row);

							$row["ACTIONS"] = new tplButtonBox();

							if ($topic_auth["reply"])
								$row["ACTIONS"]->add(mklink("index.php/module=forums/action=reply_topic?path={$catid}.{$frmid}.{$tpcid}", _l("L_REPLY"), "reply.png"));

							if (gauth("admin")) {
								// code below used to be difficult to read...

								if ($row["mode_locked"])
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=mode_thread&mode=unlock&id={$tpcid}&auth={C_AUTH_STR}", _l("L_UNLOCK_THREAD"), "unlock.png"));
								else
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=mode_thread&mode=lock&id={$tpcid}&auth={C_AUTH_STR}", _l("L_LOCK_THREAD"), "lock.png"));

								if ($row["mode_sticked"])
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=mode_thread&mode=unstick&id={$tpcid}&auth={C_AUTH_STR}", _l("L_UNSTICK_THREAD"), "unstick.png"));
								else
									$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=mode_thread&mode=stick&id={$tpcid}&auth={C_AUTH_STR}", _l("L_STICK_THREAD"), "stick.png"));

								$row["ACTIONS"]->add(mklink("modules/forums/main.act.php?action=thread_delete&id={$tpcid}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));

								$tpl->set (
									"CATEGORIES.SEL",
										mkSelect (
											forums::getForums(),
											$frmid,
											"category",
											"onchange=\"confirmAction('".urlEvalPrototype("modules/forums/main.act.php?action=thread_move&id={$tpcid}&to='+this.value+'&auth="._l("C_AUTH_STR")."'", true, false).", '"._l("L_MOVE_TOPIC")."')\""
										)
								);
							}
							$row["ACTIONS"] = $row["ACTIONS"]->make();

							$tpl->setArray($forum);
							$tpl->setArray($category);
							$tpl->setArray($topic);
							$tpl->setArray($row);

							$tpl->setArray (
								Array (
									"BLOCK_TITLE"		=> $topic["TOPIC_TITLE"],
									"BLOCK_ICON"		=> mkicon($topic["TOPIC_ICON"]),
									"PAGER"				=> $pager["html"],
									"RETURN"			=> ""
								)
							);

							$mcBuff = $tpl->make();

						} // end of thread
					break;
				}
			} else {
				// (no topic id)
				switch ($action) {
					case "create_topic":
						// TOPIC CREATION
						if ($forum_auth["post"]) {

							$tpl = new ContentBlock();
							$tpl->insert("BLOCK_CONTENT", "forums/main.$action.tpl");

							$tpl->setArray (
								Array (
									"BLOCK_TITLE"	=> _l("L_FORUMS"),
									"BLOCK_ICON"	=> mkIcon("forums.png", 16),
									"ICON"			=> "forums.png",
									"NICKNAME"		=> "",
									"CONTENT"		=> "",
									"CONTACT_MAIL"	=> "",
									"TITLE"			=> "",
									"RETURN"		=> "",
									"ACTION"		=> $action
								)
							);

							$tpl->setArray($category);
							$tpl->setArray($forum);

							$mcBuff = $tpl->make();
						} else {
							$mcBuff = accessDenied();
						}
					break;
					default:
						// THREAD VIEW
						$tpl = new ContentBlock();
						$tpl->insert("BLOCK_CONTENT", "forums/main.forum.tpl");

						$pager = $db->pager(
							"SELECT id FROM ".db_table("forum_thread")." WHERE
							forum_id = '{$frmid}'",
							"index.php/module=forums?path={$catid}.{$frmid}&page=%p",
							$page, conf::getKey("forums", "threads_per_page")
						);

						// topic related to this category
						$q = $db->query("SELECT
						t.id, t.stat_reads, t.stat_replies, t.mode_sticked, t.mode_locked, m.icon,
						m.title, m.date_created,
						m.nickname, m.author_id
						FROM ".db_table("forum_thread")." t, ".db_table("forum_message")." m
						WHERE t.forum_id = '{$frmid}' AND m.topic_id = t.id AND m.is_topic = '1'
						ORDER BY t.mode_sticked DESC, m.date_created DESC {$pager["sql"]}",
						__FILE__, __LINE__);


						while ($row = $db->fetchRow($q)) {

							saneHTML($row);

							// last message for this topic
							$q2 = $db->query("SELECT title, nickname, contact_mail, author_id,
							date_created
							FROM ".db_table("forum_message")."
							WHERE topic_id = '{$row["id"]}'
							ORDER BY date_created DESC LIMIT 1",
							__FILE__, __LINE__, true);

							while ($row2 = $db->fetchRow($q2)) {
								saneHTML($row2);
								$tpl->reset("TOPIC.STATS");

								$row2["LAST_AUTHOR"] = forums::mkUserLink($row2);

								$tpl->setArray($row2, "TOPIC.STATS");
								$tpl->saveBlock("TOPIC.STATS");
							}

							$tpl->setArray($category, "TOPIC");
							$tpl->setArray($forum, "TOPIC");

							$tpl->setArray($row, "TOPIC");
							$tpl->saveBlock("TOPIC");
						}

						// actions
						$actions = new tplButtonBox();
						if ($forum_auth["post"]) {
							$actions->add(mklink("index.php/module=forums/action=create_topic?path={$catid}.{$frmid}", _l("L_NEW_TOPIC"), "new.png"));
						}

						$tpl->setArray($category);
						$tpl->setArray($forum);

						$tpl->setArray (
							Array (
								"BLOCK_TITLE"		=> _l("L_VIEW_FORUM"),
								"BLOCK_ICON"		=> mkicon($forum["FORUM_ICON"]),
								"ACTIONS"			=> $actions->make(),
								"PAGER"				=> $pager["html"]
							)
						);

						$mcBuff = $tpl->make();
					break;
				}
			}
		} else {
			$mcBuff = accessDenied();
		}
	} else {

		// SHOWING A LIST OF FORUMS INSIDE CATEGORIES
		$tpl = new ContentBlock();
		$tpl->insert("BLOCK_CONTENT", "forums/main.default.tpl");

		// querying for categories
		$q = $db->query("SELECT id, icon, name, description
		FROM ".db_table("forum_category")."
		WHERE (".forums::getAllowedCategories(true, "id").") ".($catid ? "AND id = '{$catid}'" : "")."
		ORDER BY order_id ASC",
		__FILE__, __LINE__);

		while ($row = $db->fetchRow($q)) {

			saneHTML($row, "description");

			// listing forums for this category
			$q2 = $db->query("SELECT id, icon, category_id, name, description,
			messages_count, topics_count, last_message_id
			FROM ".db_table("forum_forum")."
			WHERE category_id = '{$row["id"]}' AND status = '1'
			ORDER BY order_id ASC",
			__FILE__, __LINE__);

			$tpl->reset("CATEGORY.FORUM");

			if ($db->numRows($q2)) {

				while ($row2 = $db->fetchRow($q2)) {

					saneHTML($row2, "description");

					$q3 = $db->query("SELECT id, topic_id, title, date_created,
					author_id, nickname, contact_mail
					FROM ".db_table("forum_message")."
					WHERE id = '{$row2["last_message_id"]}'", __FILE__, __LINE__, true);

					if ($db->numRows($q3)) {
						$tpl->reset("CATEGORY.FORUM.STATS");

						$row3 = $db->fetchRow($q3);
						saneHTML($row3);

						$tpl->setArray (
							Array (
								"LAST_TOPIC"	=> mkLink("index.php/module=forums?path={$row["id"]}.{$row2["id"]}.{$row3["topic_id"]}?page=last#{$row3["id"]}", $row3["title"]),
								"LAST_AUTHOR"	=> forums::mkuserlink($row3),
								"LAST_DATE"		=> dateFormat($row3["date_created"])
							)
						, "CATEGORY.FORUM.STATS");

						$tpl->saveBlock("CATEGORY.FORUM.STATS");
					}
					$row2["STATUS_ICON"] = "open.png";

					$tpl->setArray($row2, "CATEGORY.FORUM");
					$tpl->saveBlock("CATEGORY.FORUM");
				}

				$tpl->setArray($row, "CATEGORY");

				$tpl->saveBlock("CATEGORY");
			}

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_FORUMS"),
					"BLOCK_SUBTITLE"	=> _l("L_CATEGORIES_INDEX"),
					"BLOCK_ICON"		=> mkicon("forums.png")
				)
			);

			$mcBuff = $tpl->make();
		}
	}

?>