<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class gekkoModule_Forums {
		function create_menu() {
			return false;
		}
		function configure() {
			conf::getKey("forums", "edit_time", 600, "i");
			conf::getKey("forums", "threads_per_page", 20, "i");
			conf::getKey("forums", "messages_per_page", 30, "i");
			conf::getKey("forums", "default_auth_access", "*", "s");
			conf::getKey("forums", "default_auth_post", "$", "s");
		}
		function install() {
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("forum_category")." (
				id TINYINT (3) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (id),
				order_id SMALLINT (5) NOT NULL default '0',
				icon VARCHAR (255) NOT NULL default 'category.png',

				name VARCHAR (255),
				description TEXT,
				status ENUM('0','1') NOT NULL default '1',

				auth_access VARCHAR (255) NOT NULL default '*',
				auth_post VARCHAR (255) NOT NULL default '$'
			)
			", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("forum_forum")." (
				id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (id),
				category_id TINYINT (3) UNSIGNED NOT NULL,

				order_id SMALLINT (5) NOT NULL default '0',
				icon VARCHAR (255) NOT NULL default 'forum.png',

				name VARCHAR (255),
				description TEXT,

				messages_count INT (11) UNSIGNED NOT NULL,
				topics_count INT (11) UNSIGNED NOT NULL,
				last_message_id INT (10) UNSIGNED NOT NULL,

				status ENUM('0','1') NOT NULL default '1'
			)
			", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("forum_thread")." (
				id MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (id),
				forum_id SMALLINT (5) UNSIGNED NOT NULL,
				stat_reads SMALLINT (5) UNSIGNED NOT NULL,
				stat_replies SMALLINT (5) UNSIGNED NOT NULL,
				mode_locked  ENUM('0','1') NOT NULL default '0',
				mode_sticked  ENUM('0','1') NOT NULL default '0'
			)
			", __FILE__, __LINE__, true);


			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("forum_message")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (id),

				topic_id MEDIUMINT (8) UNSIGNED NOT NULL,

				icon VARCHAR (255) NOT NULL default 'message.png',
				title VARCHAR (255),
				content TEXT,

				is_topic ENUM('0','1') NOT NULL default '0',

				date_created DATETIME NOT NULL,
				date_modified TIMESTAMP,

				nickname VARCHAR (32),
				contact_mail VARCHAR (64),

				author_id MEDIUMINT (8) UNSIGNED NOT NULL
			)
			", __FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["forums"], "forums", "*", $GLOBALS["cgdb"]["forums"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("forum_category"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("forum_forum"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("forum_thread"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("forum_message"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			$db =& $GLOBALS["db"];

			if (Packages::checkVersion("0.5.10", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("forum_category")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("forum_forum")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("forum_thread")."
				CHANGE COLUMN mode_locked mode_locked ENUM('0','1') NOT NULL default '0',
				CHANGE COLUMN mode_sticked mode_sticked ENUM('0','1') NOT NULL default '0'",
				__FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("forum_message")."
				CHANGE COLUMN is_topic is_topic ENUM('0','1') NOT NULL default '0'",
				__FILE__, __LINE__);
			}

			if (packages::checkVersion("0.6.4", $provided_v) < 0) {

				$db->query("ALTER TABLE ".db_table("forum_category")."
				CHANGE COLUMN orderid order_id SMALLINT (5) NOT NULL default '0'
				", __FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("forum_forum")."
				CHANGE COLUMN categoryid category_id TINYINT (3) UNSIGNED NOT NULL,
				CHANGE COLUMN orderid order_id SMALLINT (5) NOT NULL default '0',
				CHANGE COLUMN messagecount messages_count INT (11) UNSIGNED NOT NULL,
				CHANGE COLUMN topiccount topics_count INT (11) UNSIGNED NOT NULL,
				CHANGE COLUMN lastpostid last_message_id INT (10) UNSIGNED NOT NULL
				", __FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("forum_thread")."
				CHANGE COLUMN forumid forum_id SMALLINT (5) UNSIGNED NOT NULL
				", __FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("forum_message")."
				CHANGE COLUMN topicid topic_id MEDIUMINT (8) UNSIGNED NOT NULL,
				CHANGE COLUMN userid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				CHANGE COLUMN contactmail contact_mail VARCHAR (64),
				ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER creationtime,
				ADD COLUMN date_modified TIMESTAMP(19) AFTER date_created
				", __FILE__, __LINE__);

				$db->query("UPDATE ".db_table("forum_message")." SET date_created = FROM_UNIXTIME(creationtime)", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("forum_message")."
					DROP COLUMN creationtime
				", __FILE__, __LINE__, true);
			}
		}
		function ext_uninstall($module) {

		}
	}

?>