<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"gallery"
	);

	Extract (
		URLGetArgs("null/null/action=alpha?id=int&page=page&gallery=int")
	);

	switch ($action) {
		case "edit_item":

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "gallery/admin.$action.tpl");

			$q = $db->query("SELECT id, gallery_id, title, description,
			thumbnail_url, thumbnail_size, media_url, media_size, author_id,
			date_modified, date_created, allow_comments
			FROM ".db_table("gallery_item")." WHERE id = '{$id}'", __FILE__, __LINE__);

			$row = $db->fetchRow($q);

			saneHTML($row, "description");
			format::htmlFilter($row["description"], $row["author_id"]);

			$tpl->setArray($row);

			$q = $db->query("SELECT id, title
			FROM ".db_table("gallery")." WHERE id = '{$row["gallery_id"]}'",
			__FILE__, __LINE__);

			$row = $db->fetchRow($q);

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=gallery", _l("L_GALLERY"), "gallery.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> $row["title"],
					"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
					"ACTION"			=> $action,
					"ACTIONS"			=> $actions,
					"RETURN"			=> "index.php/module=admin/base=gallery/action=view_items&gallery={$row["id"]}"
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "view_items":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/admin.view_items.tpl");

			$pager = $db->pager (
				"SELECT id FROM ".db_table("gallery_item")." WHERE gallery_id = '{$id}'",
				"index.php/module=admin/base=gallery/action=view_items?gallery={$id}&page=%p#items",
				$page, conf::getkey("gallery", "items_per_admin_page", 20, 'i')
			);

			$q = $db->query("SELECT id, title, description, thumbnail_url, thumbnail_size,
			media_url, allow_comments, date_modified, author_id
			FROM ".db_table("gallery_item")."
			WHERE gallery_id = '{$gallery}' ORDER BY title ASC {$pager["sql"]}",
			__FILE__, __LINE__);

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=gallery", _l("L_GALLERY"), "gallery.png"));
			$actions = $actions->make();

			while ($row = $db->fetchRow($q)) {

				saneHTML($row, "description");
				format::style($row["description"], $row["author_id"]);

				list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

				$row["ACTIONS"] = new tplButtonBox();
					$row["ACTIONS"]->add(mklink("index.php/module=admin/base=gallery/action=edit_item?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
					$row["ACTIONS"]->add(mklink("modules/gallery/main.act.php?action=delete_item&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
				$row["ACTIONS"] = $row["ACTIONS"]->make();

				$tpl->setArray($row, "ITEM");
				$tpl->saveBlock("ITEM");
			}

			$q = $db->query("SELECT title FROM ".db_table("gallery")."
			WHERE id = '{$id}'", __FILE__, __LINE__);
			$row = $db->fetchRow($q);

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> $row["title"],
					"BLOCK_SUBTITLE"	=> _l("L_ADD_ITEM"),
					"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
					"TITLE"				=> "",
					"ACTION"			=> "create_item",
					"DESCRIPTION"		=> "",
					"GALLERY_ID"		=> $gallery,
					"ACTIONS"			=> $actions,
					"PAGER"				=> $pager["html"],
					"ALLOW_COMMENTS"		=> true,
					"RETURN"			=> "index.php/module=admin/base=gallery/action=view_items?gallery=$gallery"
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "import_items":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/admin.$action.tpl");

			$q = $db->query("SELECT title FROM ".db_table("gallery")."
			WHERE id = '{$id}'", __FILE__, __LINE__);
			$row = $db->fetchRow($q);

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> $row["title"],
					"BLOCK_SUBTITLE"	=> _l("L_IMPORT"),
					"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
					"TITLE"				=> "",
					"ACTION"			=> $action,
					"DESCRIPTION"		=> "",
					"GALLERY_ID"		=> $gallery,
					"ALLOW_COMMENTS"		=> true,
					"RETURN"			=> "index.php/module=admin/base=gallery/action=view_items?gallery=$gallery"
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "edit_gallery":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/admin.edit_gallery.tpl");

			// fetching associated galleries
			$q = $db->query("SELECT
			id, title, description, status, thumbnail_url, thumbnail_size, author_id,
			date_modified
			FROM ".db_table("gallery")."
			WHERE gallery_id = '{$id}'", __FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {

				saneHTML($row, "description");
				format::htmlFilter($row["description"], $row["author_id"]);

				list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

				$row["ACTIONS"] = new tplButtonBox();
					$row["ACTIONS"]->add(mklink("index.php/module=admin/base=gallery/action=edit_gallery?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
					$row["ACTIONS"]->add(mklink("modules/gallery/main.act.php?action=delete_gallery&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					if (!$row["status"])
						$row["ACTIONS"]->add(mklink("modules/gallery/main.act.php?action=enable_gallery&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_ENABLE"), "enable.png"));
				$row["ACTIONS"] = $row["ACTIONS"]->make();

				$tpl->setArray($row, "GALLERY");
				$tpl->saveBlock("GALLERY");
			}

			$q = $db->query("SELECT
			id, gallery_id, title, description, status, thumbnail_url,
			thumbnail_size, author_id, date_modified, auth_access
			FROM ".db_table("gallery")." WHERE id = '{$id}'
			", __FILE__, __LINE__);

			$row = $db->fetchRow($q);
			saneHTML($row, "description");

			format::style($row["description"], $row["author_id"]);

			list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=gallery", _l("L_GALLERIES"), "gallery.png"));
				$actions->add(mklink("index.php/module=admin/base=gallery/action=view_items?gallery={$row["id"]}", _l("L_VIEW_ITEMS"), "new.png"));
				$actions->add(mklink("index.php/module=admin/base=gallery/action=import_items?gallery={$row["id"]}", _l("L_IMPORT_PACKAGE"), "compressed.png"));
				$actions->add(mklink("modules/gallery/main.act.php?action=delete_gallery&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
				if (!$row["status"])
					$actions->add(mklink("modules/gallery/main.act.php?action=enable_gallery&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_ENABLE"), "unlock.png"));
			$actions = $actions->make();

			$tpl->setArray ($row);

			$tpl->setArray (
				Array (
					"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
					"BLOCK_TITLE"		=> $row["title"],
					"BLOCK_SUBTITLE"	=> _l("L_EDIT"),
					"ACTION"			=> $action,
					"ACTIONS"			=> $actions,
					"RETURN"			=> "index.php/module=admin/base=gallery"
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "create_gallery":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/admin.$action.tpl");

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=gallery", _l("L_GALLERY"), "gallery.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
					"BLOCK_TITLE"		=> _l("L_GALLERY"),
					"STATUS"			=> 1,
					"ID"				=> 0,
					"GALLERY_ID"		=> 0,
					"ACTION"			=> $action,
					"TITLE"				=> "",
					"DESCRIPTION"		=> "",
					"ACTIONS"			=> $actions,
					"THUMBNAIL_URL"		=> "",
					"AUTH_ACCESS"		=> "*",
					"RETURN"			=> "index.php/module=admin/base=gallery"
				)
			);
			$mcBuff = $tpl->make();

		break;
		default:

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/admin.default.tpl");

			$q = $db->query("SELECT
			id, title, description, status, thumbnail_url, thumbnail_size, author_id,
			date_modified
			FROM ".db_table("gallery")."
			WHERE gallery_id = '0' ORDER BY title ASC", __FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {

				saneHTML($row, "description");

				format::style($row["description"], $row["author_id"]);

				list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnail_size"]);

				$row["ACTIONS"] = new tplButtonBox();
					$row["ACTIONS"]->add(mklink("index.php/module=admin/base=gallery/action=import_items?gallery={$row["id"]}", _l("L_IMPORT_PACKAGE"), "compressed.png"));
					$row["ACTIONS"]->add(mklink("index.php/module=admin/base=gallery/action=view_items?gallery={$row["id"]}", _l("L_ITEMS"), "new.png"));
					$row["ACTIONS"]->add(mklink("index.php/module=admin/base=gallery/action=edit_gallery?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
					$row["ACTIONS"]->add(mklink("modules/gallery/main.act.php?action=delete_gallery&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));

				if (!$row["status"])
					$row["ACTIONS"]->add(mklink("modules/gallery/main.act.php?action=enable_gallery&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_ENABLED"), "toggle.png"));
				$row["ACTIONS"] = $row["ACTIONS"]->make();

				$row["LINK"] = urlEvalPrototype("index.php/module=admin/base=gallery/action=edit_gallery?id={$row["id"]}");

				$tpl->setArray($row, "GALLERY");
				$tpl->saveBlock("GALLERY");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=gallery/action=create_gallery", _l("L_CREATE_ALBUM"), "new.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
					"BLOCK_TITLE"		=> _l("L_GALLERY"),
					"ACTIONS"			=> $actions
				)
			);
			$mcBuff = $tpl->make();
		break;
	}

?>