<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	define("GEKKO_GALLERY_REL_DATADIR", "data/gallery");
	define("GEKKO_GALLERY_ABS_DATADIR", GEKKO_USER_DIR.GEKKO_GALLERY_REL_DATADIR);

	LoadLib (
		"file.lib.php", "categories"
	);

	mkworkdir(GEKKO_GALLERY_ABS_DATADIR);

	Class Gallery {
		function createItemLink($id, $only_url = false, $custom_url = null) {

			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT title FROM ".db_table("gallery_item")."
			WHERE id='{$id}'",
			__FILE__, __LINE__, true);

			if ($db->numRows($q)) {
				$row = $db->fetchRow($q);
				$row["icon"] = "gallery.png";
				if ($only_url) {
					return urlEvalPrototype("index.php/module=gallery/action=view/title=".urlTitleEncode($row["title"])."?id=$id");
				} else {
					return mkicon($row["icon"], 16)." ".mklink($custom_url ? $custom_url :"index.php/module=gallery/action=view/title=".urlTitleEncode($row["title"])."?id=$id", $row["title"]);
				}
			}
			return false;
		}
		function proccessSearch($query_id, $limit = -1) {
			$db =& $GLOBALS["db"];

			$data = Array();

			for ($i = 0; ($limit < 0 || $i < $limit) && $row = $db->fetchRow($query_id); $i++) {

				list($width, $height) = explode("x", $row["thumbnail_size"]);

				$row["image"] = "<img class=\"photo\" src=\""._l("C_SITE.REL_URL")."{$row["thumbnail_url"]}\" width=\"$width\" height=\"$height\" alt=\"{$row["title"]}\" title=\"{$row["title"]}\" />";

				$row["title"] = mklink("index.php/module=gallery/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}", $row["title"]);

				if (gauth("gallery")) {
					$row["actions"] = new tplButtonBox();
						$row["actions"]->add(mklink("index.php/module=admin/base=gallery/action=item?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
						$row["actions"]->add(mklink("modules/gallery/main.act.php?action=delete_item&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$row["actions"] = $row["actions"]->make();
				}
				$row["icon"] = "gallery.png";

				$data[] = $row;
			}
			return $data;
		}
		/**
		* getPossibleGalleryStatus()
		* @returns: a human readable array of possible gallery status
		*/
		function getPossibleGalleryStatus() {
			$tmp = Array(_l("L_DISABLE"), _l("L_ENABLE"));
			return $tmp;
		}
		/**
		* guessMediaType(filename);
		* @returns: General file type based on extension
		*/
		function guessMediaType($file) {
			switch (file_extension($file)) {
				case "jpg": case "jpeg": case "gif": case "png": case "xpm": case "tiff":
					$type = "image";
				break;
				case "swf":
					$type = "flash";
				break;
				default:
					$type = "unknown";
				break;
			}
			return $type;
		}
		/**
		* getGalleries([gallery_id])
		* @returns: An array of galleries in which gallery_id can be placed
		*/
		function getGalleries($gallery_id = 0) {
			$return = Array();

			$db =& $GLOBALS["db"];

			$return[] = "("._l("L_MAIN").")";

			$q = $db->query("SELECT id, title, gallery_id
			FROM ".db_table("gallery")."
			".($gallery_id ? "WHERE id != '{$gallery_id}'" : "")."
			ORDER BY title ASC",
			__FILE__, __LINE__, true);

			if ($db->numRows($q)) {
				while ($row = $db->fetchRow($q)) {
					saneHTML($row);
					$buff[$row["id"]] = $row;
				}

				foreach ($buff as $i => $b) {
					// asociating children galleries
					if (isset($buff[$b["gallery_id"]])) {
						$buff[$i]["title"] = $buff[$b["gallery_id"]]["title"]." &raquo; ".$buff[$i]["title"];
					}
				}

				usort($buff, create_function('$a,$b', 'return strcmp($a["title"], $b["title"]);'));

				while(list($i) = each($buff))
					$return[$buff[$i]["id"]] = $buff[$i]["title"];

			}
			return $return;
		}

		/**
		* deleteGallery(gallery_id)
		*/
		function deleteGallery($id) {
			$db =& $GLOBALS["db"];

			// deleting associated subgalleries
			$q = $db->query("SELECT id FROM ".db_table("gallery")."
			WHERE gallery_id = '{$id}'", __FILE__, __LINE__, true);
			while ($row = $GLOBALS["db"]->fetchRow($q)) {
				Gallery::deleteGallery($row["id"]);
			}

			// deleting associated items
			$q = $GLOBALS["db"]->query("SELECT id FROM ".db_table("gallery_item")."
			WHERE gallery_id = '{$id}'", __FILE__, __LINE__, true);
			while ($row = $db->fetchRow($q)) {
				Gallery::deleteItem($row["id"]);
			}

			// deleting thumbnail_url
			$q = $db->query("SELECT thumbnail_url FROM ".db_table("gallery")."
			WHERE id = '{$id}'", __FILE__, __LINE__, true);
			$r = $db->fetchRow($q);

			@unlink(GEKKO_USER_DIR.$row["thumbnail_url"]);

			slog("gallery: deleted gallery id='$id'", "actions", 1);

			return $db->query ("DELETE FROM ".db_table("gallery")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}
		/**
		* deleteItem(item_id);
		*/
		function deleteItem($id) {
			LoadLib ("comments");

			$db =& $GLOBALS["db"];

			// deleting comments
			Comments::deleteItems("gallery", $id);

			// deleting files associates with this item such as its thumbnail and media location
			$q = $db->query("SELECT thumbnail_url, media_url
			FROM ".db_table("gallery_item")." WHERE id = '{$id}'", __FILE__, __LINE__, true);
			$r = $db->fetchRow($q);

			@unlink(GEKKO_USER_DIR.$r["thumbnail_url"]);
			@unlink(GEKKO_USER_DIR.$r["media_url"]);

			slog("gallery: deleted galley item id='$id'", "actions", 1);

			return $db->query ("DELETE FROM ".db_table("gallery_item")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* setGalleryStatus(gallery_id, status);
		*/
		function setGalleryStatus($id, $status) {
			slog("gallery: status of id='$id' changed to '$status'", "actions", 2);
			return $db->query ("UPDATE ".db_table("gallery")." SET status = '{$status}' WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* countGalleries([gallery_id])
		* @returns: number of galleries associated to gallery_id. If gallery_id = 0,
		* then returns number of main galleries.
		*/
		function countGalleries($id = 0) {
			$db =& $GLOBALS["db"];
			$q = $db->query("SELECT id FROM ".db_table("gallery")."
			WHERE gallery_id = '{$id}'", __FILE__, __LINE__, true);
			return intval($db->numRows($q));
		}

		/**
		* countItems([gallery_id]);
		* @returns: number or items associated to gallery_id
		*/
		function countItems($id = 0) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT id FROM ".db_table("gallery_item")."
			WHERE gallery_id = '{$id}'", __FILE__, __LINE__,
			true);

			return intval($db->numRows($q));
		}
		/**
		* getAllowedGalleries([gallery]);
		* @returns: Allowed (sub)categories. If gallery < 0, then returns all possible galleries
		* where the current user is allowed to access.
		*/
		function getAllowedGalleries($gallery = 0) {
			$allowed = Array();

			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT id, auth_access
			FROM ".db_table("gallery")."
			WHERE ".($gallery == 0 ? "" : "gallery_id = '{$gallery}' AND")." status = '1'",
			__FILE__, __LINE__, true);

			while ($row = $db->fetchRow($q))
				if (gauth($row["auth_access"]))
					$allowed[] = $row["id"];

			return $allowed;
		}
		function getNextItem($id) {
			return gallery::getRelativeItem($id, '>');
		}
		function getPrevItem($id) {
			return gallery::getRelativeItem($id, '<');
		}
		function getRelativeItem($id, $comp = '>') {
			$db =& $GLOBALS["db"];
			$q = $db->query("SELECT h.id, h.title
			FROM ".db_table("gallery_item")." h, ".db_table("gallery_item")." o
			WHERE h.title {$comp} o.title AND o.id = '{$id}'",
			__FILE__, __LINE__, true);
			if ($db->numRows($q)) {
				$row = $db->fetchRow($q);
				return urlEvalPrototype("index.php/module=gallery/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}");
			}
			return "";
		}
		function allowComment($thread) {
			$db =& $GLOBALS["db"];

			// item existence
			$q = $db->query("SELECT gallery_id
			FROM ".db_table("gallery_item")."
			WHERE id = '{$thread}' AND allow_comments = '1'",
			__FILE__, __LINE__, true);
			$row = $db->fetchRow($q);

			// does this user have access to this item?
			$q = $db->query("SELECT auth_access FROM ".db_table("gallery")."
			WHERE id = '{$row["gallery_id"]}' AND status = '1'");
			$row = $db->fetchRow($q);

			return $db->numRows($q) ? gauth($row["auth_access"]) : false;
		}
	}

?>