<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	class gekkoModule_Glossary {
		function create_menu() {
			return true;
		}
		function configure() {
			conf::getKey("glossary", "items_per_admin_page", 20, "i");
		}
		function install() {
			$db =& $GLOBALS["db"];
			$db->query("
			CREATE TABLE ".db_table("glossary")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (id),
				term VARCHAR (128),
				url VARCHAR (128),
				author_id SMALLINT (8) UNSIGNED NOT NULL,
				description TEXT,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP(19)
			)", __FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["glossary"], "glossary", "*", $GLOBALS["cgdb"]["glossary"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("glossary"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			$db =& $GLOBALS["db"];
			// last
			if (packages::checkVersion("0.6.3", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("glossary")."
				CHANGE COLUMN authorid author_id SMALLINT (8) UNSIGNED NOT NULL,
				ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER description,
				ADD COLUMN date_modified TIMESTAMP(19) AFTER date_created
				", __FILE__, __LINE__, true);
			}
		}
		function ext_uninstall($module) {

		}
	}
?>