<?php
	/*
	*	Gekko - Open Source Web Content Management System
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, Josu�Gerardo Guti�rez Hdez. <blacknash@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		Josue Gerardo Gutierrez Hdez. <blacknash@users.sf.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	class gekkoModule_Memos {
		function create_menu() {
			return true;
		}
		function configure() {
			conf::getKey("memos", "items_per_admin_page", 10, "i");
		}
		function install() {
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("memos")." (
				id MEDIUMINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (id),
				event VARCHAR (128),
				category SMALLINT (5) UNSIGNED NOT NULL,
				date DATETIME NOT NULL,
				timefordate DATETIME NOT NULL,
				description TEXT,
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				typeofrepeat SMALLINT(1) NOT NULL DEFAULT 0
			)", __FILE__, __LINE__, true);
			gekkoModule::register($GLOBALS["cgdb"]["memos"], "memos", "*", $GLOBALS["cgdb"]["memos"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("memos"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			$db =& $GLOBALS["db"];
			if (Packages::checkVersion("0.6.3", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("memos")."
					ADD COLUMN typeofrepeat SMALLINT(1) NOT NULL default 0,
					CHANGE COLUMN timefordate timefordate_ago INT(11) UNSIGNED NOT NULL,
					CHANGE COLUMN date date_ago INT(11) UNSIGNED NOT NULL,
					CHANGE COLUMN userid author_id MEDIUMINT(8) UNSIGNED NOT NULL,
					ADD COLUMN timefordate DATETIME NOT NULL AFTER category,
					ADD COLUMN date DATETIME NOT NULL AFTER timefordate
				",__FILE__,__LINE__,true);

				$db->query("UPDATE ".db_table("memos")." SET
				timefordate = FROM_UNIXTIME(timefordate_ago),
				date = FROM_UNIXTIME(date_ago)", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("memos")."
				DROP COLUMN timefordate_ago,
				DROP COLUMN date_ago", __FILE__, __LINE__, true);
			}
		}
		function ext_uninstall($module) {

		}
	}

?>