<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	Loadlib("messages", "users");

	require_once GEKKO_SOURCE_DIR."lib/auth.inc.php";

	varImport("action", "return", "id");

	switch ($action) {
		case "send":

			varImport("to_id", "to_name", "subject", "message");

			varRequire("to_id", "subject");

			if ($to_name)
				$to_id = users::getID($to_name);

			// checking for user existence
			$q = $db->query("SELECT id FROM ".db_table("user")." WHERE id='{$to_id}'",
			__FILE__, __LINE__);

			if ($db->numRows($q)) {

				// checking message size
				$msglen = strlen($message);

				if ($msglen > conf::getkey("messages", "message_size_limit"))
					formInputError("{E_SIZE_EXCEEDED}", "focus: message");

				// checking inbox capacity
				if (($msglen + messages::getInboxSize($to_id)) > conf::getkey("messages", "message_size_limit"))
					formInputError("{L_USER_INBOX_IS_FULL}", "focus: to");

				// antiflood
				$AccessTable->load_rule (
					$AccessTable->set_generic_rule("messages", "post"),
					"E_ANTI_FLOOD"
				);

				editorApplyFixes($message);

				$db->query ("
					INSERT INTO ".db_table("messages")."
					(
						id,
						to_id,
						from_id,
						subject,
						message,
						date_created,
						size
					)
						VALUES
					(
						'".$db->findFreeId("messages")."',
						'{$to_id}',
						'{$USER["id"]}',
						'{$subject}',
						'{$message}',
						'".time2date()."',
						'{$msglen}'
					)",
					__FILE__, __LINE__);
			}
		break;
		case "delete":
			varRequire("id");
			execWithEach($id, "messages::deleteItem");
			$return = "index.php/module=messages";
		break;
	}

	redirect($return);

	db_exit();
?>