<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Extract (
		URLGetArgs('/null/action=alpha/to=alpha?id=int&page=int')
	);

	LoadLib("file.lib.php", "chart.lib.php", "messages");

	switch ($action) {
		case "view":
			if ($id) {

				$q = $db->query ("
				SELECT
					subject, to_id, from_id, message, date_created
				FROM ".db_table("messages")."
				WHERE id='$id' AND to_id = '{$USER["id"]}'
				", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "messages/main.view.tpl");

					$row = $db->fetchRow($q);

					saneHTML($row, "message");
					format::style($row["message"], $row["from_id"]);

					$actions = new tplButtonBox();
						$actions->add(mklink("index.php/module=messages/action=reply?id={$id}", _l("L_REPLY"), "reply.png"));
						$actions->add(mklink("modules/messages/main.act.php?action=delete&id={$id}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$actions = $actions->make();

					$tpl->setArray($row);
					$tpl->setArray (
						Array (
							"BLOCK_TITLE"	=> _l("L_MESSAGES"),
							"BLOCK_ICON"	=> mkicon("messages.png"),
							"ACTIONS"		=> $actions
						)
					);

					$mcBuff = $tpl->make();

					$db->query("UPDATE ".db_table("messages")." SET readmsg = '1'
					WHERE id='{$id}'", __FILE__, __LINE__);

				}
			}
		break;
		case "compose":
			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "messages/main.compose.tpl");

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=messages", _l("L_MESSAGES"), "messages.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"TO"			=> users::getid($to),
					"SUBJECT"		=> "",
					"MESSAGE"		=> "",
					"ACTION"		=> "send",
					"BLOCK_TITLE"	=> _l("L_MESSAGES"),
					"ACTIONS"		=> $actions,
					"RETURN"		=> "index.php/module=messages",
					"BLOCK_ICON"	=> mkicon("edit.png")
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "reply":
			if ($id) {

				$q = $db->query ("
				SELECT
					subject, to_id, from_id, message, date_created
				FROM ".db_table("messages")."
				WHERE id='$id' AND to_id='{$USER["id"]}'
				", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					saneHTML($row, "message");

					format::htmlFilter($row["message"], $row["from_id"]);

					$filter = new GekkoHtmlFilter(cacheFunc("users::fetchInfo", $row["from_id"], "groups"));
					$row["message"] = $filter->applyFilters($row["message"]);
					$row["message"] = "<br />".preg_replace("/(^|<br>)/s", "<br />&gt; ", $row["message"]);
					$row["subject"] = "Re: {$row["subject"]}";

					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "messages/main.reply.tpl");

					$tpl->setArray ($row);

					$actions = new tplButtonBox();
						$actions->add(mklink("index.php/module=messages", _l("L_MESSAGES"), "messages.png"));
					$actions = $actions->make();

					$tpl->setArray (
						Array (
							"BLOCK_TITLE"	=> _l("L_MESSAGES"),
							"BLOCK_ICON"	=> mkicon("messages.png", 16),
							"TO"		=> $row["from_id"],
							"ACTION"	=> "send",
							"ACTIONS"	=> $actions,
							"RETURN"	=> "index.php/module=messages"
						)
					);

					$mcBuff = $tpl->make();
				}
			}
		break;
		default:

			$pager = $db->pager (
				"SELECT id FROM ".db_table("messages")."
				WHERE to_id = '{$USER["id"]}'",
				"index.php/module=messages?page=%p", $page,
				conf::getkey("messages", "items_per_page")
			);

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "messages/main.default.tpl");

			$q = $db->query ("
			SELECT
				id, date_created, subject, from_id, size, readmsg
			FROM ".db_table("messages")."
			WHERE to_id = '{$USER["id"]}'
			ORDER BY date_created DESC {$pager['sql']}
			", __FILE__, __LINE__);

			$inbox_size = 0;
			if ($db->numRows($q)) {
				while ($row = $db->fetchRow($q)) {
					saneHTML($row);
					$row["subject"] = mklink("index.php/module=messages/action=view?id={$row["id"]}", $row["subject"]);
					$tpl->setArray($row, "MESSAGE");
					$tpl->saveBlock("MESSAGE");
					$inbox_size += $row["size"];
				}
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=messages/action=compose", _l("L_COMPOSE"), "new.png"));
			$actions = $actions->make();

			$chart = new Chart("300px");
			$item_id = $chart->createItem(_l("L_INBOX_SIZE"));
			$chart->addItemNode($item_id, $inbox_size);
			$chart->setTotal('', conf::getkey("messages", "inbox_size"));
			$chart = $chart->make(false);

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"	=> _l("L_MESSAGES"),
					"BLOCK_ICON"	=> mkicon("messages.png"),
					"ACTIONS"		=> $actions,
					"CHART"			=> $chart,
					"PAGER"			=> $pager["html"]
				)
			);

			$mcBuff = $tpl->make();

		break;
	}
?>