<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	class gekkoModule_Messages {
		function create_menu() {
			return true;
		}
		function configure() {
			conf::getKey("messages", "inbox_size", 300*1024, "i");
			conf::getKey("messages", "message_size_limit", 1024*30);
			conf::getKey("messages", "items_per_page", 20, "i");
		}
		function install() {

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("messages")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (id),
				from_id SMALLINT (8) UNSIGNED NOT NULL,
				to_id SMALLINT (8) UNSIGNED NOT NULL,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				subject VARCHAR (255),
				message TEXT,
				size SMALLINT (5),
				readmsg ENUM('0','1') NOT NULL default '0'
			)", __FILE__, __LINE__, true);

			// 5160720

			gekkoModule::register($GLOBALS["cgdb"]["messages"], "messages", "$", $GLOBALS["cgdb"]["messages"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("messages"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {

			$db =& $GLOBALS["db"];

			if (packages::checkVersion("0.6.3", $provided_v) < 0) {

				$db->query("ALTER TABLE ".db_table("messages")."
					CHANGE COLUMN fromid from_id SMALLINT (8) UNSIGNED NOT NULL,
					CHANGE COLUMN toid to_id SMALLINT (8) UNSIGNED NOT NULL,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER creationtime
					", __FILE__, __LINE__, true);

				$db->query("UPDATE ".db_table("messages")." SET date_created = FROM_UNIXTIME(creationtime)", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("messages")." DROP COLUMN creationtime", __FILE__, __LINE__, true);

			}

		}
		function ext_uninstall($module) {

		}
	}
?>