<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"categories", "users", "news", "format.lib.php"
	);

	Extract (
		URLGetArgs("null/null/action=alpha?id=int&page=page")
	);

	switch ($action) {
		case "edit":
			if ($id) {

				$tpl = new ContentBlock();

				$tpl->insert("BLOCK_CONTENT", "news/admin.edit.tpl");

				$q = $db->query("
					SELECT
						id, author_id, icon, category_id, title, introduction, content,
						date_created, page_reads, source, status, allow_comments
					FROM ".db_table("news")." WHERE id = '{$id}'
				");

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					saneHTML($row, "content,introduction");

					format::htmlFilter($row["content"], $row["author_id"]);
					format::htmlFilter($row["introduction"], $row["author_id"]);

					$tpl->setArray ($row);

					$actions = new tplButtonBox();
						$actions->add(mklink("index.php/module=admin/base=news", _l("L_NEWS"), "news.png"));
					$actions = $actions->make();

					$tpl->setArray (
						Array (
							"BLOCK_TITLE"		=> _l("L_NEWS"),
							"BLOCK_SUBTITLE"	=> _l("L_EDIT"),
							"BLOCK_ICON"		=> mkIcon("news", 16),
							"ACTION"			=> "edit",
							"ACTIONS"			=> $actions,
							"RETURN"			=> "index.php/module=admin/base=news"
						)
					);
					$mcBuff = $tpl->make();
				}
			}
		break;
		case "compose":

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "news/admin.compose.tpl");

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=news", _l("L_NEWS"), "news.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_NEWS"),
					"BLOCK_ICON"		=> mkIcon("news.png", 16),
					"ACTION"			=> "create",
					"CATEGORY_ID"		=> 0,
					"STATUS"			=> 1,
					"ALLOW_COMMENTS"	=> 1,
					"ICON"				=> "news.png",
					"TITLE"				=> "",
					"CONTENT"			=> "",
					"INTRODUCTION"		=> "",
					"ACTIONS"			=> $actions,
					"SOURCE"			=> "",
					"RETURN"			=> "index.php/module=admin/base=news"
				)
			);

			$mcBuff = $tpl->make();
		break;
		default:

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "news/admin.default.tpl");

			// pages for news only (submissions will always be showed)
			$pager = $db->pager (
				"SELECT id FROM ".db_table("news")." WHERE status <= '1'",
				"index.php/module=admin/base=news?page=%p", $page, conf::getkey("news", "items_per_admin_page")
			);

			// querying for news only (submissions will always be showed)
			$q = $db->query ("
				SELECT id, author_id, category_id, icon, title, introduction,
				date_created, page_reads, status
				FROM ".db_table("news")." WHERE status <= 1
				ORDER BY status ASC, date_created DESC {$pager["sql"]}
			", __FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {

				saneHTML($row, "introduction");

				$actions = new tplButtonBox();
					$actions->add(mklink("index.php/module=admin/base=news/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
					$actions->add(mklink("modules/news/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));

				switch ($row["status"]) {
					case 0: case 2:
						$actions->add(mklink("modules/news/main.act.php?action=publish&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_PUBLISH"), "ok.png"));
					break;
				}

				if ($row["status"] == 0)
					$row["title"] .= " ("._l("L_DRAFT").")";

				$row["ACTIONS"] = $actions->make();

				$tpl->setArray($row, ($row["status"] == 2) ? "SUBMISSION" : "NEWS");
				$tpl->saveBlock(($row["status"] == 2) ? "SUBMISSION" : "NEWS");
			}


			// querying for all submissions
			$q = $db->query ("
				SELECT id, author_id, category_id, icon, title, introduction,
				date_created, page_reads, status
				FROM ".db_table("news")." WHERE status = 2
				ORDER BY date_created DESC
			", __FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {

				saneHTML($row, "introduction");

				$actions = new tplButtonBox();
					$actions->add(mklink("index.php/module=admin/base=news/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
					$actions->add(mklink("modules/news/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$actions->add(mklink("modules/news/main.act.php?action=publish&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_PUBLISH"), "ok.png"));
				$row["ACTIONS"] = $actions->make();

				$tpl->setArray($row, "SUBMISSION");
				$tpl->saveBlock("SUBMISSION");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=news/action=compose", _l("L_COMPOSE"), "new.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_NEWS"),
					"BLOCK_ICON"		=> mkIcon("news.png", 16),
					"ACTIONS"			=> $actions,
					"PAGER"				=> $pager["html"]
				)
			);
			$mcBuff = $tpl->make();
		break;
	}
?>