<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"format.lib.php", "news"
	);

	require_once GEKKO_SOURCE_DIR."lib/auth.inc.php";

	varImport("action", "id", "return");

	switch ($action) {
		case "create":
			if (is_admin() || gauth(conf::getkey("news", "auth_submit"))) {

				varImport("icon", "status", "category_id", "title", "introduction",
				"content", "allow_comments", "source", "tags");

				if (!is_admin()) {
					// antiflood
					$AccessTable->load_rule (
						$AccessTable->set_generic_rule("news-user-submit", "post"),
						"E_ANTI_FLOOD"
					);
				}

				varRequire("category_id", "title", "content");

				editorApplyFixes($content);
				editorApplyFixes($introduction);

				if (!$introduction)
					$introduction = mkIntro($content);

				$item_id = $db->findFreeId("news");

				categories::tagUpdate("news", $item_id, $tags, array($title, $content, $introduction));

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("news")."
					(
						id,
						author_id,
						category_id,
						icon,
						title,
						introduction,
						content,
						date_created,
						page_reads,
						source,
						status,
						allow_comments
					)
						VALUES
					(
						'{$item_id}',
						'{$USER["id"]}',
						'{$category_id}',
						'{$icon}',
						'{$title}',
						'{$introduction}',
						'{$content}',
 						'".time2date()."',
						'0',
						'{$source}',
						'".(is_admin() ? $status : 2)."',
						'{$allow_comments}'
					)
				", __FILE__, __LINE__);

				slog(is_admin() ? "news: posted '$title'" : "news: submitted '$title' to revision", "actions", 1);

			} else {
				abort(accessDenied());
			}
		break;
	}

	if (is_admin()) {
		switch ($action) {
			case "delete":
				varRequire("id");

				execWithEach($id, "news::deleteItem");
			break;
			case "publish":
				varRequire("id");

				$q = $db->query("SELECT status FROM ".db_table("news")."
				WHERE id = '{$id}' AND status = '0' OR status = '2' ", __FILE__, __LINE__);

				// updating time if this entry was a draft or if it was submitted by an user
				$update = $db->numRows($q);

				$db->query("UPDATE ".db_table("news")." SET
				status = '1' ".($upddate ? ", date_created = '".time()."'" : "")."
				WHERE id = '{$id}'", __FILE__, __LINE__);
			break;
			case "edit":

				varImport("id", "icon", "status", "category_id", "title", "introduction", "content",
				"allow_comments", "source", "tags");

				varRequire("id", "category_id", "title", "content");

				editorApplyFixes($content);
				editorApplyFixes($introduction);

				if (!$introduction)
					$introduction = mkIntro($content);

				// if this entry was a draft we need to update creation time
				$ptime = false;
				$q = $db->query("SELECT status FROM ".db_table("news")." WHERE id = '{$id}'");
				$row = $db->fetchRow($q);

				if (!$row["status"])
					$ptime = true;

				categories::tagUpdate("news", $id, $tags, array($title, $content, $introduction));

				$db->query("
					UPDATE ".db_table("news")." SET
						category_id = '{$category_id}',
						icon = '{$icon}',
						title = '{$title}',
						introduction = '{$introduction}',
						content = '{$content}',
						status = '{$status}',
						".($ptime ? "date_created = '".time2date()."',": "")."
						allow_comments = '{$allow_comments}'
					WHERE id = '{$id}'
				", __FILE__, __LINE__);

				slog("news: entry '$id' was updated", "actions", 1);

			break;
		}
	}

	redirect($return);

	db_exit();
?>