<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"categories", "comments", "users", "news", "feeder.lib.php"
	);

	Extract (
		URLGetArgs("null/action=alpha/type=string?id=int&page=page&date=date&category=string")
	);

	switch ($action) {
		case "submit":
			if (gauth(conf::getKey("news", "auth_submit"))) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "news/main.submit.tpl");

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"		=> _l("L_NEWS"),
						"BLOCK_SUBTITLE"	=> _l("L_COMPOSE"),
						"ICON"				=> "news.png",
						"ALLOW_COMMENTS"	=> true,
						"STATUS"			=> 2,
						"CATEGORY_ID"		=> 0,
						"TITLE"				=> "",
						"INTRODUCTION"		=> "",
						"CONTENT"			=> "",
						"SOURCE"			=> "",
						"TITLE"				=> "",
						"ACTION"			=> "create",
						"RETURN"			=> "index.php/module=news?message=".rawurlencode(_l("L_SUBMISSION_THANKS"))."&type=info"
					)
				);

				$mcBuff = $tpl->make();
			} else {
				$mcBuff = accessDenied();
			}
		break;
		case "feed":

			define ("GEKKO_USE_ABSOLUTE_URLS", true);

			if (!$type)
				$type = $category;

			// removing extension
			$type = preg_replace("/\..*/", "", $type);

			$feed = new XMLFeed($type);

			$categorylock = categories::db_categorylock("category_id", $category);

			$q = $db->query ("
			SELECT
					id, author_id, title, introduction, date_created, category_id
			FROM ".db_table("news")." WHERE status = '1' AND ($categorylock)
			ORDER BY date_created DESC LIMIT 30
			", __FILE__, __LINE__);

			if ($db->numRows($q)) {
				while ($row = $db->fetchRow($q)) {

					format::style($row["introduction"], $row["author_id"]);

					$row["DESCRIPTION"] = $row["introduction"];
					$row["CATEGORY"] = cacheFunc("categories::getCategory", $row["category_id"], true);
					$row["LINK"] = urlEvalPrototype("index.php/module=news/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}");
					$row["COMMENTS"] = urlEvalPrototype("index.php/module=news/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}");

					$feed->addItem($row);
				}

				abort($feed->serve($type));
			} else {
				header("Location: index.php");
				shutdown();
			}
		break;
		case "view":
			if ($id) {

				$tpl = new ContentBlock();
				$tpl->load("news/main.view.tpl");

				// updating reads counter
				$q = $db->query("UPDATE ".db_table("news")."
					SET page_reads = page_reads + 1 WHERE id = '{$id}'", __FILE__, __LINE__);

				if ($db->affectedRows($q)) {

					$q = $db->query("
						SELECT
						id, author_id, category_id, icon, title, content, date_created, source, page_reads, allow_comments
						FROM ".db_table("news")." WHERE status = '1' AND id='{$id}'
					", __FILE__, __LINE__);

					$row = $db->fetchRow($q);

					if (categories::auth($row["category_id"])) {

						saneHTML($row, "content");

						$row["ENTRY_LINK"] = null;

						format::style($row["content"], $row["author_id"]);

						$tpl->setArray($row);

						$mcBuff = $tpl->make();

						pageSetTitle($row["title"]);

					} else {

						$mcBuff = accessDenied();

					}
				}

			}
		break;
		default:

			$datelock = db_datelock("date_created", $date);

			$categorylock = categories::db_categorylock("category_id", $category);

			$tpl = new ContentBlock();

			$tpl->load("news/main.default.tpl");

			$pager = $db->pager (
				"SELECT id FROM ".db_table("news")." WHERE status = '1'
				AND ($datelock) AND ($categorylock)",
				"index.php/module=news?".($category ? "&category=".urlTitleEncode($category)."":"")."&page=%p",
				$page, conf::getkey("news", "items_per_page")
			);

			$q = $db->query ("
			SELECT
				id, author_id, category_id, icon, title, introduction,
				date_created, page_reads, allow_comments
			FROM ".db_table("news")."
			WHERE status = '1' AND ($datelock) AND ($categorylock)
			ORDER BY date_created DESC {$pager["sql"]}
			", __FILE__, __LINE__);

			if ($db->numRows($q)) {

				while ($row = $db->fetchRow($q)) {

					saneHTML($row, "introduction");

					$row["ENTRY_LINK"] = urlevalprototype("index.php/module=news/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}");

					format::style($row["introduction"], $row["author_id"]);

					$row["BLOCK_ICON"] = mkIcon($row["icon"], 16);
					$row["BLOCK_TITLE"]	= $row["title"];

					$tpl->setArray ($row, "ENTRY");
					$tpl->saveBlock("ENTRY");
				}

				$tpl->setArray (
					Array (
						"PAGER" => $pager["html"]
					)
				);

				$mcBuff = $tpl->make();

				// inserting some useful HTML tags in main template
				pageSetMarkContent("HEAD", '<link rel="alternate" type="application/rss+xml" title="'._l("C_SITE.TITLE").'" href="'.urlEvalPrototype("index.php/module=news/action=feed/type=rss.xml", true, false).'">');
				pageSetMarkContent("FOOTER", mkFeederButtons(urlEvalPrototype("index.php/module=news/action=feed/type=%s", true, false)));
			}
		break;

	}
?>