<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"categories"
	);

	Class News {
		function createItemLink($id, $only_url = false, $custom_url = null) {

			$db =& $GLOBALS["db"];

			$cat_lock = categories::db_categorylock("category_id");

			$q = $db->query("SELECT icon, title FROM ".db_table("news")."
			WHERE id='{$id}' AND {$cat_lock}",
			__FILE__, __LINE__, true);

			if ($db->numRows($q)) {
				$row = $db->fetchRow($q);
				if ($only_url) {
					return urlEvalPrototype("index.php/module=news/action=view/title=".urlTitleEncode($row["title"])."?id=$id");
				} else {
					return mkicon($row["icon"], 16)." ".mklink($custom_url ? $custom_url :"index.php/module=news/action=view/title=".urlTitleEncode($row["title"])."?id=$id", $row["title"]);
				}
			}
			return false;
		}
		function proccessSearch($query_id, $limit = -1) {
			$db =& $GLOBALS["db"];

			$data = Array();

			for ($i = 0; ($limit < 0 || $i < $limit) && $row = $db->fetchRow($query_id); $i++) {

				$row["title"] = mklink("index.php/module=news/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}", $row["title"]);
				$row["description"] = $row["content"];

				if (gauth("news")) {
					$row["actions"] = new tplButtonBox();
						$row["actions"]->add(mklink("index.php/module=admin/base=news/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
						$row["actions"]->add(mklink("modules/news/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$row["actions"] = $row["actions"]->make();
				}

				$data[] = $row;
			}
			return $data;
		}
		/**
		* deleteItem(item_id)
		*/
		function deleteItem($id) {
			LoadLib ("comments");

			// deleting comments
			Comments::deleteItems("news", $id);

			slog("news: deleted news entry '$id'", "actions", 1);

			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("news")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}
		/**
		* itemSetStatus(item_id, status);
		*/
		function itemSetStatus($id, $status) {
			return $GLOBALS["db"]->query ("UPDATE ".db_table("news")." SET status = '{$status}' WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* getPossibleStatus();
		* @returns: Possible status codes.
		*/
		function getPossibleStatus() {
			return Array(_l("L_DRAFT"), _l("L_PUBLISHED"), _l("L_WAITING"));
		}
		/**
		* prepareBlockForDisplay([sql_result_row]);
		* @returns: HTML formatted item to be displayed inside a block.
		*/
		function prepareBlockForDisplay(&$row) {
			saneHTML($row, "introduction");
			if (isset($row["introduction"])) {
				return ''
					.'<small class="date">'.dateformat($row["date_created"]).'</small>'
 					.'<h4><a href="'.urlEvalPrototype("index.php/module=news/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}").'">'
					.mkicon($row["icon"], 16).' '.$row["title"].'</a></h4>'
					.mkintro($row["introduction"], 80)
					.'<small style="display:block; text-align: right;">'.users::mkUserLink($row["author_id"]).'</small>';
			} else {
				return '<b><a title="'.dateformat($row["date_created"]).'" href="'.urlEvalPrototype("index.php/module=news/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}").'">'
					.mkicon($row["icon"], 16).' '.$row["title"].'</a></b>'
					.'<small style="display: block; text-align: right">'.users::mkUserLink($row["author_id"]).'</small>';
			}
		}

		function allowComment($thread) {
			// Check Function Comments::allowComment();
			$db =& $GLOBALS["db"];
			$q = $db->query("SELECT id FROM ".db_table("news")."
			WHERE id = '{$thread}' AND allow_comments = '1' AND status = '1'",
			__FILE__, __LINE__, true);
			return $db->numRows($q) ? true : false;
		}
	}
?>