<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class gekkoModule_News {
		function create_menu() {
			return false;
		}
		function configure() {
			conf::getKey("news", "auth_submit", "*", "s");
			conf::getKey("news", "items_per_page", 8, "i");
			conf::getKey("news", "items_per_admin_page", 15, "i");
			conf::getKey("news", "allow_user_comments", 1, "b");
		}
		function install() {
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("news")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				category_id SMALLINT (5) UNSIGNED NOT NULL,
				icon VARCHAR (64),
				title VARCHAR (128),
				introduction TEXT,
				content TEXT,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP(19),
				page_reads MEDIUMINT (8) UNSIGNED NOT NULL default 0,
				source VARCHAR (255),
				status TINYINT (1) UNSIGNED NOT NULL default 1,
				allow_comments ENUM('0','1') NOT NULL default '1'
			)
			",__FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["news"], "news", "*", $GLOBALS["cgdb"]["news"]);

		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("news"),__FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {

			$db =& $GLOBALS["db"];

			if (Packages::checkVersion("0.5.8", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("news")."
				CHANGE COLUMN reads pagereads MEDIUMINT (8) UNSIGNED NOT NULL default 0,
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
			if (packages::checkVersion("0.6.4", $provided_v) < 0) {

				$db->query("ALTER TABLE ".db_table("news")."
					CHANGE COLUMN userid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
					CHANGE COLUMN category category_id SMALLINT (5) UNSIGNED NOT NULL,
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER creationtime,
					ADD COLUMN date_modified TIMESTAMP(19) AFTER date_created,
					CHANGE COLUMN allowcomments allow_comments ENUM('0','1') NOT NULL default '1',
					CHANGE COLUMN pagereads page_reads MEDIUMINT (8) UNSIGNED NOT NULL default 0
				", __FILE__, __LINE__, true);

				$db->query("UPDATE ".db_table("news")." SET date_created = FROM_UNIXTIME(creationtime)", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("news")."
					DROP COLUMN creationtime
				", __FILE__, __LINE__, true);

			}
		}
		function ext_uninstall($module) {

		}
	}

?>