<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"core.lib.php", "format.lib.php", "pages"
	);

	require_once GEKKO_SOURCE_DIR."lib/auth.inc.php";

	varImport("action", "return", "id");

	if (is_admin()) {
		switch ($action) {
			case "delete":
				execWithEach($id, "Pages::deleteItem");
			break;
			case "publish":
				pages::setItemStatus($id, 1);
			break;
			case "create":

				varImport("title", "status", "category_id", "content", "show_title", "tags");
				varRequire("category_id", "title");

				editorApplyFixes($content);

				$q = $db->query("SELECT id FROM ".db_table("page")."
				WHERE title='{$title}'", __FILE__, __LINE__);

				if ($db->numRows($q))
					formInputError("{E_DUPLICATED_ENTRY}", "focus: title");

				$page_id = $db->findFreeId("page");

				categories::tagUpdate("pages", $page_id, $tags, array($title, $content));

				$db->query ("
				INSERT INTO ".db_table("page")."
					(
						id,
						category_id,
						title,
						content,
						author_id,
						date_created,
						editor_id,
						show_title,
						status
					)
						VALUES
					(
						'{$page_id}',
						'{$category_id}',
						'{$title}',
						'{$content}',
						'{$USER["id"]}',
						CURRENT_TIMESTAMP(),
						'{$USER["id"]}',
						'{$show_title}',
						'{$status}'
					)
				", __FILE__, __LINE__);

				slog("pages: date_created page'$title'");

			break;
			case "edit":

				varImport("id", "title", "status", "category_id", "content", "show_title", "tags");

				varRequire("id", "category_id", "title");

				editorApplyFixes($content);

				$q = $db->query("SELECT id FROM ".db_table("page")."
				WHERE title='{$title}' AND id != '$id'", __FILE__, __LINE__);

				if ($db->numRows($q))
					formInputError("{E_DUPLICATED_ENTRY}", "focus: title");

				categories::tagUpdate("pages", $id, $tags, array($title, $content));

				$db->query("
					UPDATE ".db_table("page")." SET
						category_id = '{$category_id}',
						title = '{$title}',
						content = '{$content}',
						editor_id = '{$USER["id"]}',
						show_title = '{$show_title}',
						status = '{$status}'
					WHERE id = '{$id}'
				", __FILE__, __LINE__);

				slog("pages: date_modified page '$title' (id='$id')");
			break;
			default:
				abort(_l("L_UNDEFINED_ACTION"));
			break;
		}
	}

	redirect($return);

	db_exit();
?>