<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"chart.lib.php", "categories", "polls"
	);

	Extract (
		URLGetArgs ("null/null/action=alpha?id=int&page=page")
	);

	switch ($action) {
		case "edit":
			if ($id) {
				$tpl = new ContentBlock();

				$tpl->insert("BLOCK_CONTENT", "polls/admin.edit.tpl");

				$q = $db->query("SELECT id, category_id, title, question, author_id, date_created, date_expires,
				status, allow_comments FROM ".db_table("polls")."
				WHERE id = '{$id}'", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					// getting options
					$p = $db->query("SELECT description, votes FROM ".db_table("polls_option")."
					WHERE poll_id = '{$row["id"]}' ORDER BY order_id ASC", __FILE__, __LINE__, true);

					$opt = Array();
					while ($opt[] = $db->fetchRow($p));

					for ($i = 0; $i < 10; $i++) {
						$tpl->setArray (
							Array (
								"INDEX"			=> $i,
								"DESCRIPTION"	=> isset($opt[$i]["description"]) ?  $opt[$i]["description"] : "",
								"VOTES"			=> isset($opt[$i]["votes"]) ? $opt[$i]["votes"] : 0
							),
						"OPTION"
						);
						$tpl->saveBlock("OPTION");
					}

					$actions = new tplButtonBox();
						$actions->add(mklink("index.php/module=admin/base=polls", _l("L_POLLS"), "polls.png"));
						$actions->add(mklink("index.php/module=admin/base=polls/action=create", _l("L_CREATE"), "new.png"));
					$actions = $actions->make();

					$tpl->setArray ($row);
					$tpl->setArray (
						Array (
							"BLOCK_ICON"		=> mkIcon("polls.png", 16),
							"BLOCK_TITLE"		=> _l("L_POLLS"),
							"ACTION"			=> $action,
							"ACTIONS"			=> $actions,
							"RETURN"			=> "index.php/module=admin/base=polls",
							"CHANGE_EXPIRATION"	=> 1
						)
					);
					$mcBuff = $tpl->make();
				} else {
					$mcBuff = "";
				}
			}
		break;
		case "create":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "polls/admin.$action.tpl");

			// cleaning option values
			for ($i = 0; $i < 10; $i++) {
				$tpl->setArray (
					Array (
						"INDEX"			=> $i,
						"DESCRIPTION"	=> "",
						"VOTES"			=> "0"
					),
					"OPTION"
				);
				$tpl->saveBlock("OPTION");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=polls", _l("L_POLLS"), "polls.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_ICON"		=> mkIcon("polls.png", 16),
					"BLOCK_TITLE"		=> _l("L_POLLS"),
					"BLOCK_SUBTITLE"	=> _l("L_CREATE_POLL"),
					"TITLE"				=> "",
					"ACTION"			=> $action,
					"ACTIONS"			=> $actions,
					"CATEGORY_ID"		=> 0,
					"STATUS"			=> 1,
					"DATE_EXPIRES"		=> 0,
					"ALLOW_COMMENTS"	=> true,
					"QUESTION"			=> "",
					"RETURN"			=> "index.php/module=admin/base=polls"
				)
			);
			$mcBuff = $tpl->make();

		break;
		default:

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "polls/admin.default.tpl");

			$pager = $db->pager (
				"SELECT id FROM ".db_table("polls")."
				ORDER BY date_expires DESC, title ASC",
				"index.php/module=admin/base=polls?page=%p", $page, conf::getkey("polls", "items_per_admin_page")
			);

			$q = $db->query("SELECT id, category_id, title, question,
			author_id, date_created, date_expires, status, allow_comments
			FROM ".db_table("polls")." ORDER BY date_expires DESC, title ASC {$pager["sql"]}",
			__FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {

				$row["CHART"] = polls::createChart($row["id"], "80%");

				$actions = new tplButtonBox();
					$actions->add(mklink("modules/polls/main.act.php?action=create_block&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_CREATE_BLOCK"), "blocks.png"));
					$actions->add(mklink("index.php/module=admin/base=polls/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
					$actions->add(mklink("modules/polls/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					if (!$row["status"]) {
						$actions->add(mklink("modules/polls/main.act.php?action=enable&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_ENABLE"), "ok.png"));
					}
				$row["ACTIONS"] = $actions->make();

				$tpl->setArray ($row, "POLL");
				$tpl->saveBlock("POLL");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=polls/action=create", _l("L_CREATE"), "new.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_ICON"		=> mkIcon("polls.png", 16),
					"BLOCK_TITLE"		=> _l("L_POLLS"),
					"PAGER"				=> $pager["html"],
					"ACTIONS"			=> $actions
				)
			);
			$mcBuff = $tpl->make();

		break;
	}

?>