<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib ("polls", "categories", "format.lib.php");

	require_once GEKKO_SOURCE_DIR."lib/auth.inc.php";

	varImport("action", "id", "return");

	switch ($action) {
		case "vote":

			varImport("option");

			varRequire("option");

			$q = $db->query("SELECT poll_id FROM ".db_table("polls_option")."
			WHERE id='{$option}' AND description <> ''", __FILE__, __LINE__);

			if ($db->numRows($q)) {

				$row = $db->fetchRow($q);

				$q = $db->query("SELECT id, category_id FROM ".db_table("polls")."
				WHERE
				(date_expires = '0000-00-00 00:00:00' OR date_expires > '".time2date()."')
				AND id='{$row["poll_id"]}' AND status='1'", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					if (polls::alreadyVoted($row["id"]) || conf::getkey("polls", "limit_votes", 0, 'b')) {
						$return = "index.php/module=polls/action=view?id={$id}&message=".rawurlencode(_l("L_ALREADY_VOTED")."&type=info");
					} else {
						if (categories::auth($row["category_id"])) {

							polls::registerVote($row["id"]);

							$db->query("UPDATE ".db_table("polls_option")." SET
							votes = votes + 1
							WHERE id = '{$option}'",
							__FILE__, __LINE__);

							slog("polls: voted for option '$option' in poll '{$row["id"]}'");

						} else {
							abort(accessDenied());
						}
					}
				}
			}
		break;
	}

	if (is_admin()) {
		switch ($action) {
			case "create_block":

				varRequire("id");

				LoadLib ("blocks");

				$block_id = Blocks::simpleCreate(_l("L_POLL"), "", "polls/show.php", "id={$id}", "polls.png");

				$return = "index.php/module=admin/base=blocks/action=edit?id={$block_id}";

			break;
			case "delete":

				varRequire("id");

				execWithEach($id, "polls::deleteItem");

			break;
			case "edit":

				varImport("id", "title", "question", "category_id", "description", "votes",
				"status", "date_expires", "allow_comments", "change_expiration");

				varRequire("id", "title", "question", "category_id", "description", "votes");

				polls::validateOptions($description);

				editorApplyFixes($question);

				$db->query("UPDATE ".db_table("polls")." SET
					title = '{$title}',
					question = '{$question}',
					category_id = '{$category_id}',
					".($change_expiration ? "date_expires = '".polls::calculateExpirationDate($date_expires)."'," : '')."
					allow_comments = '{$allow_comments}',
					status = '{$status}'
				WHERE id = '{$id}'", __FILE__, __LINE__);

				polls::regenerateOptions($id, $description, $votes);

				slog("polls: modified poll '$id'", "actions", 1);
			break;
			case "create":

				varImport("title", "question", "category_id", "description", "votes",
				"status", "date_expires", "allow_comments");

				varRequire("title", "question", "category_id", "description", "votes");

				polls::validateOptions($description);

				editorApplyFixes($question);

				$date_expires = polls::calculateExpirationDate($date_expires);

				$db->query("
					INSERT INTO ".db_table("polls")." (
						id,
						category_id,
						title,
						question,
						author_id,
						date_created,
						date_expires,
						status,
						allow_comments
					) VALUES (
						'".($id = $db->findFreeId("polls"))."',
						'{$category_id}',
						'{$title}',
						'{$question}',
						'{$USER["id"]}',
						CURRENT_TIMESTAMP(),
						'{$date_expires}',
						'{$status}',
						'{$allow_comments}'
					)
				");

				polls::regenerateOptions($id, $description, $votes);

				slog("polls: date_created poll '$title'", "actions", 1);
			break;
		}
	}

	redirect($return);

	db_exit();
?>