<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"chart.lib.php", "comments", "categories", "polls"
	);

	Extract (
		URLGetArgs ("null/action=alpha?id=int&page=page")
	);

	$categorylock = categories::db_categorylock("category_id");

	switch ($action) {
		case "view":

			if ($id) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "polls/main.view.tpl");

				$q = $db->query("SELECT id, category_id, title, question,
				author_id, date_created, date_expires, status, allow_comments
				FROM ".db_table("polls")."
				WHERE id = '{$id}' AND status = '1'
				AND (date_expires = '0000-00-00 00:00:00' OR date_expires > CURRENT_TIMESTAMP()) AND {$categorylock}
				",__FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					// is this poll expired?
					$expired = polls::isExpired($row["date_expires"]);

					if ($expired || polls::alreadyVoted($id)) {
						// inserting chart instead of form
						$tpl->set("POLL_CONTENT", polls::createChart($row["id"], "220px"));

					} else {

						// inserting vote form
						$tpl->insert("POLL_CONTENT", "polls/_vote.form.tpl");

						$p = $db->query("SELECT id, description, votes FROM ".db_table("polls_option")."
						WHERE poll_id = '{$row["id"]}' ORDER BY order_id ASC", __FILE__, __LINE__, true);

						while ($opt = $db->fetchRow($p)) {
							$tpl->setArray($opt, "OPTION");
							$tpl->saveBlock("OPTION");
						}
					}

					$tpl->setArray ($row);

					$tpl->setArray (
						Array (
							"BLOCK_ICON"		=> mkIcon("polls.png", 16),
							"BLOCK_TITLE"		=> _l("L_POLLS"),
							"RETURN"			=> ""
						)
					);
					$mcBuff = $tpl->make();

				} else {
					$mcBuff = "";
				}
			}
		break;
		default:
			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "polls/main.default.tpl");

			$pager = $db->pager (
				"SELECT id FROM ".db_table("polls")."
				WHERE status = '1' AND
				(date_expires = '0000-00-00 00:00:00' OR date_expires < CURRENT_TIMESTAMP()) AND {$categorylock}",
				"index.php/module=polls?page=%p", $page, conf::getkey("polls", "items_per_page")
			);

			$q = $db->query("SELECT id, category_id, title, question,
			author_id, date_created, date_expires, status, allow_comments
			FROM ".db_table("polls")."
			WHERE status = '1' AND
			(date_expires = '0000-00-00 00:00:00' OR date_expires > CURRENT_TIMESTAMP()) AND {$categorylock}
			ORDER BY category_id ASC, title ASC {$pager["sql"]}",
			__FILE__, __LINE__);

			if ($db->numRows($q)) {

				while ($row = $db->fetchRow($q)) {

					$row["ITEM_URL"] = urlevalprototype("index.php/module=polls/action=view/title=".urlTitleEncode($row["title"])."?id={$row["id"]}");
					$tpl->setArray($row, "POLL");
					$tpl->saveBlock("POLL");
				}

				$tpl->setArray (
					Array (
						"BLOCK_ICON"		=> mkIcon("polls.png", 16),
						"BLOCK_TITLE"		=> _l("L_POLLS"),
						"PAGER"				=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();
			}
		break;
	}
?>