<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	define ("GEKKO_POLLS_VOTE_INTERVAL", 3600*6);

	Class Polls {
		function proccessSearch($query_id, $limit = -1) {
			$db =& $GLOBALS["db"];

			$data = Array();

			for ($i = 0; ($limit < 0 || $i < $limit) && $row = $db->fetchRow($query_id); $i++) {
				$row["title"] = _l("L_POLL").": ".mklink("index.php/module=polls/action=view?id={$row["id"]}", $row["title"]);
				$row["description"] = $row["question"];
				$row["icon"] = "polls.png";

				if (gauth("polls")) {
					$row["actions"] = new tplButtonBox();
						$row["actions"]->add(mklink("index.php/module=admin/base=polls/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"));
						$row["actions"]->add(mklink("modules/polls/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
					$row["actions"] = $row["actions"]->make();
				}

				$data[] = $row;
			}

			return $data;
		}
		function validateOptions(&$opt) {
			$opts = 0;
			while (list($i) = each($opt))
				$opts += trim($opt[$i]) ? 1 : 0;
			if ($opts < 2)
				formInputError("{E_INSUFFICIENT_DATA}", "focus: option");
			return true;
		}
		function regenerateOptions($id, $description, $votes) {
			$db =& $GLOBALS["db"];

			$db->query("DELETE FROM ".db_table("polls_option")."
			WHERE poll_id='{$id}'", __FILE__, __LINE__);

			reset($description);
			$j = 1;
			while (list($i) = each($description)) {
				if ($description[$i]) {
					$db->query("INSERT INTO ".db_table("polls_option")." (
						id,
						poll_id,
						description,
						votes,
						order_id
					) VALUES (
						'".$db->findFreeId("polls_option")."',
						'{$id}',
						'".$description[$i]."',
						'".$votes[$i]."',
						'".$j++."'
					)");
				}
			}
		}
		function prepareBlockForDisplay(&$row) {

			$db =& $GLOBALS["db"];

			$tpl = new ContentBlock();

			$tpl->load("polls/_view.inc.tpl");

			// is this poll expired?
			$expired = polls::isExpired($row["date_expires"]);

			if ($expired || polls::alreadyVoted($row["id"])) {

				// inserting chart instead of form
				$tpl->set("CONTENT", polls::createChart($row["id"], "90%"));

			} else {

				// inserting vote form
				$tpl->insert("CONTENT", "polls/_vote.form.tpl");

				$p = $db->query("SELECT id, description, votes FROM ".db_table("polls_option")."
				WHERE poll_id = '{$row["id"]}' ORDER BY order_id ASC", __FILE__, __LINE__, true);

				while ($opt = $db->fetchRow($p)) {
					$tpl->setArray($opt, "OPTION");
					$tpl->saveBlock("OPTION");
				}
			}

			$tpl->setArray (
				Array (
					"RETURN"	=> "",
					"ID"		=> $row["id"]
				)
			);

			$tpl->setArray($row);

			return $tpl->make();
		}
		function calculateExpirationDate($expiration_code) {
			$vigency = polls::getVigencyCode($expiration_code);
			return ($vigency > 0) ? time2date(time()+$vigency) : '0000-00-00 00:00:00';
		}
		function isExpired($date_expires) {
			if (substr($date_expires, 0, 4) == '0000')
				return false;
			return $date_expires ? (time() > date2time($date_expires)) : false;
		}
		function getVigencyCode($i = false) {
			$vigency = Array (
				0 => _l("L_NEVER_EXPIRES"),
				1 => _l("L_A_HOUR"),
				2 => _l("L_A_DAY"),
				3 => _l("L_A_WEEK"),
				4 => _l("L_A_MONTH"),
				5 => _l("L_A_YEAR")
			);
			if ($i !== false) {
				// returns scalar value for its respective human readable vigency
				switch ($i) {
					case 0: return 0; break;
					case 1: return 3600; break;
					case 2: return 86400; break;
					case 3: return 86400*7; break;
					case 4: return 86400*30; break;
					case 5: return 86400*365; break;
				}
			}
			return $vigency;
		}
		function registerVote($id) {
			return $GLOBALS["AccessTable"]->check("polls-vote-$id",GEKKO_POLLS_VOTE_INTERVAL, 1);
		}
		function alreadyVoted($id) {
			return $GLOBALS["AccessTable"]->check("polls-vote-$id",GEKKO_POLLS_VOTE_INTERVAL, 1, false, true);
		}
		function createChart($id, $size = "80%") {

			$db =& $GLOBALS["db"];

			LoadLib ("chart.lib.php");

			$p = $db->query("SELECT description, votes FROM ".db_table("polls_option")."
			WHERE poll_id = '$id' ORDER BY order_id ASC", __FILE__, __LINE__, true);

			// creating chart
			unset($chart);
			while ($opt = $db->fetchRow($p)) {
				if (!isset($chart))
					$chart = new Chart($size, true);
				$item_id = $chart->createItem($opt["description"]);
				$chart->addItemNode($item_id, $opt["votes"]);
			}
			$chart = isset($chart) ? $chart->make() : "";

			return $chart;
		}

		function allowComment($thread) {
			$db =& $GLOBALS["db"];
			// Check Function Comments::allowComment();
			$q = $db->query("SELECT id FROM ".db_table("polls")." WHERE id = '{$thread}'
			AND allow_comments = '1' AND status = '1'",
			__FILE__, __LINE__, true);
			return $db->numRows($q) ? true : false;
		}
		/**
		* deleteItem(item id);
		* @returns: boolean
		*
		*/
		// deletes a poll and all associated content with it
		function deleteItem($id) {

			$db =& $GLOBALS["db"];

			// loading 'comments' api
			LoadLib("comments");

			// deleting comments
			Comments::deleteItems("polls", $id);

			slog("polls: deleted poll '$id'", "actions", 1);

			return $db->query ("DELETE FROM ".db_table("polls")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

	}
?>