<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class gekkoModule_Polls {
		function create_menu() {
			return false;
		}
		function configure() {
			conf::getKey("polls", "items_per_page", 8, "i");
			conf::getKey("polls", "items_per_admin_page", 3, "i");
			conf::getKey("polls", "allow_user_comments", 1, "b");
		}
		function install() {

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("polls_option")." (
				id MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				poll_id MEDIUMINT (8) UNSIGNED NOT NULL,
				description VARCHAR (128),
				votes SMALLINT (5) UNSIGNED NOT NULL,
				order_id TINYINT UNSIGNED NOT NULL
			)", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("polls")." (
				id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				category_id SMALLINT (5) UNSIGNED NOT NULL,
				title VARCHAR (64),
				question VARCHAR (255),
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP(19),
				date_expires DATETIME NOT NULL default '0000-00-00 00:00:00',
				status ENUM('0','1') NOT NULL default '1',
				allow_comments ENUM('0','1') NOT NULL default '1'
			)
			",__FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["polls"], "polls", "*", $GLOBALS["cgdb"]["polls"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("polls"),__FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("polls_option"),__FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {

			$db =& $GLOBALS["db"];

			if (Packages::checkVersion("0.5.8", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("polls")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1',
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__, true);
			}
			if (Packages::checkVersion("0.5.9", $provided_v) <= 0) {

				// this table was introduced in this version and needs to be filled
				$GLOBALS["db"]->query("
				CREATE TABLE ".db_table("polls_option")." (
					id MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
					pollid MEDIUMINT (8) UNSIGNED NOT NULL,
					description VARCHAR (128),
					votes SMALLINT (5) UNSIGNED NOT NULL,
					orderid TINYINT UNSIGNED NOT NULL
				)
				", __FILE__, __LINE__, true);


				$vote_fields = $desc_fields = Array();
				// dummy fields
				for ($i = 1; $i <= 10; $i++) {
					$vote_fields[] = "optvotes_$i";
					$desc_fields[] = "optdescr_$i";
				}

				$q = $db->query("SELECT id, category, title, description, authorid, created, expires,
				status, allowcomments, ".implode(",", $vote_fields).", ".implode(",", $desc_fields)." FROM ".db_table("polls"), __FILE__, __LINE__, true);

				while ($row = $db->fetchRow($q)) {
					$order = 1;
					for ($i = 1; $i <= 10; $i++) {
						if ($row["optdescr_$i"] || $row["optvotes_$i"]) {
							$db->query("INSERT INTO ".db_table("polls_option")." (pollid, description,
							votes, orderid) VALUES ('{$row["id"]}', '".addslashes($row["optdescr_$i"])."', '{$row["optvotes_$i"]}',
							'{$order}')", __FILE__, __LINE__, true);
							$order++;
						}
					}
				}

				// alter table
				$db->query("ALTER TABLE ".db_table("polls")."
				DROP COLUMN ".implode(", DROP COLUMN ", $vote_fields).",
				DROP COLUMN ".implode(", DROP COLUMN ", $desc_fields)."",
				__FILE__, __LINE__, true);
			}

			if (Packages::checkVersion("0.5.10", $provided_v) < 0) {
				// alter table
				$db->query("ALTER TABLE ".db_table("polls")."
				CHANGE description question VARCHAR (128) NOT NULL,
				CHANGE id id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT",
				__FILE__, __LINE__, true);
			}
			if (packages::checkVersion("0.6.6", $provided_v) < 0) {

				$db->query("ALTER TABLE ".db_table("polls_option")."
					CHANGE COLUMN pollid poll_id MEDIUMINT (8) UNSIGNED NOT NULL,
					CHANGE COLUMN orderid order_id TINYINT UNSIGNED NOT NULL
				", __FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("polls")."
					CHANGE COLUMN category category_id SMALLINT (5) UNSIGNED NOT NULL,
					CHANGE COLUMN authorid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
					CHANGE COLUMN allowcomments allow_comments ENUM('0','1') NOT NULL default '1',
					ADD COLUMN date_created DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER created,
					ADD COLUMN date_modified TIMESTAMP(19) AFTER date_created,
					ADD COLUMN date_expires DATETIME NOT NULL default '0000-00-00 00:00:00' AFTER date_modified
				", __FILE__, __LINE__);

				$db->query("UPDATE ".db_table("polls")." SET date_created = FROM_UNIXTIME(created), date_expires = FROM_UNIXTIME(expires)", __FILE__, __LINE__, true);

				$db->query("ALTER TABLE ".db_table("polls")."
					DROP COLUMN created,
					DROP COLUMN expires
				", __FILE__, __LINE__, true);
			}
		}
		function ext_uninstall($module) {

		}
	}
?>