<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"chart.lib.php", "statistics"
	);

	Extract (
		URLGetArgs("null/null/action=alpha/type=alpha?date=date&page=int&order=alpha")
	);

	switch ($action) {
		case "logs":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "statistics/admin.logs.tpl");

			if (!$type || ($type != "referer"))
				$type = "request";

			if ($order != "url" && $order != "last_ip" && $order != "date_access")
				$order = "counter";

			$pager = $db->pager (
				"SELECT counter FROM ".db_table("stats_uri_logs")."
				WHERE type = '{$type}'",
				"index.php/module=admin/base=statistics/action=logs/type=$type?page=%p",
				$page, conf::getkey("statistics", "displayed_entries", 100, 'i')
			);

			$q = $db->query("SELECT counter, url, last_ip, date_access
			FROM ".db_table("stats_uri_logs")."
			WHERE type = '{$type}' ORDER BY $order DESC {$pager["sql"]}", __FILE__, __LINE__, true);

			while ($row = $db->fetchRow($q)) {
				saneHTML($row);
				$tpl->setArray($row, "URL");
				$tpl->saveBlock("URL");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=statistics", _l("L_STATISTICS"), "statistics.png"));
				$actions->add(mklink("modules/statistics/main.act.php?action=reset_logs&type=$type&auth={C_AUTH_STR}", _l("L_RESET_ENTRIES"), "reset.png", true));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_STATISTICS"),
					"BLOCK_ICON"		=> mkIcon("statistics.png", 16),
					"ACTIONS"			=> $actions,
					"ORDER"				=> $order,
					"TYPE"				=> $type,
					"PAGER"				=> $pager["html"]
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "detailed":

			if ($date) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "statistics/admin.detailed.tpl");

				if (preg_match("/^\d*-\d*-\d*$/", $date)) {

					$q = $db->query("SELECT *
					FROM ".db_table("stats_day")."
					WHERE day = '{$date}' AND (variant='0' OR variant = '1') ORDER BY variant ASC",
					__FILE__, __LINE__);

					$tpl->set("CHART_TITLE", strftime("%A %e, %B %Y", date2time($date)));
					$tpl->set("CHART", statistics::mkDayChart($q, "300px"));

				} elseif (preg_match("/^\d*-\d*$/", $date)) {

					$q = $db->query("SELECT day, total, uniquehits FROM ".db_table("stats_visits")."
					WHERE day >= '$date-1' AND day <= '".date("Y-m-t", date2time($date))."'
					ORDER BY day ASC",
					__FILE__, __LINE__);

					$tpl->set("CHART_TITLE", strftime("%B %Y", date2time($date)));
					$tpl->set("CHART", statistics::mkIntervalChart($q, "300px"));

				} elseif (preg_match("/^\d*$/", $date)) {

					$q = $db->query("SELECT day, total, uniquehits FROM ".db_table("stats_visits")."
					WHERE day >= '$date-1-1' AND day <= '".date("Y-12-t", date2time($date))."'
					ORDER BY day ASC",
					__FILE__, __LINE__);

					$tpl->set("CHART_TITLE", strftime("%Y", date2time($date)));
					$tpl->set("CHART", statistics::mkYearChart($q, "300px"));

				}

				$actions = new tplButtonBox();
					$actions->add(mklink("index.php/module=admin/base=statistics", _l("L_STATISTICS"), "statistics.png"));
				$actions = $actions->make();

				$tpl->setArray (
					Array (
						"BLOCK_TITLE"		=> _l("L_DETAILED_STATISTICS"),
						"BLOCK_ICON"		=> mkIcon("statistics.png", 16),
						"ACTIONS"			=> $actions
					)
				);

				$mcBuff = $tpl->make();
			}
		break;
		case "keywords":
			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "statistics/admin.keywords.tpl");

			$pager = $db->pager (
				"SELECT counter FROM ".db_table("stats_search_keywords")."",
				"index.php/module=admin/base=statistics/action=keywords?page=%p", $page,
				conf::getkey("statistics", "displayed_entries", 100, 'i')
			);

			$q = $db->query("SELECT
				keywords, engine, counter, url, date_access, referer
			FROM
			".db_table("stats_search_keywords")."
			ORDER BY counter DESC {$pager["sql"]}",
			__FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {
				saneHTML($row);
				$tpl->setArray($row, "KEYWORD");
				$tpl->saveBlock("KEYWORD");
			}

			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=statistics", _l("L_STATISTICS"), "statistics.png"));
				$actions->add(mklink("modules/statistics/main.act.php?action=reset_keywords&auth={C_AUTH_STR}", _l("L_RESET_ENTRIES"), "reset.png", true));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_STATISTICS"),
					"BLOCK_ICON"		=> mkIcon("statistics.png", 16),
					"ACTIONS"			=> $actions,
					"PAGER"				=> $pager["html"]
				)
			);

			$mcBuff = $tpl->make();
		break;
		default:

			$tpl = new ContentBlock();

			$chart = Array();

			$tpl->insert("BLOCK_CONTENT", "statistics/admin.default.tpl");

			// today
			$q = $db->query("SELECT *
			FROM ".db_table("stats_day")."
			WHERE day = CURRENT_DATE() AND (variant='0' OR variant = '1')
			ORDER BY variant ASC",
			__FILE__, __LINE__);

			$chart["today"] = statistics::mkDayChart($q, "200px");

			// yesterday
			$q = $db->query("SELECT *
			FROM ".db_table("stats_day")."
			WHERE day = DATE_ADD(CURRENT_DATE(), INTERVAL -1 DAY) AND (variant='0' OR variant = '1')
			ORDER BY variant ASC",
			__FILE__, __LINE__);

			$chart["yesterday"] = statistics::mkDayChart($q, "200px");

			// month
			$q = $db->query ("SELECT day, uniquehits, total FROM ".db_table("stats_visits")."
			WHERE day >= '".date("Y-m-0")."' AND day <= '".date("Y-m-t")."' ORDER BY day ASC",
			__FILE__, __LINE__);

			$chart["month"] = statistics::mkIntervalChart($q, "200px");

			// past week
			$q = $db->query ("SELECT day, uniquehits, total FROM ".db_table("stats_visits")."
			WHERE day >= DATE_ADD(CURRENT_DATE(), INTERVAL -7 DAY) AND day <= CURRENT_DATE()
			ORDER BY day DESC",
			__FILE__, __LINE__);

			$chart["past_week"] = statistics::mkIntervalChart($q, "200px");

			// year
			$q = $db->query("SELECT day, total, uniquehits FROM ".db_table("stats_visits")."
			WHERE day >= '".date("Y")."-01-01' AND day <= '".date("Y-12-t", time())."'
			ORDER BY day ASC",
			__FILE__, __LINE__);

			$chart["year"] = statistics::mkYearChart($q, "200px");

			$tpl->setArray (
				Array (
					"TOTAL_VISITORS"	=> 0,
					"TOTAL_CLICKS"		=> 0
				)
			);

			// counting total unique visitors and clicks
			$q = $db->query ("SELECT variable, counter FROM ".db_table("stats_counter")."
			WHERE type = 'total' AND
			(variable = 'unique-visits' OR variable = 'clicks')",
			__FILE__, __LINE__);

			while ($row = $db->fetchRow($q)) {
				switch ($row["variable"]) {
					case "unique-visits":
						$tpl->set("TOTAL_VISITORS", $row["counter"]);
					break;
					case "clicks":
						$tpl->set("TOTAL_CLICKS", $row["counter"]);
					break;
				}
			}
			// actions buttons
			$actions = new tplButtonBox();
				$actions->add(mklink("index.php/module=admin/base=statistics/action=logs/type=referer", _l("L_REFERER_LOGS"), "files/html.png"));
				$actions->add(mklink("index.php/module=admin/base=statistics/action=logs/type=request", _l("L_URL_REQUEST_LOGS"), "files/html.png"));
				$actions->add(mklink("index.php/module=admin/base=statistics/action=keywords", _l("L_KEYWORDS"), "search.png"));
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"					=> _l("L_STATISTICS"),
					"BLOCK_ICON"					=> mkIcon("statistics.png", 16),
					"MONTH_STATISTICS_CHART"		=> $chart["month"],
					"TODAY_STATISTICS_CHART"		=> $chart["today"],
					"YESTERDAY_STATISTICS_CHART"	=> $chart["yesterday"],
					"PAST_WEEK_STATISTICS_CHART"	=> $chart["past_week"],
					"YEAR_STATISTICS_CHART"			=> $chart["year"],
					"ACTIONS"						=> $actions
				)
			);

			$mcBuff = $tpl->make();

		break;
	}

?>