<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title><![CDATA[Who's online?]]></title>
			<description>Shows a list of users who are online.</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
	</blockscript>
	<%%>
	*/

	LoadLib (
		"users"
	);

	$db =& $GLOBALS["db"];
	
	$return = Array();

	// seconds since last action to consider a user as being online
	$alive = 300;

	// updating last action time "$-UID" is an ID for logged-in users, "?-" is for guests
	// yes, this is just another "because I said" convention.
	accessControl::check(is_user() ? "$-".$GLOBALS["USER"]["id"] : "?-", $alive, -1);

	// querying for logged-in users
	$q = $db->query("SELECT accesstype FROM ".db_table("control")."
	WHERE SUBSTRING(accesstype, 1, 2) = '$-' AND time > ".(time()-$alive)."",
	__FILE__, __LINE__, true);

	$userlist = Array();
	while ($row = $db->fetchRow($q)) {
		$uid = substr($row["accesstype"], 2);
		if (!isset($userlist[$uid])) {
			$userlist[$uid] = true;
		}
	}
	// usernames
	while (list($uid) = each($userlist))
		$return[] = cacheFunc("users::mkUserLink", $uid);

	// how many guests are online?
	$q = $GLOBALS["db"]->query("SELECT ip FROM ".db_table("control")."
	WHERE accesstype = '?-' AND time > ".(time()-$alive)."", __FILE__, __LINE__, true);

	$guests = Array();
	while ($row = $GLOBALS["db"]->fetchRow($q)) {
		if (!isset($guests[$row["ip"]])) {
			$guests[$row["ip"]] = true;
		}
	}

	// commas are important for humans too :)
	$return = implode(", ", $return);

	if (($g = count($guests)) > 0) {
		$return .= ($return ? " ": "")."($g "._l("L_GUESTS").")";
	}
?>