<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	define ("GEKKO_STATS_UNKNOWN_ID", "_unknown");

	// user-agent ids from some browser
	$GLOBALS["stats_user_agent"] = Array (
		"firefox"		=> "Mozilla Firefox",
		"mozilla"		=> "Mozilla",
		"netscape"		=> "Netscape",
		"msie"			=> "Microsoft Internet Explorer",
		"opera"			=> "Opera",
		"konqueror"		=> "Konqueror",
		"lynx"			=> "Lynx",
		"curl"			=> "cURL",
		"w3m"			=> "w3m",
		"wget"			=> "wget",
		"galeon"		=> "Galeon",
		"google"		=> "Google (bot)",
		"msnbot"		=> "MSN (bot)",
		"yahoo"			=> "Yahoo! slurp (bot)",
		GEKKO_STATS_UNKNOWN_ID		=> _l("L_UNKNOWN")
	);

	// user-agent ids for some oses
	$GLOBALS["stats_os"] = Array (
		"win"		=> "Windows",
		"linux"		=> "Linux",
		"mac"		=> "Mac",
		"freebsd"	=> "FreeBSD",
		"netbsd"	=> "NetBSD",
		"sunos"		=> "SunOS",
		"irix"		=> "Irix",
		"beos"		=> "BeOS",
		"os/2"		=> "OS/2",
		GEKKO_STATS_UNKNOWN_ID	=> _l("L_UNKNOWN")
	);

	class Statistics {

		/**
		* increaseCounter(type, variable_name, [increment]);
		* Increments a variable of a determined type
		*/
		function increaseCounter($type, $variable, $increment = 1) {
			$db =& $GLOBALS["db"];

			// updating counter if exists
			$q = $db->query("UPDATE ".db_table("stats_counter")."
			SET counter = counter + {$increment}
			WHERE type = '{$type}' AND variable = '{$variable}'",
			__FILE__, __LINE__, true);

			if (!$db->affectedRows($q)) {
				// counter doesn't exists
				$db->query("INSERT INTO ".db_table("stats_counter")." (type, variable, counter)
				VALUES ('{$type}', '{$variable}', {$increment})",
				__FILE__, __LINE__, true);
			}
			return true;
		}

		function mkIntervalChart(&$q, $size = "180px") {
			$db =& $GLOBALS["db"];

			$chart = new Chart("180px");

			while ($row = $db->fetchRow($q)) {
				$date = strftime("%A %e", date2time($row["day"]));
				$item_id = $chart->createItem (mkLink ("index.php/module=admin/base=statistics/action=detailed?date={$row["day"]}", $date));
				$chart->addItemNode($item_id, $row["uniquehits"], _l("L_UNIQUE_VISITORS"));
				$chart->addItemNode($item_id, $row["total"], _l("L_TOTAL_HITS"));
			}

			return $chart->make();
		}
		function mkYearChart(&$q, $size = "180px") {
			$db =& $GLOBALS["db"];

			$chart = new Chart("180px");
			if ($db->numRows($q)) {
				$buff = Array();
				while ($row = $db->fetchRow($q)) {
					$id = date("Ym", date2time($row["day"]));
					if (!isset($buff[$id])) {
						$buff[$id] = $row;
					} else {
						$buff[$id]["total"] += $row["total"];
						$buff[$id]["uniquehits"] += $row["uniquehits"];
					}
				}
				foreach ($buff as $row) {
					$item_id = $chart->createItem (
						mkLink (
							"index.php/module=admin/base=statistics/action=detailed?date=".date("Y-m", date2time($row["day"])),
							strftime("%B", date2time($row["day"]))
						)
					);
					$chart->addItemNode($item_id, $row["uniquehits"], _l("L_UNIQUE_VISITORS"));
					$chart->addItemNode($item_id, $row["total"], _l("L_TOTAL_HITS"));
				}
			}
			return $chart->make();
		}
		function mkDayChart(&$q, $size = "180px") {
			$db =& $GLOBALS["db"];

			$hour_fields = Array();
			for ($i = 0; $i < 24; $i++)
				$hour_fields[] = 'h'.str_pad($i, 2, '0', STR_PAD_LEFT);

			$chart = new Chart();
			$item = Array();

			while ($row = $db->fetchRow($q)) {
				foreach ($hour_fields as $hour) {
					if (!isset($item[$hour]))
						$item[$hour] = $chart->createItem(substr($hour, 1));
					$chart->addItemNode($item[$hour], $row[$hour], $row["variant"] ? _l("L_TOTAL_HITS") : _l("L_UNIQUE_VISITORS"));
				}
			}
			return $chart->make();
		}

		/**
		* checkCounter(type, variable_name);
		* @returns: The current value of specified counter
		*/
		function checkCounter($type, $variable) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT counter FROM ".db_table("stats_counter")."
			WHERE type = '{$type}' AND variable = '{$variable}'");

			if ($db->numRows($q)) {
				$row = $db->fetchRow($q);
				return $row["counter"];
			}

			return 0;
		}
	}

?>